=== modified file 'NEWS'
--- NEWS	2008-04-06 08:36:27 +0000
+++ NEWS	2008-04-21 16:05:33 +0000
@@ -12,11 +12,59 @@
 
   CHANGES:
 
+    * Broader support of GNU Emacs mail clients. Set
+      ``mail_client=emacsclient`` in your bazaar.conf and ``send`` will pop the
+      bundle in a mail buffer according to the value of ``mail-user-agent``
+      variable. (Xavier Maillard)
+
+  FEATURES:
+
+  IMPROVEMENTS:
+
+  BUGFIXES:
+
+    * Avoid muttering every time a child update does not cause a progress bar
+      update. (John Arbash Meinel, #213771)
+
+    * Set SO_REUSEADDR on server sockets of ``bzr serve`` to avoid problems
+      rebinding the socket when starting the server a second time.
+      (John Arbash Meinel, Martin Pool, #164288)
+
+    * Severe performance degradation in fetching from knit repositories to
+      knits and packs due to parsing the entire revisions.kndx on every graph
+      walk iteration fixed by using the Repository.get_graph API.  There was
+      another regression in knit => knit fetching which re-read the index for
+      every revision each side had in common.
+      (Robert Collins, John Arbash Meinel)
+
+    * When logging the changes to a particular file, there was a bug if there
+      were ghosts in the revision ancestry. (John Arbash Meinel, #209948)
+
+  DOCUMENTATION:
+
+    * Document outlining strategies for TortoiseBzr. (Mark Hammond)
+
+  TESTING:
+
+  INTERNALS:
+
+    * Implement xml8 serializer.  (Aaron Bentley)
+
+  API BREAKS:
+
+
+bzr 1.4rc1 2008-04-11
+---------------------
+
    * bzr main script cannot be imported (Benjamin Peterson)
 
    * On Linux bzr additionally looks for plugins in arch-independent site
      directory. (Toshio Kuratomi)
- 
+
+   * The ``set_rh`` branch hook is now deprecated. Please migrate
+     any plugins using this hook to use an alternative, e.g.
+     ``post_change_branch_tip``. (Ian Clatworthy)
+
    * When a plugin cannot be loaded as the file path is not a valid
      python module name bzr will now strip a ``bzr_`` prefix from the
      front of the suggested name, as many plugins (e.g. bzr-svn)
@@ -32,13 +80,27 @@
 
   FEATURES:
 
-    * Added mail-mode GNU Emacs mail package as a mail_client.
-      (Xavier Maillard, Bojan Nikolic)
-
     * Added start_commit hook for mutable trees. (Jelmer Vernooij, #186422)
 
+    * ``status`` now accepts ``--no-pending`` to show the status without
+      listing pending merges, which speeds up the command a lot on large
+      histories.  (James Westby, #202830)
+
+    * New ``post_change_branch_tip`` hook that is called after the
+      branch tip is moved but while the branch is still write-locked.
+      See the User Reference for signature details.
+      (Ian Clatworthy, James Henstridge)
+
+    * Reconfigure can convert a branch to be standalone or to use a shared
+      repository.  (Aaron Bentley)
+
   IMPROVEMENTS:
 
+    * The smart protocol now has support for setting branches' revision info
+      directly.  This should make operations like push slightly faster, and is a
+      step towards server-side hooks.  The new request method name is
+      ``Branch.set_last_revision_info``.  (Andrew Bennetts)
+
     * ``bzr commit --fixes`` now recognises "gnome" as a tag by default.
       (James Westby, Andrew Cowie)
 
@@ -95,10 +157,27 @@
     * Don't ask for a password if there is no real terminal.
       (Alexander Belchenko, #69851)
 
+    * Fix a bug causing a ValueError crash in ``parse_line_delta_iter`` when
+      fetching revisions from a knit to pack repository or vice versa using
+      bzr:// (including over http or ssh).
+      (#208418, Andrew Bennetts, Martin Pool, Robert Collins)
+
+    * Fixed ``_get_line`` in ``bzrlib.smart.medium``, which was buggy.  Also
+      fixed ``_get_bytes`` in the same module to use the push back buffer.
+      These bugs had no known impact in normal use, but were problematic for
+      developers working on the code, and were likely to cause real bugs sooner
+      or later.  (Andrew Bennetts)
+
     * Implement handling of basename parameter for DefaultMail.  (James Westby)
 
+    * Incompatibility with Paramiko versions newer than 1.7.2 was fixed.
+      (Andrew Bennetts, #213425)
+
     * Launchpad locations (lp: URLs) can be pulled.  (Aaron Bentley, #181945)
 
+    * Merges that add files to deleted root directories complete.  They
+      do create conflicts.  (Aaron Bentley, #210092)
+
     * vsftp's return ``550 RNFR command failed.`` supported.
       (Marcus Trautwig, #129786)
 
@@ -110,16 +189,28 @@
 
     * Reduced the evangelism in the User Guide. (Ian Clatworthy)
 
+    * Added Integrating with Bazaar document for developers (Martin Albisetti)
+
   API BREAKS:
 
     * Attempting to pull data from a ghost aware repository (e.g. knits) into a
       non-ghost aware repository such as weaves will now fail if there are
       ghosts.  (Robert Collins)
 
+    * ``KnitVersionedFile`` no longer accepts an ``access_mode`` parameter, and
+      now requires the ``index`` and ``access_method`` parameters to be
+      supplied. A compatible shim has been kept in the new function
+      ``knit.make_file_knit``. (Robert Collins)
+
     * Log formatters must now provide log_revision instead of show and
       show_merge_revno methods. The latter had been deprecated since the 0.17
       release. (James Westby)
 
+    * ``LoopbackSFTP`` is now called ``SocketAsChannelAdapter``.
+      (Andrew Bennetts)
+
+    * ``osutils.backup_file`` is removed. (Alexander Belchenko)
+
     * ``Repository.get_revision_graph`` is deprecated, with no replacement
       method. The method was size(history) and not desirable. (Robert Collins)
 
@@ -129,6 +220,27 @@
     * ``Transport.get_shared_medium`` is deprecated.  Use
       ``Transport.get_smart_medium`` instead.  (Andrew Bennetts)
 
+    * ``VersionedFile`` factories now accept a get_scope parameter rather
+      than using a call to ``transaction_finished``, allowing the removal of
+      the fixed list of versioned files per repository. (Robert Collins)
+
+    * ``VersionedFile.annotate_iter`` is deprecated. While in principle this
+      allowed lower memory use, all users of annotations wanted full file 
+      annotations, and there is no storage format suitable for incremental
+      line-by-line annotation. (Robert Collins)
+
+    * ``VersionedFile.clone_text`` is deprecated. This performance optimisation
+      is no longer used - reading the content of a file that is undergoing a
+      file level merge to identical state on two branches is rare enough, and
+      not expensive enough to special case. (Robert Collins)
+
+    * ``VersionedFile.clear_cache`` and ``enable_cache`` are deprecated.
+      These methods added significant complexity to the ``VersionedFile``
+      implementation, but were only used for optimising fetches from knits - 
+      which can be done from outside the knit layer, or via a caching
+      decorator. As knits are not the default format, the complexity is no
+      longer worth paying. (Robert Collins)
+
     * ``VersionedFile.create_empty`` is removed. This method presupposed a
       sensible mapping to a transport for individual files, but pack backed
       versioned files have no such mapping. (Robert Collins)
@@ -143,9 +255,23 @@
     * ``VersionedFile.get_parents`` is deprecated, please use
       ``VersionedFile.get_parent_map``. (Robert Collins)
 
+    * ``VersionedFile.get_sha1`` is deprecated, please use
+      ``VersionedFile.get_sha1s``. (Robert Collins)
+
     * ``VersionedFile.has_ghost`` is now deprecated, as it is both expensive
       and unused outside of a single test. (Robert Collins)
 
+    * ``VersionedFile.iter_parents`` is now deprecated in favour of
+      ``get_parent_map`` which can be used to instantiate a Graph on a
+      VersionedFile. (Robert Collins)
+
+    * ``VersionedFileStore`` no longer uses the transaction parameter given
+      to most methods; amongst other things this means that the
+      get_weave_or_empty method no longer guarantees errors on a missing weave
+      in a readonly transaction, and no longer caches versioned file instances
+      which reduces memory pressure (but requires more careful management by
+      callers to preserve performance). (Robert Collins)
+
   TESTING:
 
     * New -Dselftest_debug flag disables clearing of the debug flags during
@@ -164,12 +290,37 @@
       IDs and tests present in the list but not found in the actual test suite.
       (Vincent Ladeuil)
 
+    * Slightly more concise format for the selftest progress bar, so there's
+      more space to show the test name.  (Martin Pool) ::
+
+        [2500/10884, 1fail, 3miss in 1m29s] test_revisionnamespaces.TestRev
+
     * The test suite takes much less memory to run, and is a bit faster.  This
       is done by clearing most attributes of TestCases after running them, if
       they succeeded.  (Andrew Bennetts)
 
   INTERNALS:
 
+    * Added ``_build_client_protocol`` to ``_SmartClient``.  (Andrew Bennetts)
+
+    * Added basic infrastructure for automatic plugin suggestion.
+      (Martin Albisetti)
+
+    * If a ``LockableFiles`` object is not explicitly unlocked (for example
+      because of a missing ``try/finally`` block, it will give a warning but
+      not automatically unlock itself.  (Previously they did.)  This
+      sometimes caused knock-on errors if for example the network connection
+      had already failed, and should not be relied upon by code. 
+      (Martin Pool, #109520)
+
+    * The ``read_response_tuple`` method of ``SmartClientRequestProtocol*``
+      classes will now raise ``UnknownSmartMethod`` when appropriate, so that
+      callers don't need to try distinguish unknown request errors from other
+      errors.  (Andrew Bennetts)
+
+    * ``set_make_working_trees`` is now implemented provided on all repository
+      implementations (Aaron Bentley)
+
     * ``VersionedFile`` now has a new method ``get_parent_map`` which, like
       ``Graph.get_parent_map`` returns a dict of key:parents. (Robert Collins)
 

=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2008-03-14 11:52:07 +0000
+++ bzrlib/annotate.py	2008-04-09 00:34:54 +0000
@@ -113,7 +113,7 @@
 def _annotations(repo, file_id, rev_id):
     """Return the list of (origin,text) for a revision of a file in a repository."""
     w = repo.weave_store.get_weave(file_id, repo.get_transaction())
-    return list(w.annotate_iter(rev_id))
+    return w.annotate(rev_id)
 
 
 def _annotate_file(branch, rev_id, file_id):

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2008-04-03 00:23:41 +0000
+++ bzrlib/branch.py	2008-04-11 04:51:44 +0000
@@ -1025,12 +1025,48 @@
         # local is the local branch or None, master is the target branch,
         # and an empty branch recieves new_revno of 0, new_revid of None.
         self['post_uncommit'] = []
+        # Introduced in 1.4
+        # Invoked after the tip of a branch changes.
+        # the api signature is
+        # (params) where params is a ChangeBranchTipParams with the members
+        # (branch, old_revno, new_revno, old_revid, new_revid)
+        self['post_change_branch_tip'] = []
 
 
 # install the default hooks into the Branch class.
 Branch.hooks = BranchHooks()
 
 
+class ChangeBranchTipParams(object):
+    """Object holding parameters passed to *_change_branch_tip hooks.
+
+    There are 5 fields that hooks may wish to access:
+
+    :ivar branch: the branch being changed
+    :ivar old_revno: revision number before the change
+    :ivar new_revno: revision number after the change
+    :ivar old_revid: revision id before the change
+    :ivar new_revid: revision id after the change
+
+    The revid fields are strings. The revno fields are integers.
+    """
+
+    def __init__(self, branch, old_revno, new_revno, old_revid, new_revid):
+        """Create a group of ChangeBranchTip parameters.
+
+        :param branch: The branch being changed.
+        :param old_revno: Revision number before the change.
+        :param new_revno: Revision number after the change.
+        :param old_revid: Tip revision id before the change.
+        :param new_revid: Tip revision id after the change.
+        """
+        self.branch = branch
+        self.old_revno = old_revno
+        self.new_revno = new_revno
+        self.old_revid = old_revid
+        self.new_revid = new_revid
+
+
 class BzrBranchFormat4(BranchFormat):
     """Bzr branch format 4.
 
@@ -1383,6 +1419,17 @@
         for hook in Branch.hooks['set_rh']:
             hook(self, rev_history)
 
+    def _run_post_change_branch_tip_hooks(self, old_revno, old_revid):
+        """Run the post_change_branch_tip hooks."""
+        hooks = Branch.hooks['post_change_branch_tip']
+        if not hooks:
+            return
+        new_revno, new_revid = self.last_revision_info()
+        params = ChangeBranchTipParams(
+            self, old_revno, new_revno, old_revid, new_revid)
+        for hook in hooks:
+            hook(params)
+ 
     @needs_write_lock
     def set_last_revision_info(self, revno, revision_id):
         """Set the last revision of this branch.
@@ -1396,9 +1443,11 @@
         be permitted.
         """
         revision_id = _mod_revision.ensure_null(revision_id)
+        old_revno, old_revid = self.last_revision_info()
         history = self._lefthand_history(revision_id)
         assert len(history) == revno, '%d != %d' % (len(history), revno)
         self.set_revision_history(history)
+        self._run_post_change_branch_tip_hooks(old_revno, old_revid)
 
     def _gen_revision_history(self):
         history = self.control_files.get('revision-history').read().split('\n')
@@ -1854,11 +1903,13 @@
     @needs_write_lock
     def set_last_revision_info(self, revno, revision_id):
         revision_id = _mod_revision.ensure_null(revision_id)
+        old_revno, old_revid = self.last_revision_info()
         if self._get_append_revisions_only():
             self._check_history_violation(revision_id)
         self._write_last_revision_info(revno, revision_id)
         self._clear_cached_state()
         self._last_revision_info_cache = revno, revision_id
+        self._run_post_change_branch_tip_hooks(old_revno, old_revid)
 
     def _check_history_violation(self, revision_id):
         last_revision = _mod_revision.ensure_null(self.last_revision())
@@ -2149,7 +2200,7 @@
         new_branch = format.open(branch.bzrdir, _found=True)
 
         # Copy source data into target
-        new_branch.set_last_revision_info(*branch.last_revision_info())
+        new_branch._write_last_revision_info(*branch.last_revision_info())
         new_branch.set_parent(branch.get_parent())
         new_branch.set_bound_location(branch.get_bound_location())
         new_branch.set_push_location(branch.get_push_location())

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2008-04-04 00:43:07 +0000
+++ bzrlib/builtins.py	2008-04-12 06:46:35 +0000
@@ -166,7 +166,9 @@
                      Option('short', help='Use short status indicators.',
                             short_name='S'),
                      Option('versioned', help='Only show versioned files.',
-                            short_name='V')
+                            short_name='V'),
+                     Option('no-pending', help='Don\'t show pending merges.',
+                           ),
                      ]
     aliases = ['st', 'stat']
 
@@ -175,7 +177,7 @@
     
     @display_command
     def run(self, show_ids=False, file_list=None, revision=None, short=False,
-            versioned=False):
+            versioned=False, no_pending=False):
         from bzrlib.status import show_tree_status
 
         if revision and len(revision) > 2:
@@ -186,7 +188,8 @@
             
         show_tree_status(tree, show_ids=show_ids,
                          specific_files=file_list, revision=revision,
-                         to_file=self.outf, short=short, versioned=versioned)
+                         to_file=self.outf, short=short, versioned=versioned,
+                         show_pending=not no_pending)
 
 
 class cmd_cat_revision(Command):
@@ -4433,7 +4436,9 @@
                      tree='Reconfigure to a tree.',
                      checkout='Reconfigure to a checkout.',
                      lightweight_checkout='Reconfigure to a lightweight'
-                     ' checkout.'),
+                     ' checkout.',
+                     standalone='Reconfigure to be standalone.',
+                     use_shared='Reconfigure to use a shared repository.'),
                      Option('bind-to', help='Branch to bind checkout to.',
                             type=str),
                      Option('force',
@@ -4455,6 +4460,10 @@
         elif target_type == 'lightweight-checkout':
             reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
                 directory, bind_to)
+        elif target_type == 'use-shared':
+            reconfiguration = reconfigure.Reconfigure.to_use_shared(directory)
+        elif target_type == 'standalone':
+            reconfiguration = reconfigure.Reconfigure.to_standalone(directory)
         reconfiguration.apply(force)
 
 

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2008-03-28 08:05:51 +0000
+++ bzrlib/bzrdir.py	2008-04-14 08:03:35 +0000
@@ -180,36 +180,31 @@
                                even if one is available.
         """
         transport.ensure_base()
-        result = self._format.initialize_on_transport(transport)
+        result = self.cloning_metadir().initialize_on_transport(transport)
+        repository_policy = None
         try:
             local_repo = self.find_repository()
         except errors.NoRepositoryPresent:
             local_repo = None
         if local_repo:
             # may need to copy content in
-            if force_new_repo:
-                result_repo = local_repo.clone(
-                    result,
-                    revision_id=revision_id)
-                result_repo.set_make_working_trees(local_repo.make_working_trees())
-            else:
-                try:
-                    result_repo = result.find_repository()
-                    # fetch content this dir needs.
-                    result_repo.fetch(local_repo, revision_id=revision_id)
-                except errors.NoRepositoryPresent:
-                    # needed to make one anyway.
-                    result_repo = local_repo.clone(
-                        result,
-                        revision_id=revision_id)
-                    result_repo.set_make_working_trees(local_repo.make_working_trees())
+            repository_policy = result.determine_repository_policy(
+                force_new_repo)
+            make_working_trees = local_repo.make_working_trees()
+            result_repo = repository_policy.acquire_repository(
+                make_working_trees, local_repo.is_shared())
+            result_repo.fetch(local_repo, revision_id=revision_id)
         # 1 if there is a branch present
         #   make sure its content is available in the target repository
         #   clone it.
         try:
-            self.open_branch().clone(result, revision_id=revision_id)
+            local_branch = self.open_branch()
         except errors.NotBranchError:
             pass
+        else:
+            result_branch = local_branch.clone(result, revision_id=revision_id)
+            if repository_policy is not None:
+                repository_policy.configure_branch(result_branch)
         try:
             result_repo = result.find_repository()
         except errors.NoRepositoryPresent:
@@ -356,15 +351,43 @@
         bzrdir._find_or_create_repository(force_new_repo)
         return bzrdir.create_branch()
 
+    def determine_repository_policy(self, force_new_repo=False):
+        """Return an object representing a policy to use.
+
+        This controls whether a new repository is created, or a shared
+        repository used instead.
+        """
+        def repository_policy(found_bzrdir):
+            stop = False
+            # does it have a repository ?
+            try:
+                repository = found_bzrdir.open_repository()
+            except errors.NoRepositoryPresent:
+                repository = None
+            else:
+                if ((found_bzrdir.root_transport.base !=
+                     self.root_transport.base) and not repository.is_shared()):
+                    repository = None
+                else:
+                    stop = True
+            if not stop:
+                return None, False
+            if repository:
+                return UseExistingRepository(repository), True
+            else:
+                return CreateRepository(self), True
+
+        if not force_new_repo:
+            policy = self._find_containing(repository_policy)
+            if policy is not None:
+                return policy
+        return CreateRepository(self)
+
     def _find_or_create_repository(self, force_new_repo):
         """Create a new repository if needed, returning the repository."""
-        if force_new_repo:
-            return self.create_repository()
-        try:
-            return self.find_repository()
-        except errors.NoRepositoryPresent:
-            return self.create_repository()
-        
+        policy = self.determine_repository_policy(force_new_repo)
+        return policy.acquire_repository()
+
     @staticmethod
     def create_branch_convenience(base, force_new_repo=False,
                                   force_new_tree=None, format=None,
@@ -508,6 +531,35 @@
         """
         raise NotImplementedError(self.destroy_workingtree_metadata)
 
+    def _find_containing(self, evaluate):
+        """Find something in a containing control directory.
+
+        This method will scan containing control dirs, until it finds what
+        it is looking for, decides that it will never find it, or runs out
+        of containing control directories to check.
+
+        It is used to implement find_repository and
+        determine_repository_policy.
+
+        :param evaluate: A function returning (value, stop).  If stop is True,
+            the value will be returned.
+        """
+        found_bzrdir = self
+        while True:
+            result, stop = evaluate(found_bzrdir)
+            if stop:
+                return result
+            next_transport = found_bzrdir.root_transport.clone('..')
+            if (found_bzrdir.root_transport.base == next_transport.base):
+                # top of the file system
+                return None
+            # find the next containing bzrdir
+            try:
+                found_bzrdir = BzrDir.open_containing_from_transport(
+                    next_transport)[0]
+            except errors.NotBranchError:
+                return None
+
     def find_repository(self):
         """Find the repository that should be used.
 
@@ -515,35 +567,23 @@
         new branches as well as to hook existing branches up to their
         repository.
         """
-        try:
-            return self.open_repository()
-        except errors.NoRepositoryPresent:
-            pass
-        next_transport = self.root_transport.clone('..')
-        while True:
-            # find the next containing bzrdir
-            try:
-                found_bzrdir = BzrDir.open_containing_from_transport(
-                    next_transport)[0]
-            except errors.NotBranchError:
-                # none found
-                raise errors.NoRepositoryPresent(self)
+        def usable_repository(found_bzrdir):
             # does it have a repository ?
             try:
                 repository = found_bzrdir.open_repository()
             except errors.NoRepositoryPresent:
-                next_transport = found_bzrdir.root_transport.clone('..')
-                if (found_bzrdir.root_transport.base == next_transport.base):
-                    # top of the file system
-                    break
-                else:
-                    continue
-            if ((found_bzrdir.root_transport.base ==
-                 self.root_transport.base) or repository.is_shared()):
-                return repository
+                return None, False
+            if found_bzrdir.root_transport.base == self.root_transport.base:
+                return repository, True
+            elif repository.is_shared():
+                return repository, True
             else:
-                raise errors.NoRepositoryPresent(self)
-        raise errors.NoRepositoryPresent(self)
+                return None, True
+
+        found_repo = self._find_containing(usable_repository)
+        if found_repo is None:
+            raise errors.NoRepositoryPresent(self)
+        return found_repo
 
     def get_branch_reference(self):
         """Return the referenced URL for the branch in this bzrdir.
@@ -1010,6 +1050,10 @@
         """Pre-splitout bzrdirs do not suffer from stale locks."""
         raise NotImplementedError(self.break_lock)
 
+    def cloning_metadir(self):
+        """Produce a metadir suitable for cloning with."""
+        return self._format.__class__()
+
     def clone(self, url, revision_id=None, force_new_repo=False):
         """See BzrDir.clone()."""
         from bzrlib.workingtree import WorkingTreeFormat2
@@ -2609,6 +2653,67 @@
         return output
 
 
+class RepositoryAcquisitionPolicy(object):
+    """Abstract base class for repository acquisition policies.
+
+    A repository acquisition policy decides how a BzrDir acquires a repository
+    for a branch that is being created.  The most basic policy decision is
+    whether to create a new repository or use an existing one.
+    """
+
+    def configure_branch(self, branch):
+        """Apply any configuration data from this policy to the branch.
+
+        Default implementation does nothing.
+        """
+        pass
+
+    def acquire_repository(self, make_working_trees=None, shared=False):
+        """Acquire a repository for this bzrdir.
+
+        Implementations may create a new repository or use a pre-exising
+        repository.
+        :param make_working_trees: If creating a repository, set
+            make_working_trees to this value (if non-None)
+        :param shared: If creating a repository, make it shared if True
+        :return: A repository
+        """
+        raise NotImplemented(RepositoryAcquisitionPolicy.acquire_repository)
+
+
+class CreateRepository(RepositoryAcquisitionPolicy):
+    """A policy of creating a new repository"""
+
+    def __init__(self, bzrdir):
+        RepositoryAcquisitionPolicy.__init__(self)
+        self._bzrdir = bzrdir
+
+    def acquire_repository(self, make_working_trees=None, shared=False):
+        """Implementation of RepositoryAcquisitionPolicy.acquire_repository
+
+        Creates the desired repository in the bzrdir we already have.
+        """
+        repository = self._bzrdir.create_repository(shared=shared)
+        if make_working_trees is not None:
+            repository.set_make_working_trees(make_working_trees)
+        return repository
+
+
+class UseExistingRepository(RepositoryAcquisitionPolicy):
+    """A policy of reusing an existing repository"""
+
+    def __init__(self, repository):
+        RepositoryAcquisitionPolicy.__init__(self)
+        self._repository = repository
+
+    def acquire_repository(self, make_working_trees=None, shared=False):
+        """Implementation of RepositoryAcquisitionPolicy.acquire_repository
+
+        Returns an existing repository to use
+        """
+        return self._repository
+
+
 format_registry = BzrDirFormatRegistry()
 format_registry.register('weave', BzrDirFormat6,
     'Pre-0.8 format.  Slower than knit and does not'

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2008-01-21 05:44:29 +0000
+++ bzrlib/commands.py	2008-04-08 22:56:38 +0000
@@ -43,6 +43,7 @@
     errors,
     option,
     osutils,
+    registry,
     trace,
     win32utils,
     )
@@ -168,6 +169,17 @@
     cmd_obj = ExternalCommand.find_command(cmd_name)
     if cmd_obj:
         return cmd_obj
+
+    # look for plugins that provide this command but aren't installed
+    for provider in command_providers_registry:
+        try:
+            plugin_metadata = provider.plugin_for_command(cmd_name)
+        except errors.NoPluginAvailable:
+            pass
+        else:
+            raise errors.CommandAvailableInPlugin(cmd_name, 
+                                                  plugin_metadata, provider)
+
     raise KeyError
 
 
@@ -883,5 +895,27 @@
             return [cmd]
 
 
+class Provider(object):
+    '''Generic class to be overriden by plugins'''
+
+    def plugin_for_command(self, cmd_name):
+        '''Takes a command and returns the information for that plugin
+        
+        :return: A dictionary with all the available information 
+        for the requested plugin
+        '''
+        raise NotImplementedError
+
+
+class ProvidersRegistry(registry.Registry):
+    '''This registry exists to allow other providers to exist'''
+
+    def __iter__(self):
+        for key, provider in self.iteritems():
+            yield provider
+
+command_providers_registry = ProvidersRegistry()
+
+
 if __name__ == '__main__':
     sys.exit(main(sys.argv))

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2008-03-26 06:21:48 +0000
+++ bzrlib/config.py	2008-04-13 17:38:34 +0000
@@ -151,6 +151,7 @@
             mail_client_class = {
                 None: mail_client.DefaultMail,
                 # Specific clients
+                'emacsclient': mail_client.EmacsMail,
                 'evolution': mail_client.Evolution,
                 'kmail': mail_client.KMail,
                 'mutt': mail_client.Mutt,
@@ -159,7 +160,6 @@
                 'default': mail_client.DefaultMail,
                 'editor': mail_client.Editor,
                 'mapi': mail_client.MAPIClient,
-                'emacs-mailmode': mail_client.EmacsMailMode,
                 'xdg-email': mail_client.XDGEmail,
             }[selected_client]
         except KeyError:
@@ -892,31 +892,19 @@
     """Branch configuration data associated with its contents, not location"""
 
     def __init__(self, branch):
+        transport = branch.control_files._transport
+        self._config = TransportConfig(transport, 'branch.conf')
         self.branch = branch
 
     def _get_parser(self, file=None):
         if file is not None:
             return IniBasedConfig._get_parser(file)
-        return self._get_config()
-
-    def _get_config(self):
-        try:
-            obj = ConfigObj(self.branch.control_files.get('branch.conf'),
-                            encoding='utf-8')
-        except errors.NoSuchFile:
-            obj = ConfigObj(encoding='utf=8')
-        return obj
+        return self._config._get_configobj()
 
     def get_option(self, name, section=None, default=None):
         self.branch.lock_read()
         try:
-            obj = self._get_config()
-            try:
-                if section is not None:
-                    obj = obj[section]
-                result = obj[name]
-            except KeyError:
-                result = default
+            return self._config.get_option(name, section, default)
         finally:
             self.branch.unlock()
         return result
@@ -925,20 +913,7 @@
         """Set a per-branch configuration option"""
         self.branch.lock_write()
         try:
-            cfg_obj = self._get_config()
-            if section is None:
-                obj = cfg_obj
-            else:
-                try:
-                    obj = cfg_obj[section]
-                except KeyError:
-                    cfg_obj[section] = {}
-                    obj = cfg_obj[section]
-            obj[name] = value
-            out_file = StringIO()
-            cfg_obj.write(out_file)
-            out_file.seek(0)
-            self.branch.control_files.put('branch.conf', out_file)
+            self._config.set_option(value, name, section)
         finally:
             self.branch.unlock()
 
@@ -1126,3 +1101,61 @@
 
     def decode_password(self, credentials, encoding):
         return credentials
+
+
+class TransportConfig(object):
+    """A Config that reads/writes a config file on a Transport.
+
+    It is a low-level object that considers config data to be name/value pairs
+    that may be associated with a section.  Assigning meaning to the these
+    values is done at higher levels like TreeConfig.
+    """
+
+    def __init__(self, transport, filename):
+        self._transport = transport
+        self._filename = filename
+
+    def get_option(self, name, section=None, default=None):
+        """Return the value associated with a named option.
+
+        :param name: The name of the value
+        :param section: The section the option is in (if any)
+        :param default: The value to return if the value is not set
+        :return: The value or default value
+        """
+        configobj = self._get_configobj()
+        if section is None:
+            section_obj = configobj
+        else:
+            try:
+                section_obj = configobj[section]
+            except KeyError:
+                return default
+        return section_obj.get(name, default)
+
+    def set_option(self, value, name, section=None):
+        """Set the value associated with a named option.
+
+        :param value: The value to set
+        :param name: The name of the value to set
+        :param section: The section the option is in (if any)
+        """
+        configobj = self._get_configobj()
+        if section is None:
+            configobj[name] = value
+        else:
+            configobj.setdefault(section, {})[name] = value
+        self._set_configobj(configobj)
+
+    def _get_configobj(self):
+        try:
+            return ConfigObj(self._transport.get(self._filename),
+                             encoding='utf-8')
+        except errors.NoSuchFile:
+            return ConfigObj(encoding='utf-8')
+
+    def _set_configobj(self, configobj):
+        out_file = StringIO()
+        configobj.write(out_file)
+        out_file.seek(0)
+        self._transport.put_file(self._filename, out_file)

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2008-04-06 16:54:35 +0000
+++ bzrlib/errors.py	2008-04-24 04:58:42 +0000
@@ -1476,6 +1476,14 @@
         self.details = details
 
 
+class UnknownSmartMethod(InternalBzrError):
+
+    _fmt = "The server does not recognise the '%(verb)s' request."
+
+    def __init__(self, verb):
+        self.verb = verb
+
+
 # A set of semi-meaningful errors which can be thrown
 class TransportNotPossible(TransportError):
 
@@ -2066,6 +2074,11 @@
         self.path = path
 
 
+class RepositoryUpgradeRequired(UpgradeRequired):
+
+    _fmt = "To use this feature you must upgrade your repository at %(path)s."
+
+
 class LocalRequiresBoundBranch(BzrError):
 
     _fmt = "Cannot perform local-only commits on unbound branches."
@@ -2569,6 +2582,16 @@
     _fmt = "'%(display_url)s' is already a lightweight checkout."
 
 
+class AlreadyUsingShared(BzrDirError):
+
+    _fmt = "'%(display_url)s' is already using a shared repository."
+
+
+class AlreadyStandalone(BzrDirError):
+
+    _fmt = "'%(display_url)s' is already standalone."
+
+
 class ReconfigurationNotSupported(BzrDirError):
 
     _fmt = "Requested reconfiguration of '%(display_url)s' is not supported."
@@ -2627,6 +2650,31 @@
         self.timezone = timezone
 
 
+class CommandAvailableInPlugin(StandardError):
+    
+    internal_error = False
+
+    def __init__(self, cmd_name, plugin_metadata, provider):
+        
+        self.plugin_metadata = plugin_metadata
+        self.cmd_name = cmd_name
+        self.provider = provider
+
+    def __str__(self):
+
+        _fmt = ('"%s" is not a standard bzr command. \n' 
+                'However, the following official plugin provides this command: %s\n'
+                'You can install it by going to: %s'
+                % (self.cmd_name, self.plugin_metadata['name'], 
+                    self.plugin_metadata['url']))
+
+        return _fmt
+
+
+class NoPluginAvailable(BzrError):
+    pass    
+
+
 class NotATerminal(BzrError):
 
     _fmt = 'Unable to ask for a password without real terminal.'

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2008-03-19 04:39:04 +0000
+++ bzrlib/fetch.py	2008-04-09 20:13:46 +0000
@@ -27,8 +27,7 @@
 stored, so that if a revision is present we can totally recreate it.
 However, we can't know what files are included in a revision until we
 read its inventory.  So we query the inventory store of the source for
-the ids we need, and then pull those ids and finally actually join
-the inventories.
+the ids we need, and then pull those ids and then return to the inventories.
 """
 
 import bzrlib
@@ -168,13 +167,12 @@
                 if knit_kind == "file":
                     self._fetch_weave_text(file_id, revisions)
                 elif knit_kind == "inventory":
-                    # XXX:
-                    # Once we've processed all the files, then we generate the root
-                    # texts (if necessary), then we process the inventory.  It's a
-                    # bit distasteful to have knit_kind == "inventory" mean this,
-                    # perhaps it should happen on the first non-"file" knit, in case
-                    # it's not always inventory?
+                    # Before we process the inventory we generate the root
+                    # texts (if necessary) so that the inventories references
+                    # will be valid.
                     self._generate_root_texts(revs)
+                    # NB: This currently reopens the inventory weave in source;
+                    # using a full get_data_stream instead would avoid this.
                     self._fetch_inventory_weave(revs, pb)
                 elif knit_kind == "signatures":
                     # Nothing to do here; this will be taken care of when
@@ -217,15 +215,6 @@
         # we fetch all the texts, because texts do
         # not reference anything, and its cheap enough
         to_weave.join(from_weave, version_ids=required_versions)
-        # we don't need *all* of this data anymore, but we dont know
-        # what we do. This cache clearing will result in a new read 
-        # of the knit data when we do the checkout, but probably we
-        # want to emit the needed data on the fly rather than at the
-        # end anyhow.
-        # the from weave should know not to cache data being joined,
-        # but its ok to ask it to clear.
-        from_weave.clear_cache()
-        to_weave.clear_cache()
 
     def _fetch_inventory_weave(self, revs, pb):
         pb.update("fetch inventory", 0, 2)
@@ -243,7 +232,6 @@
             # corrupt.
             to_weave.join(from_weave, pb=child_pb, msg='merge inventory',
                           version_ids=revs)
-            from_weave.clear_cache()
         finally:
             child_pb.finished()
 

=== modified file 'bzrlib/help_topics/__init__.py'
--- bzrlib/help_topics/__init__.py	2008-03-29 12:57:21 +0000
+++ bzrlib/help_topics/__init__.py	2008-04-02 04:16:23 +0000
@@ -580,8 +580,9 @@
 A criss-cross in the branch history can cause the default merge technique
 to emit more conflicts than would normally be expected.
 
-If you encounter criss-crosses, you can use merge --weave instead, which
-should provide a much better result.
+In complex merge cases, ``bzr merge --lca`` or ``bzr merge --weave`` may give
+better results.  You may wish to ``bzr revert`` the working tree and merge
+again.  Alternatively, use ``bzr remerge`` on particular conflicted files.
 
 Criss-crosses occur in a branch's history if two branches merge the same thing
 and then merge one another, or if two branches merge one another at the same
@@ -601,7 +602,8 @@
 
 The ``weave`` merge type is not affected by this problem because it uses
 line-origin detection instead of a basis revision to determine the cause of
-differences."""
+differences.
+"""
 
 
 # Register help topics

=== modified file 'bzrlib/help_topics/en/configuration.txt'
--- bzrlib/help_topics/en/configuration.txt	2007-12-17 01:33:01 +0000
+++ bzrlib/help_topics/en/configuration.txt	2008-04-16 02:23:01 +0000
@@ -122,9 +122,9 @@
 
     [DEFAULT]
 
-The only valid section header for bazaar.conf is [DEFAULT], which is
-case sensitive. The default section provides for setting variables
-which can be overridden with the branch config file.
+The only valid section headers for bazaar.conf currently are [DEFAULT] and
+[ALIASES].  Section headers are case sensitive. The default section provides for
+setting variables which can be overridden with the branch config file.
 
 For ``locations.conf``, the variables from the section with the
 longest matching section header are used to the exclusion of other

=== modified file 'bzrlib/help_topics/en/hooks.txt'
--- bzrlib/help_topics/en/hooks.txt	2007-12-17 02:00:45 +0000
+++ bzrlib/help_topics/en/hooks.txt	2008-04-09 06:41:44 +0000
@@ -76,14 +76,38 @@
 new_revid) where local is the local branch or None, master is the target
 branch, and an empty branch receives new_revno of 0, new_revid of None.
 
+post_change_branch_tip
+----------------------
+
+Run after a branch tip has been changed but while the branch is still
+write-locked. Note that push, pull, commit and uncommit all invoke this hook.
+
+The hook signature is (params), where params is an object containing
+the members
+
+  branch
+    The branch whose tip has been changed.
+
+  old_revno
+    The revision number (eg 10) of the branch before the change.
+
+  old_revid
+    The revision id (eg joe@foo.com-1234234-aoeua34) before the change.
+
+  new_revno
+    The revision number (eg 12) of the branch after the change.
+
+  new_revid
+    The revision id (eg joe@foo.com-5676566-boa234a) after the change.
+
+The old_revno and new_revno members are integers, as the head
+revision is never has a dotted revision number.
+
 set_rh
 ------
 
-Run after the branch's revision history has been modified (push, pull, commit
-and uncommit can all modify the revision history).
-
-The hook signature is (branch, revision_history), and the branch will be
-write-locked.
+Note: This hook is now deprecated and will be removed in the near future.
+Please use the ``post_change_branch_tip`` hook instead.
 
 See also `Using hooks`_ in the User Guide.
 

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2008-01-28 16:59:52 +0000
+++ bzrlib/inventory.py	2008-04-08 03:39:43 +0000
@@ -595,7 +595,7 @@
         # We can't check the length, because Weave doesn't store that
         # information, and the whole point of looking at the weave's
         # sha1sum is that we don't have to extract the text.
-        if self.text_sha1 != w.get_sha1(self.revision):
+        if self.text_sha1 != w.get_sha1s([self.revision])[0]:
             raise BzrCheckError('text {%s} version {%s} wrong sha1' 
                                 % (self.file_id, self.revision))
         checker.checked_texts[t] = self.text_sha1

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2008-04-01 02:41:25 +0000
+++ bzrlib/knit.py	2008-04-09 23:35:55 +0000
@@ -144,10 +144,6 @@
     def __init__(self):
         self._should_strip_eol = False
 
-    def annotate(self):
-        """Return a list of (origin, text) tuples."""
-        return list(self.annotate_iter())
-
     def apply_delta(self, delta, new_version_id):
         """Apply delta to this object to become new_version_id."""
         raise NotImplementedError(self.apply_delta)
@@ -206,9 +202,9 @@
         KnitContent.__init__(self)
         self._lines = lines
 
-    def annotate_iter(self):
-        """Yield tuples of (origin, text) for each content line."""
-        return iter(self._lines)
+    def annotate(self):
+        """Return a list of (origin, text) for each content line."""
+        return list(self._lines)
 
     def apply_delta(self, delta, new_version_id):
         """Apply delta to this object to become new_version_id."""
@@ -256,10 +252,9 @@
         self._lines = lines
         self._version_id = version_id
 
-    def annotate_iter(self):
-        """Yield tuples of (origin, text) for each content line."""
-        for line in self._lines:
-            yield self._version_id, line
+    def annotate(self):
+        """Return a list of (origin, text) for each content line."""
+        return [(self._version_id, line) for line in self._lines]
 
     def apply_delta(self, delta, new_version_id):
         """Apply delta to this object to become new_version_id."""
@@ -427,9 +422,9 @@
                        for origin, text in lines)
         return out
 
-    def annotate_iter(self, knit, version_id):
+    def annotate(self, knit, version_id):
         content = knit._get_content(version_id)
-        return content.annotate_iter()
+        return content.annotate()
 
 
 class KnitPlainFactory(_KnitFactory):
@@ -489,14 +484,42 @@
             out.extend(lines)
         return out
 
-    def annotate_iter(self, knit, version_id):
+    def annotate(self, knit, version_id):
         annotator = _KnitAnnotator(knit)
-        return iter(annotator.annotate(version_id))
+        return annotator.annotate(version_id)
 
 
 def make_empty_knit(transport, relpath):
     """Construct a empty knit at the specified location."""
-    k = KnitVersionedFile(transport, relpath, 'w', KnitPlainFactory)
+    k = make_file_knit(transport, relpath, 'w', KnitPlainFactory)
+
+
+def make_file_knit(name, transport, file_mode=None, access_mode='w',
+    factory=None, delta=True, create=False, create_parent_dir=False,
+    delay_create=False, dir_mode=None, get_scope=None):
+    """Factory to create a KnitVersionedFile for a .knit/.kndx file pair."""
+    if factory is None:
+        factory = KnitAnnotateFactory()
+    else:
+        factory = KnitPlainFactory()
+    if get_scope is None:
+        get_scope = lambda:None
+    index = _KnitIndex(transport, name + INDEX_SUFFIX,
+        access_mode, create=create, file_mode=file_mode,
+        create_parent_dir=create_parent_dir, delay_create=delay_create,
+        dir_mode=dir_mode, get_scope=get_scope)
+    access = _KnitAccess(transport, name + DATA_SUFFIX, file_mode,
+        dir_mode, ((create and not len(index)) and delay_create),
+        create_parent_dir)
+    return KnitVersionedFile(name, transport, factory=factory,
+        create=create, delay_create=delay_create, index=index,
+        access_method=access)
+
+
+def get_suffixes():
+    """Return the suffixes used by file based knits."""
+    return [DATA_SUFFIX, INDEX_SUFFIX]
+make_file_knit.get_suffixes = get_suffixes
 
 
 class KnitVersionedFile(VersionedFile):
@@ -514,7 +537,7 @@
     stored and retrieved.
     """
 
-    def __init__(self, relpath, transport, file_mode=None, access_mode=None,
+    def __init__(self, relpath, transport, file_mode=None,
         factory=None, delta=True, create=False, create_parent_dir=False,
         delay_create=False, dir_mode=None, index=None, access_method=None):
         """Construct a knit at location specified by relpath.
@@ -527,30 +550,18 @@
             actually be created until the first data is stored.
         :param index: An index to use for the knit.
         """
-        if access_mode is None:
-            access_mode = 'w'
-        super(KnitVersionedFile, self).__init__(access_mode)
-        assert access_mode in ('r', 'w'), "invalid mode specified %r" % access_mode
+        super(KnitVersionedFile, self).__init__()
         self.transport = transport
         self.filename = relpath
         self.factory = factory or KnitAnnotateFactory()
-        self.writable = (access_mode == 'w')
         self.delta = delta
 
         self._max_delta_chain = 200
 
-        if index is None:
-            self._index = _KnitIndex(transport, relpath + INDEX_SUFFIX,
-                access_mode, create=create, file_mode=file_mode,
-                create_parent_dir=create_parent_dir, delay_create=delay_create,
-                dir_mode=dir_mode)
-        else:
-            self._index = index
-        if access_method is None:
-            _access = _KnitAccess(transport, relpath + DATA_SUFFIX, file_mode, dir_mode,
-                ((create and not len(self)) and delay_create), create_parent_dir)
-        else:
-            _access = access_method
+        if None in (access_method, index):
+            raise ValueError("No default access_method or index any more")
+        self._index = index
+        _access = access_method
         if create and not len(self) and not delay_create:
             _access.create()
         self._data = _KnitData(_access)
@@ -588,6 +599,9 @@
 
         return fulltext_size > delta_size
 
+    def _check_write_ok(self):
+        return self._index._check_write_ok()
+
     def _add_raw_records(self, records, data):
         """Add all the records 'records' with data pre-joined in 'data'.
 
@@ -604,19 +618,9 @@
         for (version_id, options, parents, size), access_memo in zip(
             records, positions):
             index_entries.append((version_id, options, access_memo, parents))
-            if self._data._do_cache:
-                self._data._cache[version_id] = data[offset:offset+size]
             offset += size
         self._index.add_versions(index_entries)
 
-    def enable_cache(self):
-        """Start caching data for this knit"""
-        self._data.enable_cache()
-
-    def clear_cache(self):
-        """Clear the data cache only."""
-        self._data.clear_cache()
-
     def copy_to(self, name, transport):
         """See VersionedFile.copy_to()."""
         # copy the current index to a temp index to avoid racing with local
@@ -758,20 +762,12 @@
         """See VersionedFile.get_graph_with_ghosts()."""
         return self.get_parent_map(self.versions())
 
-    def get_sha1(self, version_id):
-        return self.get_sha1s([version_id])[0]
-
     def get_sha1s(self, version_ids):
-        """See VersionedFile.get_sha1()."""
+        """See VersionedFile.get_sha1s()."""
         record_map = self._get_record_map(version_ids)
         # record entry 2 is the 'digest'.
         return [record_map[v][2] for v in version_ids]
 
-    @staticmethod
-    def get_suffixes():
-        """See VersionedFile.get_suffixes()."""
-        return [DATA_SUFFIX, INDEX_SUFFIX]
-
     @deprecated_method(one_four)
     def has_ghost(self, version_id):
         """True if there is a ghost reference in the file to version_id."""
@@ -820,7 +816,7 @@
                 # Also check the SHA-1 of the fulltext this content will
                 # produce.
                 raw_data = reader_callable(length)
-                my_fulltext_sha1 = self.get_sha1(version_id)
+                my_fulltext_sha1 = self.get_sha1s([version_id])[0]
                 df, rec = self._data._parse_record_header(version_id, raw_data)
                 stream_fulltext_sha1 = rec[3]
                 if my_fulltext_sha1 != stream_fulltext_sha1:
@@ -1090,12 +1086,6 @@
     def check(self, progress_bar=None):
         """See VersionedFile.check()."""
 
-    def _clone_text(self, new_version_id, old_version_id, parents):
-        """See VersionedFile.clone_text()."""
-        # FIXME RBC 20060228 make fast by only inserting an index with null 
-        # delta.
-        self.add_lines(new_version_id, parents, self.get_lines(old_version_id))
-
     def get_lines(self, version_id):
         """See VersionedFile.get_lines()."""
         return self.get_line_list([version_id])[0]
@@ -1239,26 +1229,15 @@
 
         pb.update('Walking content.', total, total)
         
-    def iter_parents(self, version_ids):
-        """Iterate through the parents for many version ids.
-
-        :param version_ids: An iterable yielding version_ids.
-        :return: An iterator that yields (version_id, parents). Requested 
-            version_ids not present in the versioned file are simply skipped.
-            The order is undefined, allowing for different optimisations in
-            the underlying implementation.
-        """
-        return self._index.iter_parents(version_ids)
-
     def num_versions(self):
         """See VersionedFile.num_versions()."""
         return self._index.num_versions()
 
     __len__ = num_versions
 
-    def annotate_iter(self, version_id):
-        """See VersionedFile.annotate_iter."""
-        return self.factory.annotate_iter(self, version_id)
+    def annotate(self, version_id):
+        """See VersionedFile.annotate."""
+        return self.factory.annotate(self, version_id)
 
     def get_parent_map(self, version_ids):
         """See VersionedFile.get_parent_map."""
@@ -1400,8 +1379,15 @@
                                    parents,
                                    index)
 
+    def _check_write_ok(self):
+        if self._get_scope() != self._scope:
+            raise errors.OutSideTransaction()
+        if self._mode != 'w':
+            raise errors.ReadOnlyObjectDirtiedError(self)
+
     def __init__(self, transport, filename, mode, create=False, file_mode=None,
-                 create_parent_dir=False, delay_create=False, dir_mode=None):
+        create_parent_dir=False, delay_create=False, dir_mode=None,
+        get_scope=None):
         _KnitComponentFile.__init__(self, transport, filename, mode,
                                     file_mode=file_mode,
                                     create_parent_dir=create_parent_dir,
@@ -1428,6 +1414,8 @@
             else:
                 self._transport.put_bytes_non_atomic(
                     self._filename, self.HEADER, mode=self._file_mode)
+        self._scope = get_scope()
+        self._get_scope = get_scope
 
     def get_ancestry(self, versions, topo_sorted=True):
         """See VersionedFile.get_ancestry."""
@@ -1505,28 +1493,6 @@
                                   parents, (method, noeol))
         return result
 
-    def iter_parents(self, version_ids):
-        """Iterate through the parents for many version ids.
-
-        :param version_ids: An iterable yielding version_ids.
-        :return: An iterator that yields (version_id, parents). Requested 
-            version_ids not present in the versioned file are simply skipped.
-            The order is undefined, allowing for different optimisations in
-            the underlying implementation.
-        """
-        parent_map = self.get_parent_map(version_ids)
-        parent_map_set = set(parent_map)
-        unknown_existence = set()
-        for parents in parent_map.itervalues():
-            unknown_existence.update(parents)
-        unknown_existence.difference_update(parent_map_set)
-        present_parents = set(self.get_parent_map(unknown_existence))
-        present_parents.update(parent_map_set)
-        for version_id, parents in parent_map.iteritems():
-            parents = tuple(parent for parent in parents
-                if parent in present_parents)
-            yield version_id, parents
-
     def num_versions(self):
         return len(self._history)
 
@@ -1676,6 +1642,9 @@
             raise KnitCorrupt(self, "Cannot do delta compression without "
                 "parent tracking.")
 
+    def _check_write_ok(self):
+        pass
+
     def _get_entries(self, keys, check_present=False):
         """Get the entries for keys.
         
@@ -1846,35 +1815,6 @@
         else:
             return 'fulltext'
 
-    def iter_parents(self, version_ids):
-        """Iterate through the parents for many version ids.
-
-        :param version_ids: An iterable yielding version_ids.
-        :return: An iterator that yields (version_id, parents). Requested 
-            version_ids not present in the versioned file are simply skipped.
-            The order is undefined, allowing for different optimisations in
-            the underlying implementation.
-        """
-        if self._parents:
-            all_nodes = set(self._get_entries(self._version_ids_to_keys(version_ids)))
-            all_parents = set()
-            present_parents = set()
-            for node in all_nodes:
-                all_parents.update(node[3][0])
-                # any node we are querying must be present
-                present_parents.add(node[1])
-            unknown_parents = all_parents.difference(present_parents)
-            present_parents.update(self._present_keys(unknown_parents))
-            for node in all_nodes:
-                parents = []
-                for parent in node[3][0]:
-                    if parent in present_parents:
-                        parents.append(parent[0])
-                yield node[1][0], tuple(parents)
-        else:
-            for node in self._get_entries(self._version_ids_to_keys(version_ids)):
-                yield node[1][0], ()
-
     def num_versions(self):
         return len(list(self._graph_index.iter_all_entries()))
 
@@ -2225,13 +2165,17 @@
     def get_raw_records(self, memos_for_retrieval):
         """Get the raw bytes for a records.
 
-        :param memos_for_retrieval: An iterable containing the (thunk_flag,
-            index, start, end) memo for retrieving the bytes.
-        :return: An iterator over the bytes of the records.
+        :param memos_for_retrieval: An iterable of memos from the
+            _StreamIndex object identifying bytes to read; for these classes
+            they are (from_backing_knit, index, start, end) and can point to
+            either the backing knit or streamed data.
+        :return: An iterator yielding a byte string for each record in 
+            memos_for_retrieval.
         """
         # use a generator for memory friendliness
-        for thunk_flag, version_id, start, end in memos_for_retrieval:
-            if version_id is self.stream_index:
+        for from_backing_knit, version_id, start, end in memos_for_retrieval:
+            if not from_backing_knit:
+                assert version_id is self.stream_index
                 yield self.data[start:end]
                 continue
             # we have been asked to thunk. This thunking only occurs when
@@ -2242,21 +2186,19 @@
             # as desired. However, for now, this is sufficient.
             if self.orig_factory.__class__ != KnitPlainFactory:
                 raise errors.KnitCorrupt(
-                    self, 'Bad thunk request %r' % version_id)
+                    self, 'Bad thunk request %r cannot be backed by %r' %
+                        (version_id, self.orig_factory))
             lines = self.backing_knit.get_lines(version_id)
             line_bytes = ''.join(lines)
             digest = sha_string(line_bytes)
+            # the packed form of the fulltext always has a trailing newline,
+            # even if the actual text does not, unless the file is empty.  the
+            # record options including the noeol flag are passed through by
+            # _StreamIndex, so this is safe.
             if lines:
                 if lines[-1][-1] != '\n':
                     lines[-1] = lines[-1] + '\n'
                     line_bytes += '\n'
-            orig_options = list(self.backing_knit._index.get_options(version_id))
-            if 'fulltext' not in orig_options:
-                if 'line-delta' not in orig_options:
-                    raise errors.KnitCorrupt(self,
-                        'Unknown compression method %r' % orig_options)
-                orig_options.remove('line-delta')
-                orig_options.append('fulltext')
             # We want plain data, because we expect to thunk only to allow text
             # extraction.
             size, bytes = self.backing_knit._data._record_to_data(version_id,
@@ -2314,8 +2256,9 @@
         :return: A dict of version_id:(index_memo, compression_parent,
                                        parents, record_details).
             index_memo
-                opaque structure to pass to read_records to extract the raw
-                data
+                opaque memo that can be passed to _StreamAccess.read_records
+                to extract the raw data; for these classes it is
+                (from_backing_knit, index, start, end) 
             compression_parent
                 Content that this record is built upon, may be None
             parents
@@ -2333,23 +2276,22 @@
                 continue
             parent_ids = self.get_parents_with_ghosts(version_id)
             noeol = ('no-eol' in self.get_options(version_id))
+            index_memo = self.get_position(version_id)
+            from_backing_knit = index_memo[0]
+            if from_backing_knit:
+                # texts retrieved from the backing knit are always full texts
+                method = 'fulltext'
             if method == 'fulltext':
                 compression_parent = None
             else:
                 compression_parent = parent_ids[0]
-            index_memo = self.get_position(version_id)
             result[version_id] = (index_memo, compression_parent,
                                   parent_ids, (method, noeol))
         return result
 
     def get_method(self, version_id):
         """Return compression method of specified version."""
-        try:
-            options = self._by_version[version_id][0]
-        except KeyError:
-            # Strictly speaking this should check in the backing knit, but
-            # until we have a test to discriminate, this will do.
-            return self.backing_index.get_method(version_id)
+        options = self.get_options(version_id)
         if 'fulltext' in options:
             return 'fulltext'
         elif 'line-delta' in options:
@@ -2365,7 +2307,17 @@
         try:
             return self._by_version[version_id][0]
         except KeyError:
-            return self.backing_index.get_options(version_id)
+            options = list(self.backing_index.get_options(version_id))
+            if 'fulltext' in options:
+                pass
+            elif 'line-delta' in options:
+                # Texts from the backing knit are always returned from the stream
+                # as full texts
+                options.remove('line-delta')
+                options.append('fulltext')
+            else:
+                raise errors.KnitIndexUnknownMethod(self, options)
+            return tuple(options)
 
     def get_parent_map(self, version_ids):
         """Passed through to by KnitVersionedFile.get_parent_map."""
@@ -2393,8 +2345,10 @@
         coordinates into that (as index_memo's are opaque outside the
         index and matching access class).
 
-        :return: a tuple (thunk_flag, index, start, end).  If thunk_flag is
-            False, index will be self, otherwise it will be a version id.
+        :return: a tuple (from_backing_knit, index, start, end) that can 
+            be passed e.g. to get_raw_records.  
+            If from_backing_knit is False, index will be self, otherwise it
+            will be a version id.
         """
         try:
             start, end = self._by_version[version_id][1]
@@ -2407,23 +2361,6 @@
         """Get all the versions in the stream."""
         return self._by_version.keys()
 
-    def iter_parents(self, version_ids):
-        """Iterate through the parents for many version ids.
-
-        :param version_ids: An iterable yielding version_ids.
-        :return: An iterator that yields (version_id, parents). Requested 
-            version_ids not present in the versioned file are simply skipped.
-            The order is undefined, allowing for different optimisations in
-            the underlying implementation.
-        """
-        result = []
-        for version in version_ids:
-            try:
-                result.append((version, self._by_version[version][2]))
-            except KeyError:
-                pass
-        return result
-
 
 class _KnitData(object):
     """Manage extraction of data from a KnitAccess, caching and decompressing.
@@ -2441,21 +2378,6 @@
         """
         self._access = access
         self._checked = False
-        # TODO: jam 20060713 conceptually, this could spill to disk
-        #       if the cached size gets larger than a certain amount
-        #       but it complicates the model a bit, so for now just use
-        #       a simple dictionary
-        self._cache = {}
-        self._do_cache = False
-
-    def enable_cache(self):
-        """Enable caching of reads."""
-        self._do_cache = True
-
-    def clear_cache(self):
-        """Clear the record cache."""
-        self._do_cache = False
-        self._cache = {}
 
     def _open_file(self):
         return self._access.open_file()
@@ -2561,29 +2483,15 @@
         # uses readv so nice and fast we hope.
         if len(records):
             # grab the disk data needed.
-            if self._cache:
-                # Don't check _cache if it is empty
-                needed_offsets = [index_memo for version_id, index_memo
-                                              in records
-                                              if version_id not in self._cache]
-            else:
-                needed_offsets = [index_memo for version_id, index_memo
-                                               in records]
-
+            needed_offsets = [index_memo for version_id, index_memo
+                                           in records]
             raw_records = self._access.get_raw_records(needed_offsets)
 
         for version_id, index_memo in records:
-            if version_id in self._cache:
-                # This data has already been validated
-                data = self._cache[version_id]
-            else:
-                data = raw_records.next()
-                if self._do_cache:
-                    self._cache[version_id] = data
-
-                # validate the header
-                df, rec = self._parse_record_header(version_id, data)
-                df.close()
+            data = raw_records.next()
+            # validate the header
+            df, rec = self._parse_record_header(version_id, data)
+            df.close()
             yield version_id, data
 
     def read_records_iter(self, records):
@@ -2599,24 +2507,7 @@
         if not records:
             return
 
-        if self._cache:
-            # Skip records we have alread seen
-            yielded_records = set()
-            needed_records = set()
-            for record in records:
-                if record[0] in self._cache:
-                    if record[0] in yielded_records:
-                        continue
-                    yielded_records.add(record[0])
-                    data = self._cache[record[0]]
-                    content, digest = self._parse_record(record[0], data)
-                    yield (record[0], content, digest)
-                else:
-                    needed_records.add(record)
-            needed_records = sorted(needed_records, key=operator.itemgetter(1))
-        else:
-            needed_records = sorted(set(records), key=operator.itemgetter(1))
-
+        needed_records = sorted(set(records), key=operator.itemgetter(1))
         if not needed_records:
             return
 
@@ -2628,8 +2519,6 @@
         for (version_id, index_memo), data in \
                 izip(iter(needed_records), raw_data):
             content, digest = self._parse_record(version_id, data)
-            if self._do_cache:
-                self._cache[version_id] = data
             yield version_id, content, digest
 
     def read_records(self, records):
@@ -2644,8 +2533,8 @@
 class InterKnit(InterVersionedFile):
     """Optimised code paths for knit to knit operations."""
     
-    _matching_file_from_factory = KnitVersionedFile
-    _matching_file_to_factory = KnitVersionedFile
+    _matching_file_from_factory = staticmethod(make_file_knit)
+    _matching_file_to_factory = staticmethod(make_file_knit)
     
     @staticmethod
     def is_compatible(source, target):
@@ -2808,7 +2697,7 @@
     """Optimised code paths for weave to knit operations."""
     
     _matching_file_from_factory = bzrlib.weave.WeaveFile
-    _matching_file_to_factory = KnitVersionedFile
+    _matching_file_to_factory = staticmethod(make_file_knit)
     
     @staticmethod
     def is_compatible(source, target):

=== modified file 'bzrlib/lockable_files.py'
--- bzrlib/lockable_files.py	2007-12-13 20:17:06 +0000
+++ bzrlib/lockable_files.py	2008-04-09 02:32:18 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,6 +17,7 @@
 from cStringIO import StringIO
 import codecs
 #import traceback
+from warnings import warn
 
 import bzrlib
 from bzrlib.decorators import (needs_read_lock,
@@ -104,11 +105,9 @@
 
     def __del__(self):
         if self.is_locked():
-            # XXX: This should show something every time, and be suitable for
-            # headless operation and embedding
-            from warnings import warn
-            warn("file group %r was not explicitly unlocked" % self)
-            self._lock.unlock()
+            # do not automatically unlock; there should have been a
+            # try/finally to unlock this.
+            warn("%r was gc'd while locked" % self)
 
     def break_lock(self):
         """Break the lock of this lockable files group if it is held.

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2008-03-28 03:54:40 +0000
+++ bzrlib/log.py	2008-04-18 17:54:34 +0000
@@ -479,6 +479,11 @@
             if rev in weave_modifed_revisions:
                 rev_ancestry.add(rev)
             for parent in parents:
+                if parent not in ancestry:
+                    # parent is a Ghost, which won't be present in
+                    # sorted_rev_list, but we may access it later, so create an
+                    # empty node for it
+                    ancestry[parent] = set()
                 rev_ancestry = rev_ancestry.union(ancestry[parent])
         ancestry[rev] = rev_ancestry
 

=== modified file 'bzrlib/mail_client.py'
--- bzrlib/mail_client.py	2008-04-01 04:19:06 +0000
+++ bzrlib/mail_client.py	2008-04-13 11:48:00 +0000
@@ -306,16 +306,67 @@
         return commandline
 
 
-class EmacsMailMode(ExternalMailClient):
-    """Call emacsclient in mail-mode.
-    
-    This only work for emacs >= 22.1.
+class EmacsMail(ExternalMailClient):
+    """Call emacsclient to have a mail buffer.
+
+    This only work for emacs >= 22.1 due to recent -e/--eval support.
+
+    The good news is that this implementation will work with all mail
+    agents registered against ``mail-user-agent``. So there is no need
+    to instantiate ExternalMailClient for each and every GNU Emacs
+    MUA.
+
+    Users just have to ensure that ``mail-user-agent`` is set according
+    to their tastes.
     """
+
     _client_commands = ['emacsclient']
 
+    def _prepare_send_function(self):
+        """Write our wrapper function into a temporary file.
+
+        This temporary file will be loaded at runtime in
+        _get_compose_commandline function.
+
+        FIXME: this function does not remove the file. That's a wanted
+        behaviour since _get_compose_commandline won't run the send
+        mail function directly but return the eligible command line.
+        Removing our temporary file here would prevent our sendmail
+        function to work.
+
+        A possible workaround could be to load the function here with
+        emacsclient --eval '(load temp)' but this is not robust since
+        emacs could have been stopped between here and the call to
+        mail client.
+        """
+
+        _defun = r"""(defun bzr-add-mime-att (file)
+  "Attach FILe to a mail buffer as a MIME attachment."
+  (let ((agent mail-user-agent))
+    (mail-text)
+    (newline)
+    (if (and file (file-exists-p file))
+        (cond
+         ((eq agent 'sendmail-user-agent)
+          (etach-attach file))
+         ((or (eq agent 'message-user-agent)(eq agent 'gnus-user-agent))
+          (mml-attach-file file "text/x-patch" "BZR merge" "attachment"))
+         (t
+          (message "Unhandled MUA")))
+      (error "File %s does not exist." file))))
+"""
+
+        fd, temp_file = tempfile.mkstemp(prefix="emacs-bzr-send-",
+                                         suffix=".el")
+        try:
+            os.write(fd, _defun)
+        finally:
+            os.close(fd) # Just close the handle but do not remove the file.
+        return temp_file
+
     def _get_compose_commandline(self, to, subject, attach_path):
         commandline = ["--eval"]
-        # Ensure we can at least have an empty mail-mode buffer
+
         _to = "nil"
         _subject = "nil"
 
@@ -323,19 +374,23 @@
             _to = ("\"%s\"" % self._encode_safe(to))
         if subject is not None:
             _subject = ("\"%s\"" % self._encode_safe(subject))
-        mmform = "(mail nil %s %s)" % (_to ,_subject)
-
-        # call mail-mode, move the point to body and insert a new blank line
-        # we *must* force this point movement for the case when To is not passed
-        # with --mail-to. Without this, the patch could be inserted at the wrong place
-        commandline.append(mmform)
-        commandline.append("(mail-text)")
-        commandline.append("(newline)")
-
-        # ... and put a MIME attachment (if any)
+
+        # Funcall the default mail composition function
+        # This will work with any mail mode including default mail-mode
+        # User must tweak mail-user-agent variable to tell what function
+        # will be called inside compose-mail.
+        mail_cmd = "(compose-mail %s %s)" % (_to, _subject)
+        commandline.append(mail_cmd)
+
+        # Try to attach a MIME attachment using our wrapper function
         if attach_path is not None:
-            ifform = "(attach \"%s\")" % self._encode_path(attach_path,'attachment')
-            commandline.append(ifform)
+            # Do not create a file if there is no attachment
+            lmmform = '(load "%s")' % self._prepare_send_function()
+            mmform  = '(bzr-add-mime-att "%s")' % \
+                self._encode_path(attach_path, 'attachment')
+            commandline.append(lmmform)
+            commandline.append(mmform)
+
         return commandline
 
 

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2007-11-17 17:22:08 +0000
+++ bzrlib/msgeditor.py	2008-04-22 09:58:15 +0000
@@ -61,10 +61,10 @@
             ## mutter("trying editor: %r", (edargs +[filename]))
             x = call(edargs + [filename])
         except OSError, e:
-           # We're searching for an editor, so catch safe errors and continue
-           if e.errno in (errno.ENOENT, ):
-               continue
-           raise
+            # We're searching for an editor, so catch safe errors and continue
+            if e.errno in (errno.ENOENT, ):
+                continue
+            raise
         if x == 0:
             return True
         elif x == 127:

=== modified file 'bzrlib/multiparent.py'
--- bzrlib/multiparent.py	2008-03-19 04:39:04 +0000
+++ bzrlib/multiparent.py	2008-04-09 00:34:54 +0000
@@ -382,7 +382,7 @@
                     if [p for p in parents if p not in self._parents] != []:
                         continue
                     lines = [a + ' ' + l for a, l in
-                             vf.annotate_iter(revision)]
+                             vf.annotate(revision)]
                     if snapshots is None:
                         force_snapshot = None
                     else:

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2008-02-28 01:33:35 +0000
+++ bzrlib/osutils.py	2008-04-07 07:34:32 +0000
@@ -468,35 +468,6 @@
         return pathjoin(F(p), e)
 
 
-@deprecated_function(one_zero)
-def backup_file(fn):
-    """Copy a file to a backup.
-
-    Backups are named in GNU-style, with a ~ suffix.
-
-    If the file is already a backup, it's not copied.
-    """
-    if fn[-1] == '~':
-        return
-    bfn = fn + '~'
-
-    if has_symlinks() and os.path.islink(fn):
-        target = os.readlink(fn)
-        os.symlink(target, bfn)
-        return
-    inf = file(fn, 'rb')
-    try:
-        content = inf.read()
-    finally:
-        inf.close()
-    
-    outf = file(bfn, 'wb')
-    try:
-        outf.write(content)
-    finally:
-        outf.close()
-
-
 def isdir(f):
     """True if f is an accessible directory."""
     try:

=== modified file 'bzrlib/plugins/launchpad/lp_directory.py'
--- bzrlib/plugins/launchpad/lp_directory.py	2008-04-02 03:11:19 +0000
+++ bzrlib/plugins/launchpad/lp_directory.py	2008-04-18 22:07:16 +0000
@@ -93,10 +93,9 @@
                 if _lp_login is None:
                     if not _warned_login:
                         trace.warning('You have not informed bzr of your '
-                                'launchpad login. If you are attempting a '
-                                'write operation it may fail. If it does, '
-                                'run "bzr launchpad-login YOUR_ID" to '
-                                'set your login and try again.')
+                                'launchpad login. If you are attempting a\n'
+                                'write operation and it fails, run '
+                                '"bzr launchpad-login YOUR_ID" and try again.')
                         _warned_login = True
                     continue
                 url = urlunsplit((scheme, '%s@%s' % (_lp_login, netloc),

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2008-02-13 03:30:01 +0000
+++ bzrlib/progress.py	2008-04-16 14:44:53 +0000
@@ -325,8 +325,6 @@
                 pass
             elif self.last_cnt + child_fraction <= self.last_total:
                 self.child_fraction = child_fraction
-            else:
-                mutter('not updating child fraction')
         if self.last_msg is None:
             self.last_msg = ''
         self.tick()

=== modified file 'bzrlib/reconfigure.py'
--- bzrlib/reconfigure.py	2008-04-06 16:54:35 +0000
+++ bzrlib/reconfigure.py	2008-04-24 04:58:42 +0000
@@ -18,6 +18,7 @@
 
 from bzrlib import (
     branch,
+    bzrdir,
     errors,
     )
 
@@ -30,6 +31,12 @@
             self.repository = self.bzrdir.find_repository()
         except errors.NoRepositoryPresent:
             self.repository = None
+        else:
+            if (self.repository.bzrdir.root_transport.base ==
+                self.bzrdir.root_transport.base):
+                self.local_repository = self.repository
+            else:
+                self.local_repository = None
         try:
             branch = self.bzrdir.open_branch()
             if branch.bzrdir.root_transport.base == bzrdir.root_transport.base:
@@ -115,6 +122,24 @@
             raise errors.AlreadyLightweightCheckout(bzrdir)
         return reconfiguration
 
+    @classmethod
+    def to_use_shared(klass, bzrdir):
+        """Convert a standalone branch into a repository branch"""
+        reconfiguration = klass(bzrdir)
+        reconfiguration._set_use_shared(use_shared=True)
+        if not reconfiguration.changes_planned():
+            raise errors.AlreadyUsingShared(bzrdir)
+        return reconfiguration
+
+    @classmethod
+    def to_standalone(klass, bzrdir):
+        """Convert a repository branch into a standalone branch"""
+        reconfiguration = klass(bzrdir)
+        reconfiguration._set_use_shared(use_shared=False)
+        if not reconfiguration.changes_planned():
+            raise errors.AlreadyStandalone(bzrdir)
+        return reconfiguration
+
     def _plan_changes(self, want_tree, want_branch, want_bound,
                       want_reference):
         """Determine which changes are needed to assume the configuration"""
@@ -155,12 +180,22 @@
         if want_tree and self.tree is None:
             self._create_tree = True
 
+    def _set_use_shared(self, use_shared=None):
+        if use_shared is None:
+            return
+        if use_shared:
+            if self.local_repository is not None:
+                self._destroy_repository = True
+        else:
+            if self.local_repository is None:
+                self._create_repository = True
+
     def changes_planned(self):
         """Return True if changes are planned, False otherwise"""
         return (self._unbind or self._bind or self._destroy_tree
                 or self._create_tree or self._destroy_reference
                 or self._create_branch or self._create_repository
-                or self._create_reference)
+                or self._create_reference or self._destroy_repository)
 
     def _check(self):
         """Raise if reconfiguration would destroy local changes"""
@@ -218,6 +253,9 @@
             self._check()
         if self._create_repository:
             repo = self.bzrdir.create_repository()
+            if self.local_branch and not self._destroy_branch:
+                repo.fetch(self.local_branch.repository,
+                           self.local_branch.last_revision())
         else:
             repo = self.repository
         if self._create_branch and self.referenced_branch is not None:
@@ -228,6 +266,11 @@
         if self._destroy_repository:
             if self._create_reference:
                 reference_branch.repository.fetch(self.repository)
+            elif self.local_branch is not None and not self._destroy_branch:
+                up = self.local_branch.bzrdir.root_transport.clone('..')
+                up_bzrdir = bzrdir.BzrDir.open_containing_from_transport(up)[0]
+                new_repo = up_bzrdir.find_repository()
+                new_repo.fetch(self.repository)
         last_revision_info = None
         if self._destroy_reference:
             last_revision_info = self.referenced_branch.last_revision_info()

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2008-03-28 08:58:43 +0000
+++ bzrlib/remote.py	2008-04-10 16:41:50 +0000
@@ -42,7 +42,7 @@
     deprecated_method,
     zero_ninetyone,
     )
-from bzrlib.revision import NULL_REVISION
+from bzrlib.revision import ensure_null, NULL_REVISION
 from bzrlib.trace import mutter, note, warning
 
 # Note: RemoteBzrDirFormat is in bzrdir.py
@@ -149,11 +149,9 @@
     def open_repository(self):
         path = self._path_for_remote_call(self._client)
         verb = 'BzrDir.find_repositoryV2'
-        response = self._client.call(verb, path)
-        if (response == ('error', "Generic bzr smart protocol error: "
-                "bad request '%s'" % verb) or
-              response == ('error', "Generic bzr smart protocol error: "
-                "bad request u'%s'" % verb)):
+        try:
+            response = self._client.call(verb, path)
+        except errors.UnknownSmartMethod:
             verb = 'BzrDir.find_repository'
             response = self._client.call(verb, path)
         assert response[0] in ('ok', 'norepository'), \
@@ -634,8 +632,12 @@
         """
         import tempfile
         path = self.bzrdir._path_for_remote_call(self._client)
-        response, protocol = self._client.call_expecting_body(
-            'Repository.tarball', path, compression)
+        try:
+            response, protocol = self._client.call_expecting_body(
+                'Repository.tarball', path, compression)
+        except errors.UnknownSmartMethod:
+            protocol.cancel_read_body()
+            return None
         if response[0] == 'ok':
             # Extract the tarball and return it
             t = tempfile.NamedTemporaryFile()
@@ -643,12 +645,6 @@
             t.write(protocol.read_body_bytes())
             t.seek(0)
             return t
-        if (response == ('error', "Generic bzr smart protocol error: "
-                "bad request 'Repository.tarball'") or
-              response == ('error', "Generic bzr smart protocol error: "
-                "bad request u'Repository.tarball'")):
-            protocol.cancel_read_body()
-            return None
         raise errors.UnexpectedSmartServerResponse(response)
 
     def sprout(self, to_bzrdir, revision_id=None):
@@ -718,8 +714,9 @@
         return self._real_repository.clone(a_bzrdir, revision_id=revision_id)
 
     def make_working_trees(self):
-        """RemoteRepositories never create working trees by default."""
-        return False
+        """See Repository.make_working_trees"""
+        self._ensure_real()
+        return self._real_repository.make_working_trees()
 
     def revision_ids_to_search_result(self, result_set):
         """Convert a set of revision ids to a graph SearchResult."""
@@ -815,24 +812,6 @@
                 100.0 * len(self._requested_parents) / len(ancestry))
         return dict((k, ancestry[k]) for k in present_keys)
 
-    def _response_is_unknown_method(self, response, verb):
-        """Return True if response is an unknonwn method response to verb.
-        
-        :param response: The response from a smart client call_expecting_body
-            call.
-        :param verb: The verb used in that call.
-        :return: True if an unknown method was encountered.
-        """
-        # This might live better on
-        # bzrlib.smart.protocol.SmartClientRequestProtocolOne
-        if (response[0] == ('error', "Generic bzr smart protocol error: "
-                "bad request '%s'" % verb) or
-              response[0] == ('error', "Generic bzr smart protocol error: "
-                "bad request u'%s'" % verb)):
-           response[1].cancel_read_body()
-           return True
-        return False
-
     def _get_parent_map(self, keys):
         """Helper for get_parent_map that performs the RPC."""
         medium = self._client._medium
@@ -883,9 +862,10 @@
             assert type(key) is str
         verb = 'Repository.get_parent_map'
         args = (path,) + tuple(keys)
-        response = self._client.call_with_body_bytes_expecting_body(
-            verb, args, self._serialise_search_recipe(recipe))
-        if self._response_is_unknown_method(response, verb):
+        try:
+            response = self._client.call_with_body_bytes_expecting_body(
+                verb, args, self._serialise_search_recipe(recipe))
+        except errors.UnknownSmartMethod:
             # Server does not support this method, so get the whole graph.
             # Worse, we have to force a disconnection, because the server now
             # doesn't realise it has a body on the wire to consume, so the
@@ -897,9 +877,9 @@
             # To avoid having to disconnect repeatedly, we keep track of the
             # fact the server doesn't understand remote methods added in 1.2.
             medium._remote_is_at_least_1_2 = False
-            return self._get_revision_graph(None)
-        elif response[0][0] not in ['ok']:
-            reponse[1].cancel_read_body()
+            return self.get_revision_graph(None)
+        if response[0][0] not in ['ok']:
+            response[1].cancel_read_body()
             raise errors.UnexpectedSmartServerResponse(response[0])
         if response[0][0] == 'ok':
             coded = bz2.decompress(response[1].read_body_bytes())
@@ -1015,7 +995,8 @@
         return self._real_repository.pack()
 
     def set_make_working_trees(self, new_value):
-        raise NotImplementedError(self.set_make_working_trees)
+        self._ensure_real()
+        self._real_repository.set_make_working_trees(new_value)
 
     @needs_write_lock
     def sign_revision(self, revision_id, gpg_strategy):
@@ -1061,10 +1042,11 @@
         REQUEST_NAME = 'Repository.stream_revisions_chunked'
         path = self.bzrdir._path_for_remote_call(self._client)
         body = self._serialise_search_recipe(search.get_recipe())
-        response, protocol = self._client.call_with_body_bytes_expecting_body(
-            REQUEST_NAME, (path,), body)
-
-        if self._response_is_unknown_method((response, protocol), REQUEST_NAME):
+        try:
+            result = self._client.call_with_body_bytes_expecting_body(
+                REQUEST_NAME, (path,), body)
+            response, protocol = result
+        except errors.UnknownSmartMethod:
             # Server does not support this method, so fall back to VFS.
             # Worse, we have to force a disconnection, because the server now
             # doesn't realise it has a body on the wire to consume, so the
@@ -1248,6 +1230,7 @@
         self._control_files = None
         self._lock_mode = None
         self._lock_token = None
+        self._repo_lock_token = None
         self._lock_count = 0
         self._leave_lock = False
 
@@ -1508,10 +1491,24 @@
     def is_locked(self):
         return self._lock_count >= 1
 
+    @needs_write_lock
     def set_last_revision_info(self, revno, revision_id):
-        self._ensure_real()
-        self._clear_cached_state()
-        return self._real_branch.set_last_revision_info(revno, revision_id)
+        assert type(revno) is int
+        revision_id = ensure_null(revision_id)
+        path = self.bzrdir._path_for_remote_call(self._client)
+        try:
+            response = self._client.call('Branch.set_last_revision_info',
+                path, self._lock_token, self._repo_lock_token, str(revno), revision_id)
+        except errors.UnknownSmartMethod:
+            self._ensure_real()
+            self._clear_cached_state()
+            return self._real_branch.set_last_revision_info(revno, revision_id)
+        if response == ('ok',):
+            self._clear_cached_state()
+        elif response[0] == 'NoSuchRevision':
+            raise NoSuchRevision(self, response[1])
+        else:
+            raise errors.UnexpectedSmartServerResponse(response)
 
     def generate_revision_history(self, revision_id, last_rev=None,
                                   other_branch=None):

=== modified file 'bzrlib/repofmt/knitrepo.py'
--- bzrlib/repofmt/knitrepo.py	2008-03-26 21:42:35 +0000
+++ bzrlib/repofmt/knitrepo.py	2008-04-04 00:06:58 +0000
@@ -101,6 +101,9 @@
         self._commit_builder_class = _commit_builder_class
         self._serializer = _serializer
         self._reconcile_fixes_text_parents = True
+        control_store.get_scope = self.get_transaction
+        text_store.get_scope = self.get_transaction
+        _revision_store.get_scope = self.get_transaction
 
     def _warn_if_deprecated(self):
         # This class isn't deprecated
@@ -358,7 +361,7 @@
             repo_transport,
             prefixed=False,
             file_mode=control_files._file_mode,
-            versionedfile_class=knit.KnitVersionedFile,
+            versionedfile_class=knit.make_file_knit,
             versionedfile_kwargs={'factory':knit.KnitPlainFactory()},
             )
 
@@ -369,7 +372,7 @@
             file_mode=control_files._file_mode,
             prefixed=False,
             precious=True,
-            versionedfile_class=knit.KnitVersionedFile,
+            versionedfile_class=knit.make_file_knit,
             versionedfile_kwargs={'delta':False,
                                   'factory':knit.KnitPlainFactory(),
                                  },
@@ -382,7 +385,7 @@
         return self._get_versioned_file_store('knits',
                                   transport,
                                   control_files,
-                                  versionedfile_class=knit.KnitVersionedFile,
+                                  versionedfile_class=knit.make_file_knit,
                                   versionedfile_kwargs={
                                       'create_parent_dir':True,
                                       'delay_create':True,

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2008-03-26 21:42:35 +0000
+++ bzrlib/repofmt/pack_repo.py	2008-04-04 00:06:58 +0000
@@ -1061,7 +1061,6 @@
             deltas=True, parents=True)
         output_knit = knit.KnitVersionedFile('reconcile-texts',
             self._pack_collection.transport,
-            None,
             index=knit_index,
             access_method=_PackAccess(
                 {self.new_pack.text_index:self.new_pack.access_tuple()},
@@ -1706,7 +1705,7 @@
         self.repo._revision_knit = knit.KnitVersionedFile(
             'revisions', self.transport.clone('..'),
             self.repo.control_files._file_mode,
-            create=False, access_mode=self.repo._access_mode(),
+            create=False,
             index=knit_index, delta=False, factory=knit.KnitPlainFactory(),
             access_method=self.repo._pack_collection.revision_index.knit_access)
         return self.repo._revision_knit
@@ -1724,7 +1723,7 @@
         self.repo._signature_knit = knit.KnitVersionedFile(
             'signatures', self.transport.clone('..'),
             self.repo.control_files._file_mode,
-            create=False, access_mode=self.repo._access_mode(),
+            create=False,
             index=knit_index, delta=False, factory=knit.KnitPlainFactory(),
             access_method=self.repo._pack_collection.signature_index.knit_access)
         return self.repo._signature_knit
@@ -1813,7 +1812,7 @@
         return knit.KnitVersionedFile(
             'inventory', self.transport.clone('..'),
             self.repo.control_files._file_mode,
-            create=False, access_mode=self.repo._access_mode(),
+            create=False,
             index=knit_index, delta=True, factory=knit.KnitPlainFactory(),
             access_method=self.repo._pack_collection.inventory_index.knit_access)
 
@@ -1849,15 +1848,6 @@
     def _abort_write_group(self):
         self._pack_collection._abort_write_group()
 
-    def _access_mode(self):
-        """Return 'w' or 'r' for depending on whether a write lock is active.
-        
-        This method is a helper for the Knit-thunking support objects.
-        """
-        if self.is_write_locked():
-            return 'w'
-        return 'r'
-
     def _find_inconsistent_revision_parents(self):
         """Find revisions with incorrectly cached parents.
 
@@ -2121,7 +2111,7 @@
             repo_transport,
             prefixed=False,
             file_mode=control_files._file_mode,
-            versionedfile_class=knit.KnitVersionedFile,
+            versionedfile_class=knit.make_file_knit,
             versionedfile_kwargs={'factory': knit.KnitPlainFactory()},
             )
 
@@ -2132,7 +2122,7 @@
             file_mode=control_files._file_mode,
             prefixed=False,
             precious=True,
-            versionedfile_class=knit.KnitVersionedFile,
+            versionedfile_class=knit.make_file_knit,
             versionedfile_kwargs={'delta': False,
                                   'factory': knit.KnitPlainFactory(),
                                  },
@@ -2145,7 +2135,7 @@
         return self._get_versioned_file_store('knits',
                                   transport,
                                   control_files,
-                                  versionedfile_class=knit.KnitVersionedFile,
+                                  versionedfile_class=knit.make_file_knit,
                                   versionedfile_kwargs={
                                       'create_parent_dir': True,
                                       'delay_create': True,

=== modified file 'bzrlib/repofmt/weaverepo.py'
--- bzrlib/repofmt/weaverepo.py	2008-03-26 21:42:35 +0000
+++ bzrlib/repofmt/weaverepo.py	2008-04-10 06:19:49 +0000
@@ -37,7 +37,7 @@
 from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.repository import (
     CommitBuilder,
-    MetaDirRepository,
+    MetaDirVersionedFileRepository,
     MetaDirRepositoryFormat,
     Repository,
     RepositoryFormat,
@@ -77,6 +77,9 @@
             self.inventory_store = get_store('inventory-store')
             text_store = get_store('text-store')
         super(AllInOneRepository, self).__init__(_format, a_bzrdir, a_bzrdir._control_files, _revision_store, control_store, text_store)
+        if control_store is not None:
+            control_store.get_scope = self.get_transaction
+        text_store.get_scope = self.get_transaction
 
     @needs_read_lock
     def _all_possible_ids(self):
@@ -202,8 +205,8 @@
         :param new_value: True to restore the default, False to disable making
                           working trees.
         """
-        raise NotImplementedError(self.set_make_working_trees)
-    
+        raise errors.RepositoryUpgradeRequired(self.bzrdir.root_transport.base)
+
     def make_working_trees(self):
         """Returns the policy for making working trees on new branches."""
         return True
@@ -214,7 +217,7 @@
         return False
 
 
-class WeaveMetaDirRepository(MetaDirRepository):
+class WeaveMetaDirRepository(MetaDirVersionedFileRepository):
     """A subclass of MetaDirRepository to set weave specific policy."""
 
     _serializer = xml5.serializer_v5
@@ -629,7 +632,6 @@
         result = versionedfile.add_lines(
             self._new_revision_id, parents, new_lines,
             nostore_sha=nostore_sha)[0:2]
-        versionedfile.clear_cache()
         return result
 
 

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2008-03-28 03:54:40 +0000
+++ bzrlib/repository.py	2008-04-16 14:54:19 +0000
@@ -420,13 +420,10 @@
         # implementation could give us bad output from readlines() so this is
         # not a guarantee of safety. What would be better is always checking
         # the content during test suite execution. RBC 20070912
-        try:
-            return versionedfile.add_lines_with_ghosts(
-                self._new_revision_id, parents, new_lines,
-                nostore_sha=nostore_sha, random_id=self.random_revid,
-                check_content=False)[0:2]
-        finally:
-            versionedfile.clear_cache()
+        return versionedfile.add_lines_with_ghosts(
+            self._new_revision_id, parents, new_lines,
+            nostore_sha=nostore_sha, random_id=self.random_revid,
+            check_content=False)[0:2]
 
 
 class RootCommitBuilder(CommitBuilder):
@@ -595,10 +592,10 @@
         Returns a set of the present revisions.
         """
         result = []
-        for id in revision_ids:
-            if self.has_revision(id):
-               result.append(id)
-        return result
+        graph = self.get_graph()
+        parent_map = graph.get_parent_map(revision_ids)
+        # The old API returned a list, should this actually be a set?
+        return parent_map.keys()
 
     @staticmethod
     def create(a_bzrdir):
@@ -1281,16 +1278,18 @@
                 setdefault(file_id, set()).add(revision_id)
         return result
 
-    def fileids_altered_by_revision_ids(self, revision_ids):
+    def fileids_altered_by_revision_ids(self, revision_ids, _inv_weave=None):
         """Find the file ids and versions affected by revisions.
 
         :param revisions: an iterable containing revision ids.
+        :param _inv_weave: The inventory weave from this repository or None.
+            If None, the inventory weave will be opened automatically.
         :return: a dictionary mapping altered file-ids to an iterable of
         revision_ids. Each altered file-ids has the exact revision_ids that
         altered it listed explicitly.
         """
         selected_revision_ids = set(revision_ids)
-        w = self.get_inventory_weave()
+        w = _inv_weave or self.get_inventory_weave()
         pb = ui.ui_factory.nested_progress_bar()
         try:
             return self._find_file_ids_from_xml_inventory_lines(
@@ -1450,10 +1449,9 @@
         # processed?
         self.lock_read()
         inv_w = self.get_inventory_weave()
-        inv_w.enable_cache()
 
         # file ids that changed
-        file_ids = self.fileids_altered_by_revision_ids(revision_ids)
+        file_ids = self.fileids_altered_by_revision_ids(revision_ids, inv_w)
         count = 0
         num_file_ids = len(file_ids)
         for file_id, altered_versions in file_ids.iteritems():
@@ -1467,7 +1465,6 @@
 
         # inventory
         yield ("inventory", None, revision_ids)
-        inv_w.clear_cache()
 
         # signatures
         revisions_with_signatures = set()
@@ -2038,6 +2035,17 @@
         return not self.control_files._transport.has('no-working-trees')
 
 
+class MetaDirVersionedFileRepository(MetaDirRepository):
+    """Repositories in a meta-dir, that work via versioned file objects."""
+
+    def __init__(self, _format, a_bzrdir, control_files, _revision_store, control_store, text_store):
+        super(MetaDirVersionedFileRepository, self).__init__(_format, a_bzrdir,
+            control_files, _revision_store, control_store, text_store)
+        _revision_store.get_scope = self.get_transaction
+        control_store.get_scope = self.get_transaction
+        text_store.get_scope = self.get_transaction
+
+
 class RepositoryFormatRegistry(registry.Registry):
     """Registry of RepositoryFormats."""
 
@@ -2377,6 +2385,7 @@
         :return: A set of revision ids.
         """
         graph = self.source.get_graph()
+        target_graph = self.target.get_graph()
         missing_revs = set()
         # ensure we don't pay silly lookup costs.
         revision_ids = frozenset(revision_ids)
@@ -2391,14 +2400,14 @@
                 absent_ids = set(revision_ids.intersection(ghosts))
                 # If all absent_ids are present in target, no error is needed.
                 absent_ids.difference_update(
-                    self.target.has_revisions(absent_ids))
+                    set(target_graph.get_parent_map(absent_ids)))
                 if absent_ids:
                     raise errors.NoSuchRevision(self.source, absent_ids.pop())
             # we don't care about other ghosts as we can't fetch them and
             # haven't been asked to.
             next_revs = set(next_revs)
             # we always have NULL_REVISION present.
-            have_revs = self.target.has_revisions(next_revs).union(null_set)
+            have_revs = set(target_graph.get_parent_map(next_revs)).union(null_set)
             missing_revs.update(next_revs - have_revs)
             searcher.stop_searching_any(have_revs)
         return searcher.get_result()
@@ -2550,7 +2559,7 @@
         # weave specific optimised path:
         try:
             self.target.set_make_working_trees(self.source.make_working_trees())
-        except NotImplementedError:
+        except (errors.RepositoryUpgradeRequired, NotImplemented):
             pass
         # FIXME do not peek!
         if self.source.control_files._transport.listable():

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2007-12-06 20:06:01 +0000
+++ bzrlib/revisiontree.py	2008-04-09 00:34:54 +0000
@@ -93,7 +93,7 @@
                       default_revision=revision.CURRENT_REVISION):
         """See Tree.annotate_iter"""
         w = self._get_weave(file_id)
-        return w.annotate_iter(self.inventory[file_id].revision)
+        return w.annotate(self.inventory[file_id].revision)
 
     def get_file_size(self, file_id):
         return self._inventory[file_id].text_size

=== modified file 'bzrlib/smart/branch.py'
--- bzrlib/smart/branch.py	2007-12-05 07:09:42 +0000
+++ bzrlib/smart/branch.py	2008-04-08 08:13:33 +0000
@@ -123,6 +123,23 @@
         return SuccessfulSmartServerResponse(('ok',))
 
 
+class SmartServerBranchRequestSetLastRevisionInfo(
+    SmartServerLockedBranchRequest):
+    """Branch.set_last_revision_info.  Sets the revno and the revision ID of
+    the specified branch.
+
+    New in bzrlib 1.4.
+    """
+    
+    def do_with_locked_branch(self, branch, new_revno, new_last_revision_id):
+        try:
+            branch.set_last_revision_info(int(new_revno), new_last_revision_id)
+        except errors.NoSuchRevision:
+            return FailedSmartServerResponse(
+                ('NoSuchRevision', new_last_revision_id))
+        return SuccessfulSmartServerResponse(('ok',))
+
+
 class SmartServerBranchRequestLockWrite(SmartServerBranchRequest):
     
     def do_with_branch(self, branch, branch_token='', repo_token=''):

=== modified file 'bzrlib/smart/client.py'
--- bzrlib/smart/client.py	2008-03-28 09:07:01 +0000
+++ bzrlib/smart/client.py	2008-04-14 08:03:35 +0000
@@ -18,7 +18,10 @@
 from urlparse import urlparse
 
 from bzrlib.smart import protocol
-from bzrlib import urlutils
+from bzrlib import (
+    errors,
+    urlutils,
+    )
 
 
 class _SmartClient(object):
@@ -32,6 +35,15 @@
         self._medium = medium
         self._base = base
 
+    def _build_client_protocol(self):
+        version = self._medium.protocol_version()
+        request = self._medium.get_request()
+        if version == 2:
+            smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        else:
+            smart_protocol = protocol.SmartClientRequestProtocolOne(request)
+        return smart_protocol
+
     def call(self, method, *args):
         """Call a method on the remote server."""
         result, protocol = self.call_expecting_body(method, *args)
@@ -46,8 +58,7 @@
             result, smart_protocol = smart_client.call_expecting_body(...)
             body = smart_protocol.read_body_bytes()
         """
-        request = self._medium.get_request()
-        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        smart_protocol = self._build_client_protocol()
         smart_protocol.call(method, *args)
         return smart_protocol.read_response_tuple(expect_body=True), smart_protocol
 
@@ -60,8 +71,7 @@
                 raise TypeError('args must be byte strings, not %r' % (args,))
         if type(body) is not str:
             raise TypeError('body must be byte string, not %r' % (body,))
-        request = self._medium.get_request()
-        smart_protocol = protocol.SmartClientRequestProtocolOne(request)
+        smart_protocol = self._build_client_protocol()
         smart_protocol.call_with_body_bytes((method, ) + args, body)
         return smart_protocol.read_response_tuple()
 
@@ -74,8 +84,7 @@
                 raise TypeError('args must be byte strings, not %r' % (args,))
         if type(body) is not str:
             raise TypeError('body must be byte string, not %r' % (body,))
-        request = self._medium.get_request()
-        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        smart_protocol = self._build_client_protocol()
         smart_protocol.call_with_body_bytes((method, ) + args, body)
         return smart_protocol.read_response_tuple(expect_body=True), smart_protocol
 
@@ -95,3 +104,4 @@
             
         rel_url = urlutils.relative_url(medium_base, transport.base)
         return urllib.unquote(rel_url)
+

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2008-03-27 06:10:18 +0000
+++ bzrlib/smart/medium.py	2008-04-14 08:03:35 +0000
@@ -53,6 +53,11 @@
 
     The server passes requests through to an underlying backing transport, 
     which will typically be a LocalTransport looking at the server's filesystem.
+
+    :ivar _push_back_buffer: a str of bytes that have been read from the stream
+        but not used yet, or None if there are no buffered bytes.  Subclasses
+        should make sure to exhaust this buffer before reading more bytes from
+        the stream.  See also the _push_back method.
     """
 
     def __init__(self, backing_transport, root_client_path='/'):
@@ -64,6 +69,28 @@
         self.backing_transport = backing_transport
         self.root_client_path = root_client_path
         self.finished = False
+        self._push_back_buffer = None
+
+    def _push_back(self, bytes):
+        """Return unused bytes to the medium, because they belong to the next
+        request(s).
+
+        This sets the _push_back_buffer to the given bytes.
+        """
+        assert self._push_back_buffer is None, (
+            "_push_back called when self._push_back_buffer is %r"
+            % (self._push_back_buffer,))
+        if bytes == '':
+            return
+        self._push_back_buffer = bytes
+
+    def _get_push_back_buffer(self):
+        assert self._push_back_buffer != '', (
+            '%s._push_back_buffer should never be the empty string, '
+            'which can be confused with EOF' % (self,))
+        bytes = self._push_back_buffer
+        self._push_back_buffer = None
+        return bytes
 
     def serve(self):
         """Serve requests until the client disconnects."""
@@ -130,16 +157,19 @@
 
         :returns: a string of bytes ending in a newline (byte 0x0A).
         """
-        # XXX: this duplicates SmartClientRequestProtocolOne._recv_tuple
-        line = ''
-        while not line or line[-1] != '\n':
-            new_char = self._get_bytes(1)
-            line += new_char
-            if new_char == '':
+        newline_pos = -1
+        bytes = ''
+        while newline_pos == -1:
+            new_bytes = self._get_bytes(1)
+            bytes += new_bytes
+            if new_bytes == '':
                 # Ran out of bytes before receiving a complete line.
-                break
+                return bytes
+            newline_pos = bytes.find('\n')
+        line = bytes[:newline_pos+1]
+        self._push_back(bytes[newline_pos+1:])
         return line
-
+ 
 
 class SmartServerSocketStreamMedium(SmartServerStreamMedium):
 
@@ -151,25 +181,22 @@
         """
         SmartServerStreamMedium.__init__(
             self, backing_transport, root_client_path=root_client_path)
-        self.push_back = ''
         sock.setblocking(True)
         self.socket = sock
 
     def _serve_one_request_unguarded(self, protocol):
         while protocol.next_read_size():
-            if self.push_back:
-                protocol.accept_bytes(self.push_back)
-                self.push_back = ''
-            else:
-                bytes = self._get_bytes(4096)
-                if bytes == '':
-                    self.finished = True
-                    return
-                protocol.accept_bytes(bytes)
+            bytes = self._get_bytes(4096)
+            if bytes == '':
+                self.finished = True
+                return
+            protocol.accept_bytes(bytes)
         
-        self.push_back = protocol.excess_buffer
+        self._push_back(protocol.excess_buffer)
 
     def _get_bytes(self, desired_count):
+        if self._push_back_buffer is not None:
+            return self._get_push_back_buffer()
         # We ignore the desired_count because on sockets it's more efficient to
         # read 4k at a time.
         return self.socket.recv(4096)
@@ -221,6 +248,8 @@
             protocol.accept_bytes(bytes)
 
     def _get_bytes(self, desired_count):
+        if self._push_back_buffer is not None:
+            return self._get_push_back_buffer()
         return self._in.read(desired_count)
 
     def terminate_due_to_error(self):

=== modified file 'bzrlib/smart/protocol.py'
--- bzrlib/smart/protocol.py	2008-03-27 06:10:18 +0000
+++ bzrlib/smart/protocol.py	2008-04-07 10:34:57 +0000
@@ -469,6 +469,7 @@
         self._request = request
         self._body_buffer = None
         self._request_start_time = None
+        self._last_verb = None
 
     def call(self, *args):
         if 'hpss' in debug.debug_flags:
@@ -478,6 +479,7 @@
             self._request_start_time = time.time()
         self._write_args(args)
         self._request.finished_writing()
+        self._last_verb = args[0]
 
     def call_with_body_bytes(self, args, body):
         """Make a remote call of args with body bytes 'body'.
@@ -496,6 +498,7 @@
         bytes = self._encode_bulk_data(body)
         self._request.accept_bytes(bytes)
         self._request.finished_writing()
+        self._last_verb = args[0]
 
     def call_with_body_readv_array(self, args, body):
         """Make a remote call with a readv array.
@@ -515,6 +518,7 @@
         self._request.finished_writing()
         if 'hpss' in debug.debug_flags:
             mutter('              %d bytes in readv request', len(readv_bytes))
+        self._last_verb = args[0]
 
     def cancel_read_body(self):
         """After expecting a body, a response code may indicate one otherwise.
@@ -539,10 +543,28 @@
                 self._request_start_time = None
             else:
                 mutter('   result:   %s', repr(result)[1:-1])
+        self._response_is_unknown_method(result)
         if not expect_body:
             self._request.finished_reading()
         return result
 
+    def _response_is_unknown_method(self, result_tuple):
+        """Raise UnexpectedSmartServerResponse if the response is an 'unknonwn
+        method' response to the request.
+        
+        :param response: The response from a smart client call_expecting_body
+            call.
+        :param verb: The verb used in that call.
+        :raises: UnexpectedSmartServerResponse
+        """
+        if (result_tuple == ('error', "Generic bzr smart protocol error: "
+                "bad request '%s'" % self._last_verb) or
+              result_tuple == ('error', "Generic bzr smart protocol error: "
+                "bad request u'%s'" % self._last_verb)):
+            # The response will have no body, so we've finished reading.
+            self._request.finished_reading()
+            raise errors.UnknownSmartMethod(self._last_verb)
+        
     def read_body_bytes(self, count=-1):
         """Read bytes from the body, decoding into a byte stream.
         

=== modified file 'bzrlib/smart/request.py'
--- bzrlib/smart/request.py	2008-03-27 06:10:18 +0000
+++ bzrlib/smart/request.py	2008-04-08 06:38:34 +0000
@@ -340,6 +340,9 @@
 request_handlers.register_lazy(
     'Branch.set_last_revision', 'bzrlib.smart.branch', 'SmartServerBranchRequestSetLastRevision')
 request_handlers.register_lazy(
+    'Branch.set_last_revision_info', 'bzrlib.smart.branch',
+    'SmartServerBranchRequestSetLastRevisionInfo')
+request_handlers.register_lazy(
     'Branch.unlock', 'bzrlib.smart.branch', 'SmartServerBranchRequestUnlock')
 request_handlers.register_lazy(
     'BzrDir.find_repository', 'bzrlib.smart.bzrdir', 'SmartServerRequestFindRepositoryV1')

=== modified file 'bzrlib/smart/server.py'
--- bzrlib/smart/server.py	2007-12-13 22:22:58 +0000
+++ bzrlib/smart/server.py	2008-04-21 01:07:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 
 import errno
 import socket
+import sys
 import threading
 
 from bzrlib.hooks import Hooks
@@ -59,6 +60,10 @@
         self._socket_error = socket_error
         self._socket_timeout = socket_timeout
         self._server_socket = socket.socket()
+        # SO_REUSERADDR has a different meaning on Windows
+        if sys.platform != 'win32':
+            self._server_socket.setsockopt(socket.SOL_SOCKET,
+                socket.SO_REUSEADDR, 1)
         self._server_socket.bind((host, port))
         self._sockname = self._server_socket.getsockname()
         self.port = self._sockname[1]

=== modified file 'bzrlib/store/revision/knit.py'
--- bzrlib/store/revision/knit.py	2007-10-11 04:54:04 +0000
+++ bzrlib/store/revision/knit.py	2008-04-04 00:06:58 +0000
@@ -26,7 +26,7 @@
     osutils,
     revision as _mod_revision,
     )
-from bzrlib.knit import KnitVersionedFile, KnitPlainFactory
+from bzrlib.knit import make_file_knit, KnitPlainFactory
 from bzrlib.store.revision import RevisionStore
 from bzrlib.store.versioned import VersionedFileStore
 from bzrlib.transport import get_transport
@@ -42,7 +42,7 @@
         versioned_file_store = VersionedFileStore(
             t.clone('revision-store'),
             precious=True,
-            versionedfile_class=KnitVersionedFile,
+            versionedfile_class=make_file_knit,
             versionedfile_kwargs={'delta':False, 'factory':KnitPlainFactory()})
         return KnitRevisionStore(versioned_file_store)
 

=== modified file 'bzrlib/store/versioned/__init__.py'
--- bzrlib/store/versioned/__init__.py	2007-09-25 08:14:12 +0000
+++ bzrlib/store/versioned/__init__.py	2008-04-08 00:57:07 +0000
@@ -54,21 +54,8 @@
         self._precious = precious
         self._versionedfile_class = versionedfile_class
         self._versionedfile_kwargs = versionedfile_kwargs
-
-    def _clear_cache_id(self, file_id, transaction):
-        """WARNING may lead to inconsistent object references for file_id.
-
-        Remove file_id from the transaction map. 
-
-        NOT in the transaction api because theres no reliable way to clear
-        callers. So its here for very specialised use rather than having an
-        'api' that isn't.
-        """
-        weave = transaction.map.find_weave(file_id)
-        if weave is not None:
-            mutter("old data in transaction in %s for %s", self, file_id)
-            # FIXME abstraction violation - transaction now has stale data.
-            transaction.map.remove_object(weave)
+        # Used for passing get_scope to versioned file constructors;
+        self.get_scope = None
 
     def filename(self, file_id):
         """Return the path relative to the transport root."""
@@ -108,7 +95,6 @@
         filename = self.filename(file_id)
         for suffix in suffixes:
             self._transport.delete(filename + suffix)
-        self._clear_cache_id(file_id, transaction)
 
     def _get(self, file_id):
         return self._transport.get(self.filename(file_id))
@@ -130,26 +116,19 @@
         file_id. This is used to reduce duplicate filename calculations when
         using 'get_weave_or_empty'. FOR INTERNAL USE ONLY.
         """
-        weave = transaction.map.find_weave(file_id)
-        if weave is not None:
-            #mutter("cache hit in %s for %s", self, file_id)
-            return weave
         if _filename is None:
             _filename = self.filename(file_id)
         if transaction.writeable():
             w = self._versionedfile_class(_filename, self._transport, self._file_mode,
-                                          **self._versionedfile_kwargs)
-            transaction.map.add_weave(file_id, w)
-            transaction.register_dirty(w)
+                get_scope=self.get_scope, **self._versionedfile_kwargs)
         else:
             w = self._versionedfile_class(_filename,
                                           self._transport,
                                           self._file_mode,
                                           create=False,
                                           access_mode='r',
+                                          get_scope=self.get_scope,
                                           **self._versionedfile_kwargs)
-            transaction.map.add_weave(file_id, w)
-            transaction.register_clean(w, precious=self._precious)
         return w
 
     def _make_new_versionedfile(self, file_id, transaction,
@@ -168,15 +147,16 @@
             # we try without making the directory first because thats optimising
             # for the common case.
             weave = self._versionedfile_class(_filename, self._transport, self._file_mode, create=True,
-                                              **self._versionedfile_kwargs)
+                get_scope=self.get_scope, **self._versionedfile_kwargs)
         except errors.NoSuchFile:
             if not self._prefixed:
                 # unexpected error - NoSuchFile is expected to be raised on a
                 # missing dir only and that only occurs when we are prefixed.
                 raise
             self._transport.mkdir(self.hash_prefix(file_id), mode=self._dir_mode)
-            weave = self._versionedfile_class(_filename, self._transport, 
+            weave = self._versionedfile_class(_filename, self._transport,
                                               self._file_mode, create=True,
+                                              get_scope=self.get_scope,
                                               **self._versionedfile_kwargs)
         return weave
 
@@ -193,9 +173,6 @@
         except errors.NoSuchFile:
             weave = self._make_new_versionedfile(file_id, transaction,
                 known_missing=True, _filename=_filename)
-            transaction.map.add_weave(file_id, weave)
-            # has to be dirty - its able to mutate on its own.
-            transaction.register_dirty(weave)
             return weave
 
     def _put_weave(self, file_id, weave, transaction):
@@ -205,7 +182,6 @@
 
     def copy(self, source, result_id, transaction):
         """Copy the source versioned file to result_id in this store."""
-        self._clear_cache_id(result_id, transaction)
         source.copy_to(self.filename(result_id), self._transport)
  
     def copy_all_ids(self, store_from, pb=None, from_transaction=None,

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2008-04-05 01:46:46 +0000
+++ bzrlib/tests/__init__.py	2008-04-07 04:44:56 +0000
@@ -402,20 +402,29 @@
         self.pb.update('[test 0/%d] starting...' % (self.num_tests))
 
     def _progress_prefix_text(self):
-        a = '[%d' % self.count
+        # the longer this text, the less space we have to show the test
+        # name...
+        a = '[%d' % self.count              # total that have been run
+        # tests skipped as known not to be relevant are not important enough
+        # to show here
+        ## if self.skip_count:
+        ##     a += ', %d skip' % self.skip_count
+        ## if self.known_failure_count:
+        ##     a += '+%dX' % self.known_failure_count
         if self.num_tests is not None:
             a +='/%d' % self.num_tests
-        a += ' in %ds' % (time.time() - self._overall_start_time)
+        a += ' in '
+        runtime = time.time() - self._overall_start_time
+        if runtime >= 60:
+            a += '%dm%ds' % (runtime / 60, runtime % 60)
+        else:
+            a += '%ds' % runtime
         if self.error_count:
-            a += ', %d errors' % self.error_count
+            a += ', %d err' % self.error_count
         if self.failure_count:
-            a += ', %d failed' % self.failure_count
-        if self.known_failure_count:
-            a += ', %d known failures' % self.known_failure_count
-        if self.skip_count:
-            a += ', %d skipped' % self.skip_count
+            a += ', %d fail' % self.failure_count
         if self.unsupported:
-            a += ', %d missing features' % len(self.unsupported)
+            a += ', %d missing' % len(self.unsupported)
         a += ']'
         return a
 

=== modified file 'bzrlib/tests/blackbox/test_reconfigure.py'
--- bzrlib/tests/blackbox/test_reconfigure.py	2007-11-29 17:32:23 +0000
+++ bzrlib/tests/blackbox/test_reconfigure.py	2008-04-12 05:48:07 +0000
@@ -15,6 +15,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 from bzrlib import (
+    bzrdir,
     errors,
     tests,
     workingtree,
@@ -66,3 +67,22 @@
         branch = self.make_branch('branch')
         checkout = branch.create_checkout('checkout')
         self.run_bzr('reconfigure --lightweight-checkout checkout')
+
+    def test_standalone_to_use_shared(self):
+        self.build_tree(['repo/'])
+        tree = self.make_branch_and_tree('repo/tree')
+        repo = self.make_repository('repo', shared=True)
+        self.run_bzr('reconfigure --use-shared', working_dir='repo/tree')
+        tree = workingtree.WorkingTree.open('repo/tree')
+        self.assertNotEqual(tree.bzrdir.root_transport.base,
+            tree.branch.repository.bzrdir.root_transport.base)
+
+    def test_use_shared_to_standalone(self):
+        repo = self.make_repository('repo', shared=True)
+        branch = bzrdir.BzrDir.create_branch_convenience('repo/tree')
+        self.assertNotEqual(branch.bzrdir.root_transport.base,
+            branch.repository.bzrdir.root_transport.base)
+        self.run_bzr('reconfigure --standalone', working_dir='repo/tree')
+        tree = workingtree.WorkingTree.open('repo/tree')
+        self.assertEqual(tree.bzrdir.root_transport.base,
+            tree.branch.repository.bzrdir.root_transport.base)

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2007-09-04 01:20:26 +0000
+++ bzrlib/tests/blackbox/test_status.py	2008-03-16 15:17:57 +0000
@@ -44,20 +44,22 @@
 class BranchStatus(TestCaseWithTransport):
     
     def assertStatus(self, expected_lines, working_tree,
-        revision=None, short=False):
+        revision=None, short=False, pending=True):
         """Run status in working_tree and look for output.
         
         :param expected_lines: The lines to look for.
         :param working_tree: The tree to run status in.
         """
-        output_string = self.status_string(working_tree, revision, short)
+        output_string = self.status_string(working_tree, revision, short,
+                pending)
         self.assertEqual(expected_lines, output_string.splitlines(True))
     
-    def status_string(self, wt, revision=None, short=False):
+    def status_string(self, wt, revision=None, short=False, pending=True):
         # use a real file rather than StringIO because it doesn't handle
         # Unicode very well.
         tof = codecs.getwriter('utf-8')(TemporaryFile())
-        show_tree_status(wt, to_file=tof, revision=revision, short=short)
+        show_tree_status(wt, to_file=tof, revision=revision, short=short,
+                show_pending=pending)
         tof.seek(0)
         return tof.read().decode('utf-8')
 
@@ -102,6 +104,17 @@
                 'P   pending@pending-0-0\n',
             ],
             wt, short=True)
+        self.assertStatus([
+                'unknown:\n',
+                '  bye.c\n',
+                '  hello.c\n',
+            ],
+            wt, pending=False)
+        self.assertStatus([
+                '?   bye.c\n',
+                '?   hello.c\n',
+            ],
+            wt, short=True, pending=False)
 
     def test_branch_status_revisions(self):
         """Tests branch status with revisions"""
@@ -415,6 +428,22 @@
         out, err = self.run_bzr('status -r 1..23..123', retcode=3)
         self.assertContainsRe(err, 'one or two revision specifiers')
 
+    def test_status_no_pending(self):
+        a_tree = self.make_branch_and_tree('a')
+        self.build_tree(['a/a'])
+        a_tree.add('a')
+        a_tree.commit('a')
+        b_tree = a_tree.bzrdir.sprout('b').open_workingtree()
+        self.build_tree(['b/b'])
+        b_tree.add('b')
+        b_tree.commit('b')
+
+        chdir('a')
+        self.run_bzr('merge ../b')
+        out, err = self.run_bzr('status --no-pending')
+        self.assertEquals(out, "added:\n  b\n")
+
+
 
 class TestStatusEncodings(TestCaseWithTransport):
     

=== modified file 'bzrlib/tests/branch_implementations/test_hooks.py'
--- bzrlib/tests/branch_implementations/test_hooks.py	2007-08-14 11:42:58 +0000
+++ bzrlib/tests/branch_implementations/test_hooks.py	2008-04-09 06:43:42 +0000
@@ -17,6 +17,7 @@
 """Tests that branch classes implement hook callouts correctly."""
 
 from bzrlib.branch import Branch
+from bzrlib.revision import NULL_REVISION
 from bzrlib.tests import TestCaseWithMemoryTransport
 
 
@@ -72,3 +73,71 @@
             [('set_rh', branch, [], True),
              ('set_rh', branch, [], True),
             ])
+
+
+class TestPostChangeBranchTip(TestCaseWithMemoryTransport):
+
+    def setUp(self):
+        self.hook_calls = []
+        TestCaseWithMemoryTransport.setUp(self)
+
+    def capture_post_change_branch_tip_hook(self, params):
+        """Capture post_change_branch_tip hook calls to self.hook_calls.
+
+        The call is logged, as is some state of the branch.
+        """
+        self.hook_calls.append((params, params.branch.is_locked()))
+        self.assertEquals(params.branch.last_revision_info(),
+                          (params.new_revno, params.new_revid))
+
+    def test_post_change_branch_tip_empty_history(self):
+        branch = self.make_branch('source')
+        Branch.hooks.install_hook('post_change_branch_tip',
+                                  self.capture_post_change_branch_tip_hook)
+        branch.set_last_revision_info(0, NULL_REVISION)
+        self.assertEqual(len(self.hook_calls), 1)
+        self.assertEqual(self.hook_calls[0][0].branch, branch)
+        self.assertEqual(self.hook_calls[0][0].old_revid, NULL_REVISION)
+        self.assertEqual(self.hook_calls[0][0].old_revno, 0)
+        self.assertEqual(self.hook_calls[0][0].new_revid, NULL_REVISION)
+        self.assertEqual(self.hook_calls[0][0].new_revno, 0)
+
+    def test_post_change_branch_tip_nonempty_history(self):
+        tree = self.make_branch_and_memory_tree('source')
+        tree.lock_write()
+        tree.add('')
+        tree.commit('another commit', rev_id='f\xc2\xb5')
+        tree.commit('empty commit', rev_id='foo')
+        tree.unlock()
+        branch = tree.branch
+        Branch.hooks.install_hook('post_change_branch_tip',
+                                  self.capture_post_change_branch_tip_hook)
+        # some branches require that their history be set to a revision in the
+        # repository
+        branch.set_last_revision_info(1, 'f\xc2\xb5')
+        self.assertEqual(len(self.hook_calls), 1)
+        self.assertEqual(self.hook_calls[0][0].branch, branch)
+        self.assertEqual(self.hook_calls[0][0].old_revid, 'foo')
+        self.assertEqual(self.hook_calls[0][0].old_revno, 2)
+        self.assertEqual(self.hook_calls[0][0].new_revid, 'f\xc2\xb5')
+        self.assertEqual(self.hook_calls[0][0].new_revno, 1)
+
+    def test_post_change_branch_tip_branch_is_locked(self):
+        branch = self.make_branch('source')
+        Branch.hooks.install_hook('post_change_branch_tip',
+                                  self.capture_post_change_branch_tip_hook)
+        branch.set_last_revision_info(0, NULL_REVISION)
+        self.assertEqual(len(self.hook_calls), 1)
+        self.assertEqual(self.hook_calls[0][0].branch, branch)
+        self.assertEqual(self.hook_calls[0][1], True)
+
+    def test_post_change_branch_tip_calls_all_hooks_no_errors(self):
+        branch = self.make_branch('source')
+        Branch.hooks.install_hook('post_change_branch_tip',
+                                  self.capture_post_change_branch_tip_hook)
+        Branch.hooks.install_hook('post_change_branch_tip',
+                                  self.capture_post_change_branch_tip_hook)
+        branch.set_last_revision_info(0, NULL_REVISION)
+        self.assertEqual(len(self.hook_calls), 2)
+        self.assertEqual(self.hook_calls[0][0].branch, branch)
+        self.assertEqual(self.hook_calls[1][0].branch, branch)

=== modified file 'bzrlib/tests/bzrdir_implementations/__init__.py'
--- bzrlib/tests/bzrdir_implementations/__init__.py	2007-06-28 06:01:18 +0000
+++ bzrlib/tests/bzrdir_implementations/__init__.py	2008-04-09 20:24:11 +0000
@@ -86,8 +86,10 @@
         return self.bzrdir
 
     def make_bzrdir(self, relpath, format=None):
+        if format is None:
+            format = self.bzrdir_format
         return super(TestCaseWithBzrDir, self).make_bzrdir(
-            relpath, format=self.bzrdir_format)
+            relpath, format=format)
 
 
 def test_suite():

=== modified file 'bzrlib/tests/bzrdir_implementations/test_bzrdir.py'
--- bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2008-03-17 04:41:06 +0000
+++ bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2008-04-10 13:30:05 +0000
@@ -537,6 +537,20 @@
             target.open_repository())
         target.open_workingtree().revert()
 
+    def test_clone_on_transport_preserves_repo_format(self):
+        if self.bzrdir_format == bzrdir.format_registry.make_bzrdir('default'):
+            format = 'knit'
+        else:
+            format = None
+        source_branch = self.make_branch('source', format=format)
+        # Ensure no format data is cached
+        a_dir = bzrlib.branch.Branch.open_from_transport(
+            self.get_transport('source')).bzrdir
+        target_transport = a_dir.root_transport.clone('..').clone('target')
+        target_bzrdir = a_dir.clone_on_transport(target_transport)
+        target_repo = target_bzrdir.open_repository()
+        self.assertEqual(target_repo._format, source_branch.repository._format)
+
     def test_revert_inventory(self):
         tree = self.make_branch_and_tree('source')
         self.build_tree(['source/foo'])

=== modified file 'bzrlib/tests/intertree_implementations/__init__.py'
--- bzrlib/tests/intertree_implementations/__init__.py	2007-06-28 07:15:28 +0000
+++ bzrlib/tests/intertree_implementations/__init__.py	2008-04-12 06:03:29 +0000
@@ -89,7 +89,7 @@
                 "mutable_trees_to_test_trees":mutable_trees_to_test_trees,
                 # workingtree_to_test_tree is set to disable changing individual,
                 # trees: instead the mutable_trees_to_test_trees helper is used.,
-                "workingtree_to_test_tree":return_parameter,
+                "_workingtree_to_test_tree": return_parameter,
                 })
             result.append(scenario)
         return result

=== modified file 'bzrlib/tests/interversionedfile_implementations/__init__.py'
--- bzrlib/tests/interversionedfile_implementations/__init__.py	2007-06-28 06:16:19 +0000
+++ bzrlib/tests/interversionedfile_implementations/__init__.py	2008-04-04 00:06:58 +0000
@@ -73,11 +73,11 @@
         """Generate the default list of interversionedfile permutations to test."""
         from bzrlib.versionedfile import InterVersionedFile
         from bzrlib.weave import WeaveFile
-        from bzrlib.knit import KnitVersionedFile
+        from bzrlib.knit import make_file_knit
         result = []
         # test the fallback InterVersionedFile from annotated knits to weave
         result.append((InterVersionedFile,
-                       KnitVersionedFile,
+                       make_file_knit,
                        WeaveFile))
         for optimiser in InterVersionedFile._optimisers:
             result.append((optimiser,

=== modified file 'bzrlib/tests/repository_implementations/test_check_reconcile.py'
--- bzrlib/tests/repository_implementations/test_check_reconcile.py	2008-03-19 04:39:04 +0000
+++ bzrlib/tests/repository_implementations/test_check_reconcile.py	2008-04-08 03:39:43 +0000
@@ -153,7 +153,7 @@
         :returns: A dict of `{version: hash}`.
         """
         vf = repo.weave_store.get_weave('a-file-id', repo.get_transaction())
-        return dict((v, vf.get_sha1(v)) for v in versions)
+        return dict(zip(versions, vf.get_sha1s(versions)))
 
     def test_reconcile_behaviour(self):
         """Populate a repository and reconcile it, verifying the state before

=== modified file 'bzrlib/tests/repository_implementations/test_fetch.py'
--- bzrlib/tests/repository_implementations/test_fetch.py	2008-01-02 03:08:59 +0000
+++ bzrlib/tests/repository_implementations/test_fetch.py	2008-04-10 06:08:55 +0000
@@ -48,7 +48,7 @@
 
     def test_fetch_knit3(self):
         # create a repository of the sort we are testing.
-        tree_a = self.make_branch_and_tree('a', '')
+        tree_a = self.make_branch_and_tree('a')
         self.build_tree(['a/foo'])
         tree_a.add('foo', 'file1')
         tree_a.commit('rev1', rev_id='rev1')
@@ -127,7 +127,7 @@
             target_repo.get_signature_text('rev1'))
 
     def make_repository_with_one_revision(self):
-        wt = self.make_branch_and_tree('source', '')
+        wt = self.make_branch_and_tree('source')
         wt.commit('rev1', allow_pointless=True, rev_id='rev1')
         return wt.branch.repository
 

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2008-03-26 21:53:32 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2008-04-10 04:22:38 +0000
@@ -797,6 +797,22 @@
             self.assertEqual([repo.bzrdir.root_transport.base],
                              [b.base for b in repo.find_branches(using=True)])
 
+    def test_set_get_make_working_trees_true(self):
+        repo = self.make_repository('repo')
+        try:
+            repo.set_make_working_trees(True)
+        except errors.RepositoryUpgradeRequired, e:
+            raise TestNotApplicable('Format does not support this flag.')
+        self.assertTrue(repo.make_working_trees())
+
+    def test_set_get_make_working_trees_false(self):
+        repo = self.make_repository('repo')
+        try:
+            repo.set_make_working_trees(False)
+        except errors.RepositoryUpgradeRequired, e:
+            raise TestNotApplicable('Format does not support this flag.')
+        self.assertFalse(repo.make_working_trees())
+
 
 class TestRepositoryLocking(TestCaseWithRepository):
 

=== modified file 'bzrlib/tests/revisionstore_implementations/test_all.py'
--- bzrlib/tests/revisionstore_implementations/test_all.py	2007-08-23 02:18:37 +0000
+++ bzrlib/tests/revisionstore_implementations/test_all.py	2008-04-04 00:06:58 +0000
@@ -37,6 +37,10 @@
         super(TestAll, self).setUp()
         self.store = self.store_factory.create(self.get_url('.'))
         self.transaction = PassThroughTransaction()
+        self.store.get_scope = self.get_transaction
+
+    def get_transaction(self):
+        return self.transaction
 
     def test_add_has_get(self):
         rev = self.add_sample_rev()

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2008-02-08 19:09:45 +0000
+++ bzrlib/tests/test_branch.py	2008-04-09 03:09:58 +0000
@@ -334,6 +334,8 @@
         self.assertTrue("pre_commit" in hooks, "pre_commit not in %s" % hooks)
         self.assertTrue("post_pull" in hooks, "post_pull not in %s" % hooks)
         self.assertTrue("post_uncommit" in hooks, "post_uncommit not in %s" % hooks)
+        self.assertTrue("post_change_branch_tip" in hooks,
+                        "post_change_branch_tip not in %s" % hooks)
 
     def test_installed_hooks_are_BranchHooks(self):
         """The installed hooks object should be a BranchHooks."""

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2008-02-13 22:11:40 +0000
+++ bzrlib/tests/test_bzrdir.py	2008-04-09 20:24:11 +0000
@@ -454,6 +454,18 @@
         branch.bzrdir.open_workingtree()
 
 
+class TestRepositoryAcquisitionPolicy(TestCaseWithTransport):
+
+    def test_acquire_repository_standalone(self):
+        """The default acquisition policy should create a standalone branch."""
+        my_bzrdir = self.make_bzrdir('.')
+        repo_policy = my_bzrdir.determine_repository_policy()
+        repo = repo_policy.acquire_repository()
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         my_bzrdir.root_transport.base)
+        self.assertFalse(repo.is_shared())
+
+
 class ChrootedTests(TestCaseWithTransport):
     """A support class that provides readonly urls outside the local namespace.
 

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2008-02-11 23:27:34 +0000
+++ bzrlib/tests/test_config.py	2008-04-04 17:11:06 +0000
@@ -33,6 +33,7 @@
     urlutils,
     tests,
     trace,
+    transport,
     )
 from bzrlib.util.configobj import configobj
 
@@ -160,6 +161,7 @@
     def __init__(self, user_id=None):
         self.email = user_id
         self.files = {}
+        self._transport = self
 
     def get_utf8(self, filename):
         if filename != 'email':
@@ -177,6 +179,9 @@
     def put(self, filename, fileobj):
         self.files[filename] = fileobj.read()
 
+    def put_file(self, filename, fileobj):
+        return self.put(filename, fileobj)
+
 
 class InstrumentedConfig(config.Config):
     """An instrumented config that supplies stubs for template methods."""
@@ -1136,6 +1141,35 @@
         self.assertEqual(value, 'value3-section')
 
 
+class TestTransportConfig(tests.TestCaseWithTransport):
+
+    def test_get_value(self):
+        """Test that retreiving a value from a section is possible"""
+        bzrdir_config = config.TransportConfig(transport.get_transport('.'),
+                                               'control.conf')
+        bzrdir_config.set_option('value', 'key', 'SECTION')
+        bzrdir_config.set_option('value2', 'key2')
+        bzrdir_config.set_option('value3-top', 'key3')
+        bzrdir_config.set_option('value3-section', 'key3', 'SECTION')
+        value = bzrdir_config.get_option('key', 'SECTION')
+        self.assertEqual(value, 'value')
+        value = bzrdir_config.get_option('key2')
+        self.assertEqual(value, 'value2')
+        self.assertEqual(bzrdir_config.get_option('non-existant'), None)
+        value = bzrdir_config.get_option('non-existant', 'SECTION')
+        self.assertEqual(value, None)
+        value = bzrdir_config.get_option('non-existant', default='default')
+        self.assertEqual(value, 'default')
+        self.assertEqual(bzrdir_config.get_option('key2', 'NOSECTION'), None)
+        value = bzrdir_config.get_option('key2', 'NOSECTION',
+                                         default='default')
+        self.assertEqual(value, 'default')
+        value = bzrdir_config.get_option('key3')
+        self.assertEqual(value, 'value3-top')
+        value = bzrdir_config.get_option('key3', 'SECTION')
+        self.assertEqual(value, 'value3-section')
+
+
 class TestAuthenticationConfigFile(tests.TestCase):
     """Test the authentication.conf file matching"""
 

=== modified file 'bzrlib/tests/test_fetch.py'
--- bzrlib/tests/test_fetch.py	2008-03-26 21:44:02 +0000
+++ bzrlib/tests/test_fetch.py	2008-04-08 00:57:07 +0000
@@ -285,9 +285,13 @@
         # unfortunately this log entry is branch format specific. We could 
         # factor out the 'what files does this format use' to a method on the 
         # repository, which would let us to this generically. RBC 20060419
+        # RBC 20080408: Or perhaps we can assert that no files are fully read
+        # twice?
         self.assertEqual(1, self._count_log_matches('/ce/id.kndx', http_logs))
         self.assertEqual(1, self._count_log_matches('/ce/id.knit', http_logs))
-        self.assertEqual(1, self._count_log_matches('inventory.kndx', http_logs))
+        # XXX: This *should* be '1', but more intrusive fetch changes are
+        # needed to drop this back to 1.
+        self.assertEqual(2, self._count_log_matches('inventory.kndx', http_logs))
         # this r-h check test will prevent regressions, but it currently already 
         # passes, before the patch to cache-rh is applied :[
         self.assertTrue(1 >= self._count_log_matches('revision-history',
@@ -311,7 +315,8 @@
         self.log('\n'.join(http_logs))
         self.assertEqual(1, self._count_log_matches('branch-format', http_logs))
         self.assertEqual(1, self._count_log_matches('branch/format', http_logs))
-        self.assertEqual(1, self._count_log_matches('repository/format', http_logs))
+        self.assertEqual(1, self._count_log_matches('repository/format',
+            http_logs))
         self.assertTrue(1 >= self._count_log_matches('revision-history',
                                                      http_logs))
         self.assertTrue(1 >= self._count_log_matches('last-revision',

=== modified file 'bzrlib/tests/test_knit.py'
--- bzrlib/tests/test_knit.py	2008-04-01 02:41:25 +0000
+++ bzrlib/tests/test_knit.py	2008-04-09 23:35:55 +0000
@@ -37,6 +37,8 @@
 from bzrlib.index import *
 from bzrlib.knit import (
     AnnotatedKnitContent,
+    DATA_SUFFIX,
+    INDEX_SUFFIX,
     KnitContent,
     KnitGraphIndex,
     KnitVersionedFile,
@@ -45,6 +47,7 @@
     _KnitAccess,
     _KnitData,
     _KnitIndex,
+    make_file_knit,
     _PackAccess,
     PlainKnitContent,
     _StreamAccess,
@@ -53,6 +56,7 @@
     KnitSequenceMatcher,
     )
 from bzrlib.osutils import split_lines
+from bzrlib.symbol_versioning import one_four
 from bzrlib.tests import (
     Feature,
     TestCase,
@@ -158,17 +162,6 @@
         self.assertEqual(content.annotate(),
             [("bogus", "text1"), ("bogus", "text2")])
 
-    def test_annotate_iter(self):
-        content = self._make_content([])
-        it = content.annotate_iter()
-        self.assertRaises(StopIteration, it.next)
-
-        content = self._make_content([("bogus", "text1"), ("bogus", "text2")])
-        it = content.annotate_iter()
-        self.assertEqual(it.next(), ("bogus", "text1"))
-        self.assertEqual(it.next(), ("bogus", "text2"))
-        self.assertRaises(StopIteration, it.next)
-
     def test_line_delta(self):
         content1 = self._make_content([("", "a"), ("", "b")])
         content2 = self._make_content([("", "a"), ("", "a"), ("", "c")])
@@ -196,17 +189,6 @@
         self.assertEqual(content.annotate(),
             [("origin1", "text1"), ("origin2", "text2")])
 
-    def test_annotate_iter(self):
-        content = self._make_content([])
-        it = content.annotate_iter()
-        self.assertRaises(StopIteration, it.next)
-
-        content = self._make_content([("origin1", "text1"), ("origin2", "text2")])
-        it = content.annotate_iter()
-        self.assertEqual(it.next(), ("origin1", "text1"))
-        self.assertEqual(it.next(), ("origin2", "text2"))
-        self.assertRaises(StopIteration, it.next)
-
     def test_line_delta(self):
         content1 = self._make_content([("", "a"), ("", "b")])
         content2 = self._make_content([("", "a"), ("", "a"), ("", "c")])
@@ -492,7 +474,7 @@
         self.addCleanup(reset)
         from bzrlib._knit_load_data_py import _load_data_py
         knit._load_data = _load_data_py
-        return _KnitIndex(*args, **kwargs)
+        return _KnitIndex(get_scope=lambda:None, *args, **kwargs)
 
     def test_no_such_file(self):
         transport = MockTransport()
@@ -677,36 +659,6 @@
         self.assertRaises(RevisionNotPresent,
             index.get_ancestry_with_ghosts, ["e"])
 
-    def test_iter_parents(self):
-        transport = MockTransport()
-        index = self.get_knit_index(transport, "filename", "w", create=True)
-        # no parents
-        index.add_version('r0', ['option'], (None, 0, 1), [])
-        # 1 parent
-        index.add_version('r1', ['option'], (None, 0, 1), ['r0'])
-        # 2 parents
-        index.add_version('r2', ['option'], (None, 0, 1), ['r1', 'r0'])
-        # XXX TODO a ghost
-        # cases: each sample data individually:
-        self.assertEqual(set([('r0', ())]),
-            set(index.iter_parents(['r0'])))
-        self.assertEqual(set([('r1', ('r0', ))]),
-            set(index.iter_parents(['r1'])))
-        self.assertEqual(set([('r2', ('r1', 'r0'))]),
-            set(index.iter_parents(['r2'])))
-        # no nodes returned for a missing node
-        self.assertEqual(set(),
-            set(index.iter_parents(['missing'])))
-        # 1 node returned with missing nodes skipped
-        self.assertEqual(set([('r1', ('r0', ))]),
-            set(index.iter_parents(['ghost1', 'r1', 'ghost'])))
-        # 2 nodes returned
-        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
-            set(index.iter_parents(['r0', 'r1'])))
-        # 2 nodes returned, missing skipped
-        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
-            set(index.iter_parents(['a', 'r0', 'b', 'r1', 'c'])))
-
     def test_num_versions(self):
         transport = MockTransport([
             _KnitIndex.HEADER
@@ -1075,22 +1027,28 @@
         self.addCleanup(reset)
         from bzrlib._knit_load_data_c import _load_data_c
         knit._load_data = _load_data_c
-        return _KnitIndex(*args, **kwargs)
-
+        return _KnitIndex(get_scope=lambda:None, *args, **kwargs)
 
 
 class KnitTests(TestCaseWithTransport):
     """Class containing knit test helper routines."""
 
     def make_test_knit(self, annotate=False, delay_create=False, index=None,
-                       name='test'):
+                       name='test', delta=True, access_mode='w'):
         if not annotate:
             factory = KnitPlainFactory()
         else:
             factory = None
-        return KnitVersionedFile(name, get_transport('.'), access_mode='w',
-                                 factory=factory, create=True,
-                                 delay_create=delay_create, index=index)
+        if index is None:
+            index = _KnitIndex(get_transport('.'), name + INDEX_SUFFIX,
+                access_mode, create=True, file_mode=None,
+                create_parent_dir=False, delay_create=delay_create,
+                dir_mode=None, get_scope=lambda:None)
+        access = _KnitAccess(get_transport('.'), name + DATA_SUFFIX, None,
+            None, delay_create, False)
+        return KnitVersionedFile(name, get_transport('.'), factory=factory,
+            create=True, delay_create=delay_create, index=index,
+            access_method=access, delta=delta)
 
     def assertRecordContentEqual(self, knit, version_id, candidate_content):
         """Assert that some raw record content matches the raw record content
@@ -1115,7 +1073,7 @@
     def test_make_explicit_index(self):
         """We can supply an index to use."""
         knit = KnitVersionedFile('test', get_transport('.'),
-            index='strangelove')
+            index='strangelove', access_method="a")
         self.assertEqual(knit._index, 'strangelove')
 
     def test_knit_add(self):
@@ -1162,7 +1120,8 @@
         k = self.make_test_knit()
         k.add_lines('text-1', [], split_lines(TEXT_1))
         del k
-        k2 = KnitVersionedFile('test', get_transport('.'), access_mode='r', factory=KnitPlainFactory(), create=True)
+        k2 = make_file_knit('test', get_transport('.'), access_mode='r',
+            factory=KnitPlainFactory(), create=True)
         self.assertTrue(k2.has_version('text-1'))
         self.assertEqualDiff(''.join(k2.get_lines('text-1')), TEXT_1)
 
@@ -1190,11 +1149,11 @@
     def test_incomplete(self):
         """Test if texts without a ending line-end can be inserted and
         extracted."""
-        k = KnitVersionedFile('test', get_transport('.'), delta=False, create=True)
+        k = make_file_knit('test', get_transport('.'), delta=False, create=True)
         k.add_lines('text-1', [], ['a\n',    'b'  ])
         k.add_lines('text-2', ['text-1'], ['a\rb\n', 'b\n'])
         # reopening ensures maximum room for confusion
-        k = KnitVersionedFile('test', get_transport('.'), delta=False, create=True)
+        k = make_file_knit('test', get_transport('.'), delta=False, create=True)
         self.assertEquals(k.get_lines('text-1'), ['a\n',    'b'  ])
         self.assertEquals(k.get_lines('text-2'), ['a\rb\n', 'b\n'])
 
@@ -1222,10 +1181,8 @@
 
     def test_add_delta(self):
         """Store in knit with parents"""
-        k = KnitVersionedFile('test', get_transport('.'), factory=KnitPlainFactory(),
-            delta=True, create=True)
+        k = self.make_test_knit(annotate=False)
         self.add_stock_one_and_one_a(k)
-        k.clear_cache()
         self.assertEqualDiff(''.join(k.get_lines('text-1a')), TEXT_1A)
 
     def test_add_delta_knit_graph_index(self):
@@ -1233,10 +1190,8 @@
         index = InMemoryGraphIndex(2)
         knit_index = KnitGraphIndex(index, add_callback=index.add_nodes,
             deltas=True)
-        k = KnitVersionedFile('test', get_transport('.'),
-            delta=True, create=True, index=knit_index)
+        k = self.make_test_knit(annotate=True, index=knit_index)
         self.add_stock_one_and_one_a(k)
-        k.clear_cache()
         self.assertEqualDiff(''.join(k.get_lines('text-1a')), TEXT_1A)
         # check the index had the right data added.
         self.assertEqual(set([
@@ -1248,8 +1203,7 @@
 
     def test_annotate(self):
         """Annotations"""
-        k = KnitVersionedFile('knit', get_transport('.'), factory=KnitAnnotateFactory(),
-            delta=True, create=True)
+        k = self.make_test_knit(annotate=True, name='knit')
         self.insert_and_test_small_annotate(k)
 
     def insert_and_test_small_annotate(self, k):
@@ -1263,8 +1217,7 @@
 
     def test_annotate_fulltext(self):
         """Annotations"""
-        k = KnitVersionedFile('knit', get_transport('.'), factory=KnitAnnotateFactory(),
-            delta=False, create=True)
+        k = self.make_test_knit(annotate=True, name='knit', delta=False)
         self.insert_and_test_small_annotate(k)
 
     def test_annotate_merge_1(self):
@@ -1341,13 +1294,13 @@
         self.assertEquals(origins[2], ('text-1', 'c\n'))
 
     def _test_join_with_factories(self, k1_factory, k2_factory):
-        k1 = KnitVersionedFile('test1', get_transport('.'), factory=k1_factory, create=True)
+        k1 = make_file_knit('test1', get_transport('.'), factory=k1_factory, create=True)
         k1.add_lines('text-a', [], ['a1\n', 'a2\n', 'a3\n'])
         k1.add_lines('text-b', ['text-a'], ['a1\n', 'b2\n', 'a3\n'])
         k1.add_lines('text-c', [], ['c1\n', 'c2\n', 'c3\n'])
         k1.add_lines('text-d', ['text-c'], ['c1\n', 'd2\n', 'd3\n'])
         k1.add_lines('text-m', ['text-b', 'text-d'], ['a1\n', 'b2\n', 'd3\n'])
-        k2 = KnitVersionedFile('test2', get_transport('.'), factory=k2_factory, create=True)
+        k2 = make_file_knit('test2', get_transport('.'), factory=k2_factory, create=True)
         count = k2.join(k1, version_ids=['text-m'])
         self.assertEquals(count, 5)
         self.assertTrue(k2.has_version('text-a'))
@@ -1374,14 +1327,14 @@
         self._test_join_with_factories(KnitPlainFactory(), None)
 
     def test_reannotate(self):
-        k1 = KnitVersionedFile('knit1', get_transport('.'),
+        k1 = make_file_knit('knit1', get_transport('.'),
                                factory=KnitAnnotateFactory(), create=True)
         # 0
         k1.add_lines('text-a', [], ['a\n', 'b\n'])
         # 1
         k1.add_lines('text-b', ['text-a'], ['a\n', 'c\n'])
 
-        k2 = KnitVersionedFile('test2', get_transport('.'),
+        k2 = make_file_knit('test2', get_transport('.'),
                                factory=KnitAnnotateFactory(), create=True)
         k2.join(k1, version_ids=['text-b'])
 
@@ -1404,8 +1357,8 @@
 
     def test_get_line_delta_texts(self):
         """Make sure we can call get_texts on text with reused line deltas"""
-        k1 = KnitVersionedFile('test1', get_transport('.'), 
-                               factory=KnitPlainFactory(), create=True)
+        k1 = make_file_knit('test1', get_transport('.'),
+            factory=KnitPlainFactory(), create=True)
         for t in range(3):
             if t == 0:
                 parents = []
@@ -1416,12 +1369,11 @@
         
     def test_iter_lines_reads_in_order(self):
         instrumented_t = get_transport('trace+memory:///')
-        k1 = KnitVersionedFile('id', instrumented_t, create=True, delta=True)
+        k1 = make_file_knit('id', instrumented_t, create=True, delta=True)
         self.assertEqual([('get', 'id.kndx',)], instrumented_t._activity)
         # add texts with no required ordering
         k1.add_lines('base', [], ['text\n'])
         k1.add_lines('base2', [], ['text2\n'])
-        k1.clear_cache()
         # clear the logged activity, but preserve the list instance in case of
         # clones pointing at it.
         del instrumented_t._activity[:]
@@ -1452,19 +1404,19 @@
             "\nrevid2 line-delta 84 82 0 :",
             'test.kndx')
         # we should be able to load this file again
-        knit = KnitVersionedFile('test', get_transport('.'), access_mode='r')
+        knit = make_file_knit('test', get_transport('.'), access_mode='r')
         self.assertEqual(['revid', 'revid2'], knit.versions())
         # write a short write to the file and ensure that its ignored
         indexfile = file('test.kndx', 'ab')
         indexfile.write('\nrevid3 line-delta 166 82 1 2 3 4 5 .phwoar:demo ')
         indexfile.close()
         # we should be able to load this file again
-        knit = KnitVersionedFile('test', get_transport('.'), access_mode='w')
+        knit = make_file_knit('test', get_transport('.'), access_mode='w')
         self.assertEqual(['revid', 'revid2'], knit.versions())
         # and add a revision with the same id the failed write had
         knit.add_lines('revid3', ['revid2'], ['a\n'])
         # and when reading it revid3 should now appear.
-        knit = KnitVersionedFile('test', get_transport('.'), access_mode='r')
+        knit = make_file_knit('test', get_transport('.'), access_mode='r')
         self.assertEqual(['revid', 'revid2', 'revid3'], knit.versions())
         self.assertEqual({'revid3':('revid2',)}, knit.get_parent_map(['revid3']))
 
@@ -1485,11 +1437,11 @@
         """create_parent_dir can create knits in nonexistant dirs"""
         # Has no effect if we don't set 'delay_create'
         trans = get_transport('.')
-        self.assertRaises(NoSuchFile, KnitVersionedFile, 'dir/test',
+        self.assertRaises(NoSuchFile, make_file_knit, 'dir/test',
                           trans, access_mode='w', factory=None,
                           create=True, create_parent_dir=True)
         # Nothing should have changed yet
-        knit = KnitVersionedFile('dir/test', trans, access_mode='w',
+        knit = make_file_knit('dir/test', trans, access_mode='w',
                                  factory=None, create=True,
                                  create_parent_dir=True,
                                  delay_create=True)
@@ -1510,12 +1462,9 @@
         if not trans._can_roundtrip_unix_modebits():
             # Can't roundtrip, so no need to run this test
             return
-        knit = KnitVersionedFile('dir/test', trans, access_mode='w',
-                                 factory=None, create=True,
-                                 create_parent_dir=True,
-                                 delay_create=True,
-                                 file_mode=0600,
-                                 dir_mode=0700)
+        knit = make_file_knit('dir/test', trans, access_mode='w', factory=None,
+            create=True, create_parent_dir=True, delay_create=True,
+            file_mode=0600, dir_mode=0700)
         knit.add_lines('revid', [], ['a\n'])
         self.assertTransportMode(trans, 'dir', 0700)
         self.assertTransportMode(trans, 'dir/test.knit', 0600)
@@ -1526,12 +1475,9 @@
         if not trans._can_roundtrip_unix_modebits():
             # Can't roundtrip, so no need to run this test
             return
-        knit = KnitVersionedFile('dir/test', trans, access_mode='w',
-                                 factory=None, create=True,
-                                 create_parent_dir=True,
-                                 delay_create=True,
-                                 file_mode=0660,
-                                 dir_mode=0770)
+        knit = make_file_knit('dir/test', trans, access_mode='w', factory=None,
+            create=True, create_parent_dir=True, delay_create=True,
+            file_mode=0660, dir_mode=0770)
         knit.add_lines('revid', [], ['a\n'])
         self.assertTransportMode(trans, 'dir', 0770)
         self.assertTransportMode(trans, 'dir/test.knit', 0660)
@@ -1542,12 +1488,9 @@
         if not trans._can_roundtrip_unix_modebits():
             # Can't roundtrip, so no need to run this test
             return
-        knit = KnitVersionedFile('dir/test', trans, access_mode='w',
-                                 factory=None, create=True,
-                                 create_parent_dir=True,
-                                 delay_create=True,
-                                 file_mode=0666,
-                                 dir_mode=0777)
+        knit = make_file_knit('dir/test', trans, access_mode='w', factory=None,
+            create=True, create_parent_dir=True, delay_create=True,
+            file_mode=0666, dir_mode=0777)
         knit.add_lines('revid', [], ['a\n'])
         self.assertTransportMode(trans, 'dir', 0777)
         self.assertTransportMode(trans, 'dir/test.knit', 0666)
@@ -1924,6 +1867,37 @@
             errors.KnitDataStreamUnknown,
             target.insert_data_stream, data_stream)
 
+    def test_insert_data_stream_bug_208418(self):
+        """You can insert a stream with an incompatible format, even when:
+          * the stream has a line-delta record,
+          * whose parent is in the target, also stored as a line-delta
+
+        See <https://launchpad.net/bugs/208418>.
+        """
+        base_lines = split_lines(TEXT_1)
+        # Make the target
+        target = self.make_test_knit(name='target', annotate=True)
+        target.add_lines('version-1', [], base_lines)
+        target.add_lines('version-2', ['version-1'], base_lines + ['a\n'])
+        # The second record should be a delta.
+        self.assertEqual('line-delta', target._index.get_method('version-2'))
+        
+        # Make a source, with a different format, but the same data
+        source = self.make_test_knit(name='source', annotate=False)
+        source.add_lines('version-1', [], base_lines)
+        source.add_lines('version-2', ['version-1'], base_lines + ['a\n'])
+        # Now add another record, which should be stored as a delta against
+        # version-2.
+        source.add_lines('version-3', ['version-2'], base_lines + ['b\n'])
+        self.assertEqual('line-delta', source._index.get_method('version-3'))
+
+        # Make a stream of the new version
+        data_stream = source.get_data_stream(['version-3'])
+        # And insert into the target
+        target.insert_data_stream(data_stream)
+        # No errors should have been raised.
+
+
     #  * test that a stream of "already present version, then new version"
     #    inserts correctly.
 
@@ -2056,7 +2030,7 @@
     def test_weave_to_knit_matches(self):
         # check that the WeaveToKnit is_compatible function
         # registers True for a Weave to a Knit.
-        w = Weave()
+        w = Weave(get_scope=lambda:None)
         k = self.make_test_knit()
         self.failUnless(WeaveToKnit.is_compatible(w, k))
         self.failIf(WeaveToKnit.is_compatible(k, w))
@@ -2064,87 +2038,6 @@
         self.failIf(WeaveToKnit.is_compatible(k, k))
 
 
-class TestKnitCaching(KnitTests):
-    
-    def create_knit(self):
-        k = self.make_test_knit(True)
-        k.add_lines('text-1', [], split_lines(TEXT_1))
-        k.add_lines('text-2', [], split_lines(TEXT_2))
-        return k
-
-    def test_no_caching(self):
-        k = self.create_knit()
-        # Nothing should be cached without setting 'enable_cache'
-        self.assertEqual({}, k._data._cache)
-
-    def test_cache_data_read_raw(self):
-        k = self.create_knit()
-
-        # Now cache and read
-        k.enable_cache()
-
-        def read_one_raw(version):
-            pos_map = k._get_components_positions([version])
-            method, index_memo, next = pos_map[version]
-            lst = list(k._data.read_records_iter_raw([(version, index_memo)]))
-            self.assertEqual(1, len(lst))
-            return lst[0]
-
-        val = read_one_raw('text-1')
-        self.assertEqual({'text-1':val[1]}, k._data._cache)
-
-        k.clear_cache()
-        # After clear, new reads are not cached
-        self.assertEqual({}, k._data._cache)
-
-        val2 = read_one_raw('text-1')
-        self.assertEqual(val, val2)
-        self.assertEqual({}, k._data._cache)
-
-    def test_cache_data_read(self):
-        k = self.create_knit()
-
-        def read_one(version):
-            pos_map = k._get_components_positions([version])
-            method, index_memo, next = pos_map[version]
-            lst = list(k._data.read_records_iter([(version, index_memo)]))
-            self.assertEqual(1, len(lst))
-            return lst[0]
-
-        # Now cache and read
-        k.enable_cache()
-
-        val = read_one('text-2')
-        self.assertEqual(['text-2'], k._data._cache.keys())
-        self.assertEqual('text-2', val[0])
-        content, digest = k._data._parse_record('text-2',
-                                                k._data._cache['text-2'])
-        self.assertEqual(content, val[1])
-        self.assertEqual(digest, val[2])
-
-        k.clear_cache()
-        self.assertEqual({}, k._data._cache)
-
-        val2 = read_one('text-2')
-        self.assertEqual(val, val2)
-        self.assertEqual({}, k._data._cache)
-
-    def test_cache_read(self):
-        k = self.create_knit()
-        k.enable_cache()
-
-        text = k.get_text('text-1')
-        self.assertEqual(TEXT_1, text)
-        self.assertEqual(['text-1'], k._data._cache.keys())
-
-        k.clear_cache()
-        self.assertEqual({}, k._data._cache)
-
-        text = k.get_text('text-1')
-        self.assertEqual(TEXT_1, text)
-        self.assertEqual({}, k._data._cache)
-
-
 class TestKnitIndex(KnitTests):
 
     def test_add_versions_dictionary_compresses(self):
@@ -2485,40 +2378,6 @@
              ('tip', 'no-eol,line-delta', (None, 0, 100), ['parent'])])
         self.assertEqual([], self.caught_entries)
 
-    def test_iter_parents(self):
-        index1 = self.make_g_index('1', 1, [
-        # no parents
-            (('r0', ), 'N0 100', ([], )),
-        # 1 parent
-            (('r1', ), '', ([('r0', )], ))])
-        index2 = self.make_g_index('2', 1, [
-        # 2 parents
-            (('r2', ), 'N0 100', ([('r1', ), ('r0', )], )),
-            ])
-        combined_index = CombinedGraphIndex([index1, index2])
-        index = KnitGraphIndex(combined_index)
-        # XXX TODO a ghost
-        # cases: each sample data individually:
-        self.assertEqual(set([('r0', ())]),
-            set(index.iter_parents(['r0'])))
-        self.assertEqual(set([('r1', ('r0', ))]),
-            set(index.iter_parents(['r1'])))
-        self.assertEqual(set([('r2', ('r1', 'r0'))]),
-            set(index.iter_parents(['r2'])))
-        # no nodes returned for a missing node
-        self.assertEqual(set(),
-            set(index.iter_parents(['missing'])))
-        # 1 node returned with missing nodes skipped
-        self.assertEqual(set([('r1', ('r0', ))]),
-            set(index.iter_parents(['ghost1', 'r1', 'ghost'])))
-        # 2 nodes returned
-        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
-            set(index.iter_parents(['r0', 'r1'])))
-        # 2 nodes returned, missing skipped
-        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
-            set(index.iter_parents(['a', 'r0', 'b', 'r1', 'c'])))
-
-
 class TestNoParentsGraphIndexKnit(KnitTests):
     """Tests for knits using KnitGraphIndex with no parents."""
 
@@ -2736,18 +2595,6 @@
              ('tip', 'no-eol,line-delta', (None, 0, 100), [])])
         self.assertEqual([], self.caught_entries)
 
-    def test_iter_parents(self):
-        index = self.two_graph_index()
-        self.assertEqual(set([
-            ('tip', ()), ('tail', ()), ('parent', ()), ('separate', ())
-            ]),
-            set(index.iter_parents(['tip', 'tail', 'ghost', 'parent', 'separate'])))
-        self.assertEqual(set([('tip', ())]),
-            set(index.iter_parents(['tip'])))
-        self.assertEqual(set(),
-            set(index.iter_parents([])))
-
-
 class TestPackKnits(KnitTests):
     """Tests that use a _PackAccess and KnitGraphIndex."""
 
@@ -2802,11 +2649,6 @@
             set(result),
             set(index.get_ancestry(ancestry_versions, False)))
 
-    def assertIterParents(self, knit, versions, parent_versions, result):
-        """Check the result of an iter_parents call on knit."""
-        index = self.get_index(knit, knit.get_data_stream(versions))
-        self.assertEqual(result, index.iter_parents(parent_versions))
-
     def assertGetMethod(self, knit, versions, version, result):
         index = self.get_index(knit, knit.get_data_stream(versions))
         self.assertEqual(result, index.get_method(version))
@@ -2877,19 +2719,6 @@
         # we thunk across.
         self.assertGetMethod(knit, ['c'], 'b', 'fulltext')
 
-    def test_iter_parents(self):
-        knit = self.make_knit_with_4_versions_2_dags()
-        self.assertIterParents(knit, ['a'], ['a'], [('a', ())])
-        self.assertIterParents(knit, ['a', 'b'], ['a', 'b'],
-            [('a', ()), ('b', ())])
-        self.assertIterParents(knit, ['a', 'b', 'c'], ['a', 'b', 'c'],
-            [('a', ()), ('b', ()), ('c', ('b', 'a'))])
-        self.assertIterParents(knit, ['a', 'b', 'c', 'd'],
-            ['a', 'b', 'c', 'd'],
-            [('a', ()), ('b', ()), ('c', ('b', 'a')), ('d', ('e', 'f'))])
-        self.assertIterParents(knit, ['c'], ['a', 'b', 'c'],
-            [('c', ('b', 'a'))])
-
     def test_get_options(self):
         knit = self.make_knit_with_4_versions_2_dags()
         self.assertGetOptions(knit, 'a', ['no-eol', 'fulltext'])
@@ -2981,3 +2810,13 @@
             knit.get_data_stream([]))
         self.assertRaises(errors.KnitCorrupt,
             list, access.get_raw_records([(True, "A", None, None)]))
+
+
+class TestFormatSignatures(KnitTests):
+
+    def test_knit_format_signatures(self):
+        """Different formats of knit have different signature strings."""
+        knit = self.make_test_knit(name='a', annotate=True)
+        self.assertEqual('knit-annotated', knit.get_format_signature())
+        knit = self.make_test_knit(name='p', annotate=False)
+        self.assertEqual('knit-plain', knit.get_format_signature())

=== modified file 'bzrlib/tests/test_log.py'
--- bzrlib/tests/test_log.py	2008-03-26 21:42:35 +0000
+++ bzrlib/tests/test_log.py	2008-04-18 17:54:34 +0000
@@ -891,6 +891,20 @@
         # f3 should be marked as modified by revisions A, B, C, and D
         self.assertAllRevisionsForFileID(tree, 'f2-id', ['D', 'C', 'A'])
 
+    def test_file_id_with_ghosts(self):
+        # This is testing bug #209948, where having a ghost would cause
+        # _filter_revisions_touching_file_id() to fail.
+        tree = self.create_tree_with_single_merge()
+        # We need to add a revision, so switch back to a write-locked tree
+        tree.unlock()
+        tree.lock_write()
+        first_parent = tree.last_revision()
+        tree.set_parent_ids([first_parent, 'ghost-revision-id'])
+        self.build_tree_contents([('tree/f1', 'A\nB\nXX\n')])
+        tree.commit('commit with a ghost', rev_id='XX')
+        self.assertAllRevisionsForFileID(tree, 'f1-id', ['XX', 'B', 'A'])
+        self.assertAllRevisionsForFileID(tree, 'f2-id', ['D', 'C', 'A'])
+
 
 class TestShowChangedRevisions(TestCaseWithTransport):
 

=== modified file 'bzrlib/tests/test_mail_client.py'
--- bzrlib/tests/test_mail_client.py	2008-04-01 04:19:06 +0000
+++ bzrlib/tests/test_mail_client.py	2008-04-13 11:48:00 +0000
@@ -71,27 +71,34 @@
                 'Command-line item %r is unicode!' % item)
 
 
-class TestEmacsMailMode(tests.TestCase):
+class TestEmacsMail(tests.TestCase):
 
     def test_commandline(self):
-        eclient = mail_client.EmacsMailMode(None)
-        commandline = eclient._get_compose_commandline(None, None, 'file%')
-        self.assertEqual(['--eval', '(mail nil nil nil)',
-                          '(mail-text)', '(newline)',
-                          '(attach "file%")'], commandline)
+        eclient = mail_client.EmacsMail(None)
+
+        commandline = eclient._get_compose_commandline(None, 'Hi there!', None)
+        self.assertEqual(['--eval', '(compose-mail nil "Hi there!")'],
+                         commandline)
 
         commandline = eclient._get_compose_commandline('jrandom@example.org',
-                                                     'Hi there!', None)
-        self.assertEqual(['--eval', '(mail nil "jrandom@example.org" "Hi there!")',
-                          '(mail-text)', '(newline)'], commandline)
+                                                       'Hi there!', None)
+        self.assertEqual(['--eval',
+                          '(compose-mail "jrandom@example.org" "Hi there!")'],
+                         commandline)
+
+        # We won't be able to know the temporary file name at this stage
+        # so we can't raise an assertion with assertEqual
+        cmdline = eclient._get_compose_commandline(None, None, 'file%')
+        commandline = ' '.join(cmdline)
+        self.assertContainsRe(commandline, '--eval')
+        self.assertContainsRe(commandline, '(compose-mail nil nil)')
+        self.assertContainsRe(commandline, '(load .*)')
+        self.assertContainsRe(commandline, '(bzr-add-mime-att \"file%\")')
 
     def test_commandline_is_8bit(self):
-        eclient = mail_client.EmacsMailMode(None)
+        eclient = mail_client.EmacsMail(None)
         commandline = eclient._get_compose_commandline(u'jrandom@example.org',
             u'Hi there!', u'file%')
-        self.assertEqual(['--eval', '(mail nil "jrandom@example.org" "Hi there!")',
-                          '(mail-text)', '(newline)',
-                          '(attach "file%")'], commandline)
         for item in commandline:
             self.assertFalse(isinstance(item, unicode),
                 'Command-line item %r is unicode!' % item)

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2008-03-15 14:22:50 +0000
+++ bzrlib/tests/test_merge.py	2008-04-07 04:54:52 +0000
@@ -450,13 +450,27 @@
         finally:
             tree_file.close()
 
+    def test_merge_add_into_deleted_root(self):
+        # Yes, people actually do this.  And report bugs if it breaks.
+        source = self.make_branch_and_tree('source', format='rich-root-pack')
+        self.build_tree(['source/foo/'])
+        source.add('foo', 'foo-id')
+        source.commit('Add foo')
+        target = source.bzrdir.sprout('target').open_workingtree()
+        subtree = target.extract('foo-id')
+        subtree.commit('Delete root')
+        self.build_tree(['source/bar'])
+        source.add('bar', 'bar-id')
+        source.commit('Add bar')
+        subtree.merge_from_branch(source.branch)
+
 
 class TestPlanMerge(TestCaseWithMemoryTransport):
 
     def setUp(self):
         TestCaseWithMemoryTransport.setUp(self)
-        self.vf = knit.KnitVersionedFile('root', self.get_transport(),
-                                         create=True)
+        self.vf = knit.make_file_knit('root', self.get_transport(),
+            create=True)
         self.plan_merge_vf = versionedfile._PlanMergeVersionedFile('root',
                                                                    [self.vf])
 

=== modified file 'bzrlib/tests/test_reconfigure.py'
--- bzrlib/tests/test_reconfigure.py	2008-04-08 05:53:35 +0000
+++ bzrlib/tests/test_reconfigure.py	2008-04-24 04:58:42 +0000
@@ -304,6 +304,72 @@
         self.assertRaises(errors.NoRepositoryPresent,
                           repository.Repository.open, 'repo')
 
+    def test_standalone_to_use_shared(self):
+        self.build_tree(['root/'])
+        tree = self.make_branch_and_tree('root/tree')
+        tree.commit('Hello', rev_id='hello-id')
+        repo = self.make_repository('root', shared=True)
+        reconfiguration = reconfigure.Reconfigure.to_use_shared(tree.bzrdir)
+        reconfiguration.apply()
+        tree = workingtree.WorkingTree.open('root/tree')
+        self.assertTrue(repo.has_same_location(tree.branch.repository))
+        self.assertEqual('Hello', repo.get_revision('hello-id').message)
+
+    def add_dead_head(self, tree):
+        revno, revision_id = tree.branch.last_revision_info()
+        tree.commit('Dead head', rev_id='dead-head-id')
+        tree.branch.set_last_revision_info(revno, revision_id)
+        tree.set_last_revision(revision_id)
+
+    def test_standalone_to_use_shared_preserves_dead_heads(self):
+        self.build_tree(['root/'])
+        tree = self.make_branch_and_tree('root/tree')
+        self.add_dead_head(tree)
+        tree.commit('Hello', rev_id='hello-id')
+        repo = self.make_repository('root', shared=True)
+        reconfiguration = reconfigure.Reconfigure.to_use_shared(tree.bzrdir)
+        reconfiguration.apply()
+        tree = workingtree.WorkingTree.open('root/tree')
+        message = repo.get_revision('dead-head-id').message
+        self.assertEqual('Dead head', message)
+
+    def make_repository_tree(self):
+        self.build_tree(['root/'])
+        repo = self.make_repository('root', shared=True)
+        tree = self.make_branch_and_tree('root/tree')
+        reconfigure.Reconfigure.to_use_shared(tree.bzrdir).apply()
+        return workingtree.WorkingTree.open('root/tree')
+
+    def test_use_shared_to_use_shared(self):
+        tree = self.make_repository_tree()
+        self.assertRaises(errors.AlreadyUsingShared,
+                          reconfigure.Reconfigure.to_use_shared, tree.bzrdir)
+
+    def test_use_shared_to_standalone(self):
+        tree = self.make_repository_tree()
+        tree.commit('Hello', rev_id='hello-id')
+        reconfigure.Reconfigure.to_standalone(tree.bzrdir).apply()
+        tree = workingtree.WorkingTree.open('root/tree')
+        repo = tree.branch.repository
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         tree.bzrdir.root_transport.base)
+        self.assertEqual('Hello', repo.get_revision('hello-id').message)
+
+    def test_use_shared_to_standalone_preserves_dead_heads(self):
+        tree = self.make_repository_tree()
+        self.add_dead_head(tree)
+        tree.commit('Hello', rev_id='hello-id')
+        reconfigure.Reconfigure.to_standalone(tree.bzrdir).apply()
+        tree = workingtree.WorkingTree.open('root/tree')
+        repo = tree.branch.repository
+        self.assertRaises(errors.NoSuchRevision, repo.get_revision,
+                          'dead-head-id')
+
+    def test_standalone_to_standalone(self):
+        tree = self.make_branch_and_tree('tree')
+        self.assertRaises(errors.AlreadyStandalone,
+                          reconfigure.Reconfigure.to_standalone, tree.bzrdir)
+
     def make_unsynced_branch_reconfiguration(self):
         parent = self.make_branch_and_tree('parent')
         parent.commit('commit 1')

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2008-04-01 11:59:07 +0000
+++ bzrlib/tests/test_remote.py	2008-04-08 07:44:39 +0000
@@ -136,27 +136,36 @@
         """Create a FakeClient.
 
         :param responses: A list of response-tuple, body-data pairs to be sent
-            back to callers.
+            back to callers.  A special case is if the response-tuple is
+            'unknown verb', then a UnknownSmartMethod will be raised for that
+            call, using the second element of the tuple as the verb in the
+            exception.
         """
         self.responses = responses
         self._calls = []
         self.expecting_body = False
         _SmartClient.__init__(self, FakeMedium(self._calls), fake_medium_base)
 
+    def _get_next_response(self):
+        response_tuple = self.responses.pop(0)
+        if response_tuple[0][0] == 'unknown verb':
+            raise errors.UnknownSmartMethod(response_tuple[0][1])
+        return response_tuple
+
     def call(self, method, *args):
         self._calls.append(('call', method, args))
-        return self.responses.pop(0)[0]
+        return self._get_next_response()[0]
 
     def call_expecting_body(self, method, *args):
         self._calls.append(('call_expecting_body', method, args))
-        result = self.responses.pop(0)
+        result = self._get_next_response()
         self.expecting_body = True
         return result[0], FakeProtocol(result[1], self)
 
     def call_with_body_bytes_expecting_body(self, method, args, body):
         self._calls.append(('call_with_body_bytes_expecting_body', method,
             args, body))
-        result = self.responses.pop(0)
+        result = self._get_next_response()
         self.expecting_body = True
         return result[0], FakeProtocol(result[1], self)
 
@@ -315,6 +324,24 @@
             RemoteBzrDirFormat.probe_transport, OldServerTransport())
 
 
+class TestBzrDirOpenRepository(tests.TestCase):
+
+    def test_backwards_compat_1_2(self):
+        transport = MemoryTransport()
+        transport.mkdir('quack')
+        transport = transport.clone('quack')
+        client = FakeClient([
+            (('unknown verb', 'RemoteRepository.find_repositoryV2'), ''),
+            (('ok', '', 'no', 'no'), ''),],
+            transport.base)
+        bzrdir = RemoteBzrDir(transport, _client=client)
+        repo = bzrdir.open_repository()
+        self.assertEqual(
+            [('call', 'BzrDir.find_repositoryV2', ('quack/',)),
+             ('call', 'BzrDir.find_repository', ('quack/',))],
+            client._calls)
+
+
 class OldSmartClient(object):
     """A fake smart client for test_old_version that just returns a version one
     response to the 'hello' (query version) command.
@@ -467,6 +494,114 @@
         branch.unlock()
 
 
+class TestBranchSetLastRevisionInfo(tests.TestCase):
+
+    def test_set_last_revision_info(self):
+        # set_last_revision_info(num, 'rev-id') is translated to calling
+        # Branch.set_last_revision_info(num, 'rev-id') on the wire.
+        transport = MemoryTransport()
+        transport.mkdir('branch')
+        transport = transport.clone('branch')
+        client = FakeClient([
+            # lock_write
+            (('ok', 'branch token', 'repo token'), ),
+            # set_last_revision_info
+            (('ok',), ),
+            # unlock
+            (('ok',), )], transport.base)
+
+        bzrdir = RemoteBzrDir(transport, _client=False)
+        branch = RemoteBranch(bzrdir, None, _client=client)
+        # This is a hack to work around the problem that RemoteBranch currently
+        # unnecessarily invokes _ensure_real upon a call to lock_write.
+        branch._ensure_real = lambda: None
+        # Lock the branch, reset the record of remote calls.
+        branch.lock_write()
+        client._calls = []
+        result = branch.set_last_revision_info(1234, 'a-revision-id')
+        self.assertEqual(
+            [('call', 'Branch.set_last_revision_info',
+                ('branch/', 'branch token', 'repo token',
+                 '1234', 'a-revision-id'))],
+            client._calls)
+        self.assertEqual(None, result)
+
+    def test_no_such_revision(self):
+        # A response of 'NoSuchRevision' is translated into an exception.
+        client = FakeClient([
+            # lock_write
+            (('ok', 'branch token', 'repo token'), ),
+            # set_last_revision_info
+            (('NoSuchRevision', 'revid'), ),
+            # unlock
+            (('ok',), ),
+            ])
+        transport = MemoryTransport()
+        transport.mkdir('branch')
+        transport = transport.clone('branch')
+
+        bzrdir = RemoteBzrDir(transport, _client=False)
+        branch = RemoteBranch(bzrdir, None, _client=client)
+        # This is a hack to work around the problem that RemoteBranch currently
+        # unnecessarily invokes _ensure_real upon a call to lock_write.
+        branch._ensure_real = lambda: None
+        # Lock the branch, reset the record of remote calls.
+        branch.lock_write()
+        client._calls = []
+
+        self.assertRaises(
+            errors.NoSuchRevision, branch.set_last_revision_info, 123, 'revid')
+        branch.unlock()
+
+    def lock_remote_branch(self, branch):
+        """Trick a RemoteBranch into thinking it is locked."""
+        branch._lock_mode = 'w'
+        branch._lock_count = 2
+        branch._lock_token = 'branch token'
+        branch._repo_lock_token = 'repo token'
+
+    def test_backwards_compatibility(self):
+        """If the server does not support the Branch.set_last_revision_info
+        verb (which is new in 1.4), then the client falls back to VFS methods.
+        """
+        # This test is a little messy.  Unlike most tests in this file, it
+        # doesn't purely test what a Remote* object sends over the wire, and
+        # how it reacts to responses from the wire.  It instead relies partly
+        # on asserting that the RemoteBranch will call
+        # self._real_branch.set_last_revision_info(...).
+
+        # First, set up our RemoteBranch with a FakeClient that raises
+        # UnknownSmartMethod, and a StubRealBranch that logs how it is called.
+        transport = MemoryTransport()
+        transport.mkdir('branch')
+        transport = transport.clone('branch')
+        client = FakeClient(
+            [(('unknown verb', 'Branch.set_last_revision_info',), ),],
+            transport.base)
+        bzrdir = RemoteBzrDir(transport, _client=False)
+        branch = RemoteBranch(bzrdir, None, _client=client)
+        class StubRealBranch(object):
+            def __init__(self):
+                self.calls = []
+            def set_last_revision_info(self, revno, revision_id):
+                self.calls.append(
+                    ('set_last_revision_info', revno, revision_id))
+        real_branch = StubRealBranch()
+        branch._real_branch = real_branch
+        self.lock_remote_branch(branch)
+
+        # Call set_last_revision_info, and verify it behaved as expected.
+        result = branch.set_last_revision_info(1234, 'a-revision-id')
+        self.assertEqual(
+            [('call', 'Branch.set_last_revision_info',
+                ('branch/', 'branch token', 'repo token',
+                 '1234', 'a-revision-id')),],
+            client._calls)
+        self.assertEqual(
+            [('set_last_revision_info', 1234, 'a-revision-id')],
+            real_branch.calls)
+
+
 class TestBranchControlGetBranchConf(tests.TestCaseWithMemoryTransport):
     """Test branch.control_files api munging...
 
@@ -536,23 +671,7 @@
         advisory anyway (a transport could be read-write, but then the
         underlying filesystem could be readonly anyway).
         """
-        client = FakeClient([(
-            ('error', "Generic bzr smart protocol error: "
-                      "bad request 'Transport.is_readonly'"), '')])
-        transport = RemoteTransport('bzr://example.com/', medium=False,
-                                    _client=client)
-        self.assertEqual(False, transport.is_readonly())
-        self.assertEqual(
-            [('call', 'Transport.is_readonly', ())],
-            client._calls)
-
-    def test_error_from_old_0_11_server(self):
-        """Same as test_error_from_old_server, but with the slightly different
-        error message from bzr 0.11 servers.
-        """
-        client = FakeClient([(
-            ('error', "Generic bzr smart protocol error: "
-                      "bad request u'Transport.is_readonly'"), '')])
+        client = FakeClient([(('unknown verb', 'Transport.is_readonly'), '')])
         transport = RemoteTransport('bzr://example.com/', medium=False,
                                     _client=client)
         self.assertEqual(False, transport.is_readonly())
@@ -704,17 +823,18 @@
         repo.unlock()
 
     def test_get_parent_map_reconnects_if_unknown_method(self):
-        error_msg = (
-            "Generic bzr smart protocol error: "
-            "bad request 'Repository.get_parent_map'")
         responses = [
-            (('error', error_msg), ''),
+            (('unknown verb', 'Repository.get_parent_map'), ''),
             (('ok',), '')]
         transport_path = 'quack'
         repo, client = self.setup_fake_client_and_repository(
             responses, transport_path)
         rev_id = 'revision-id'
-        parents = repo.get_parent_map([rev_id])
+        expected_deprecations = [
+            'bzrlib.remote.RemoteRepository.get_revision_graph was deprecated '
+            'in version 1.4.']
+        parents = self.callDeprecated(
+            expected_deprecations, repo.get_parent_map, [rev_id])
         self.assertEqual(
             [('call_with_body_bytes_expecting_body',
               'Repository.get_parent_map', ('quack/', rev_id), '\n\n0'),
@@ -723,6 +843,13 @@
               ('quack/', ''))],
             client._calls)
 
+    def test_get_parent_map_unexpected_response(self):
+        responses = [
+            (('something unexpected!',), '')]
+        repo, client = self.setup_fake_client_and_repository(responses, 'path')
+        self.assertRaises(
+            errors.UnexpectedSmartServerResponse,
+            repo.get_parent_map, ['a-revision-id'])
 
 
 class TestRepositoryGetRevisionGraph(TestRemoteRepository):
@@ -989,11 +1116,8 @@
     
     def test_backwards_compatibility(self):
         """If the server doesn't recognise this request, fallback to VFS."""
-        error_msg = (
-            "Generic bzr smart protocol error: "
-            "bad request 'Repository.stream_revisions_chunked'")
         responses = [
-            (('error', error_msg), '')]
+            (('unknown verb', 'Repository.stream_revisions_chunked'), '')]
         repo, client = self.setup_fake_client_and_repository(
             responses, 'path')
         self.mock_called = False

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2008-03-26 21:44:40 +0000
+++ bzrlib/tests/test_selftest.py	2008-04-11 23:05:02 +0000
@@ -510,18 +510,18 @@
         self.assertEqual(tests[0].bzrdir_format, formats[0][1])
         self.assertEqual(tests[0].transport_server, server1)
         self.assertEqual(tests[0].transport_readonly_server, server2)
-        self.assertEqual(tests[0].workingtree_to_test_tree, return_parameter)
+        self.assertEqual(tests[0]._workingtree_to_test_tree, return_parameter)
         self.assertEqual(tests[1].workingtree_format, formats[1][0])
         self.assertEqual(tests[1].bzrdir_format, formats[1][1])
         self.assertEqual(tests[1].transport_server, server1)
         self.assertEqual(tests[1].transport_readonly_server, server2)
-        self.assertEqual(tests[1].workingtree_to_test_tree, return_parameter)
+        self.assertEqual(tests[1]._workingtree_to_test_tree, return_parameter)
         self.assertIsInstance(tests[2].workingtree_format, default_format)
         #self.assertEqual(tests[2].bzrdir_format,
         #                 default_format._matchingbzrdir)
         self.assertEqual(tests[2].transport_server, server1)
         self.assertEqual(tests[2].transport_readonly_server, server2)
-        self.assertEqual(tests[2].workingtree_to_test_tree,
+        self.assertEqual(tests[2]._workingtree_to_test_tree,
             revision_tree_from_workingtree)
 
 
@@ -562,14 +562,14 @@
         self.assertEqual(tests[0].workingtree_format, formats[0][1])
         self.assertEqual(tests[0].workingtree_format_to, formats[0][2])
         self.assertEqual(tests[0].mutable_trees_to_test_trees, formats[0][3])
-        self.assertEqual(tests[0].workingtree_to_test_tree, return_parameter)
+        self.assertEqual(tests[0]._workingtree_to_test_tree, return_parameter)
         self.assertEqual(tests[0].transport_server, server1)
         self.assertEqual(tests[0].transport_readonly_server, server2)
         self.assertEqual(tests[1].intertree_class, formats[1][0])
         self.assertEqual(tests[1].workingtree_format, formats[1][1])
         self.assertEqual(tests[1].workingtree_format_to, formats[1][2])
         self.assertEqual(tests[1].mutable_trees_to_test_trees, formats[1][3])
-        self.assertEqual(tests[1].workingtree_to_test_tree, return_parameter)
+        self.assertEqual(tests[1]._workingtree_to_test_tree, return_parameter)
         self.assertEqual(tests[1].transport_server, server1)
         self.assertEqual(tests[1].transport_readonly_server, server2)
 
@@ -921,7 +921,7 @@
         test.run(result)
         self.assertEqual(
             [
-            ('update', '[2 in 0s, 3 known failures] passing_test', None, None),
+            ('update', '[2 in 0s] passing_test', None, None),
             ],
             pb.calls[2:])
 
@@ -997,7 +997,7 @@
         test.run(result)
         self.assertEqual(
             [
-            ('update', '[2 in 0s, 2 missing features] passing_test', None, None),
+            ('update', '[2 in 0s, 2 missing] passing_test', None, None),
             ],
             pb.calls[1:])
     

=== modified file 'bzrlib/tests/test_smart.py'
--- bzrlib/tests/test_smart.py	2008-03-27 06:10:18 +0000
+++ bzrlib/tests/test_smart.py	2008-04-08 08:13:33 +0000
@@ -476,6 +476,70 @@
             tree.branch.unlock()
 
 
+class TestSmartServerBranchRequestSetLastRevisionInfo(tests.TestCaseWithTransport):
+
+    def lock_branch(self, branch):
+        branch_token = branch.lock_write()
+        repo_token = branch.repository.lock_write()
+        branch.repository.unlock()
+        self.addCleanup(branch.unlock)
+        return branch_token, repo_token
+
+    def make_locked_branch(self, format=None):
+        branch = self.make_branch('.', format=format)
+        branch_token, repo_token = self.lock_branch(branch)
+        return branch, branch_token, repo_token
+
+    def test_empty(self):
+        """An empty branch can have its last revision set to 'null:'."""
+        b, branch_token, repo_token = self.make_locked_branch()
+        backing = self.get_transport()
+        request = smart.branch.SmartServerBranchRequestSetLastRevisionInfo(
+            backing)
+        response = request.execute('', branch_token, repo_token, '0', 'null:')
+        self.assertEqual(SmartServerResponse(('ok',)), response)
+
+    def assertBranchLastRevisionInfo(self, expected_info, branch_relpath):
+        branch = bzrdir.BzrDir.open(branch_relpath).open_branch()
+        self.assertEqual(expected_info, branch.last_revision_info())
+
+    def test_branch_revision_info_is_updated(self):
+        """This method really does update the branch last revision info."""
+        tree = self.make_branch_and_memory_tree('.')
+        tree.lock_write()
+        tree.add('')
+        tree.commit('First commit', rev_id='revision-1')
+        tree.commit('Second commit', rev_id='revision-2')
+        tree.unlock()
+        branch = tree.branch
+
+        branch_token, repo_token = self.lock_branch(branch)
+        backing = self.get_transport()
+        request = smart.branch.SmartServerBranchRequestSetLastRevisionInfo(
+            backing)
+        self.assertBranchLastRevisionInfo((2, 'revision-2'), '.')
+        response = request.execute(
+            '', branch_token, repo_token, '1', 'revision-1')
+        self.assertEqual(SmartServerResponse(('ok',)), response)
+        self.assertBranchLastRevisionInfo((1, 'revision-1'), '.')
+
+    def test_not_present_revid(self):
+        """Some branch formats will check that the revision is present in the
+        repository.  When that check fails, a NoSuchRevision error is returned
+        to the client.
+        """
+        # Make a knit format branch, because that format checks the values
+        # given to set_last_revision_info.
+        b, branch_token, repo_token = self.make_locked_branch(format='knit')
+        backing = self.get_transport()
+        request = smart.branch.SmartServerBranchRequestSetLastRevisionInfo(
+            backing)
+        response = request.execute(
+            '', branch_token, repo_token, '1', 'not-present')
+        self.assertEqual(
+            SmartServerResponse(('NoSuchRevision', 'not-present')), response)
+
+
 class TestSmartServerBranchRequestLockWrite(tests.TestCaseWithMemoryTransport):
 
     def setUp(self):
@@ -1014,6 +1078,9 @@
             smart.request.request_handlers.get('Branch.set_last_revision'),
             smart.branch.SmartServerBranchRequestSetLastRevision)
         self.assertEqual(
+            smart.request.request_handlers.get('Branch.set_last_revision_info'),
+            smart.branch.SmartServerBranchRequestSetLastRevisionInfo)
+        self.assertEqual(
             smart.request.request_handlers.get('Branch.unlock'),
             smart.branch.SmartServerBranchRequestUnlock)
         self.assertEqual(

=== modified file 'bzrlib/tests/test_smart_transport.py'
--- bzrlib/tests/test_smart_transport.py	2008-04-01 02:16:14 +0000
+++ bzrlib/tests/test_smart_transport.py	2008-04-14 08:07:08 +0000
@@ -433,6 +433,7 @@
         # now disconnect again: this should not do anything, if disconnection
         # really did disconnect.
         medium.disconnect()
+
     
     def test_tcp_client_ignores_disconnect_when_not_connected(self):
         # Doing a disconnect on a new (and thus unconnected) TCP medium
@@ -732,6 +733,68 @@
         server._serve_one_request(SampleRequest('x'))
         self.assertTrue(server.finished)
         
+    def test_socket_stream_incomplete_request(self):
+        """The medium should still construct the right protocol version even if
+        the initial read only reads part of the request.
+
+        Specifically, it should correctly read the protocol version line even
+        if the partial read doesn't end in a newline.  An older, naive
+        implementation of _get_line in the server used to have a bug in that
+        case.
+        """
+        incomplete_request_bytes = protocol.REQUEST_VERSION_TWO + 'hel'
+        rest_of_request_bytes = 'lo\n'
+        expected_response = (
+            protocol.RESPONSE_VERSION_TWO + 'success\nok\x012\n')
+        server_sock, client_sock = self.portable_socket_pair()
+        server = medium.SmartServerSocketStreamMedium(
+            server_sock, None)
+        client_sock.sendall(incomplete_request_bytes)
+        server_protocol = server._build_protocol()
+        client_sock.sendall(rest_of_request_bytes)
+        server._serve_one_request(server_protocol)
+        server_sock.close()
+        self.assertEqual(expected_response, client_sock.recv(50),
+                         "Not a version 2 response to 'hello' request.")
+        self.assertEqual('', client_sock.recv(1))
+
+    def test_pipe_stream_incomplete_request(self):
+        """The medium should still construct the right protocol version even if
+        the initial read only reads part of the request.
+
+        Specifically, it should correctly read the protocol version line even
+        if the partial read doesn't end in a newline.  An older, naive
+        implementation of _get_line in the server used to have a bug in that
+        case.
+        """
+        incomplete_request_bytes = protocol.REQUEST_VERSION_TWO + 'hel'
+        rest_of_request_bytes = 'lo\n'
+        expected_response = (
+            protocol.RESPONSE_VERSION_TWO + 'success\nok\x012\n')
+        # Make a pair of pipes, to and from the server
+        to_server, to_server_w = os.pipe()
+        from_server_r, from_server = os.pipe()
+        to_server = os.fdopen(to_server, 'r', 0)
+        to_server_w = os.fdopen(to_server_w, 'w', 0)
+        from_server_r = os.fdopen(from_server_r, 'r', 0)
+        from_server = os.fdopen(from_server, 'w', 0)
+        server = medium.SmartServerPipeStreamMedium(
+            to_server, from_server, None)
+        # Like test_socket_stream_incomplete_request, write an incomplete
+        # request (that does not end in '\n') and build a protocol from it.
+        to_server_w.write(incomplete_request_bytes)
+        server_protocol = server._build_protocol()
+        # Send the rest of the request, and finish serving it.
+        to_server_w.write(rest_of_request_bytes)
+        server._serve_one_request(server_protocol)
+        to_server_w.close()
+        from_server.close()
+        self.assertEqual(expected_response, from_server_r.read(),
+                         "Not a version 2 response to 'hello' request.")
+        self.assertEqual('', from_server_r.read(1))
+        from_server_r.close()
+        to_server.close()
+
     def test_pipe_like_stream_with_two_requests(self):
         # If two requests are read in one go, then two calls to
         # _serve_one_request should still process both of them as if they had
@@ -1307,14 +1370,6 @@
             transport._translate_error, ("ReadOnlyError", ))
 
 
-class InstrumentedServerProtocol(medium.SmartServerStreamMedium):
-    """A smart server which is backed by memory and saves its write requests."""
-
-    def __init__(self, write_output_list):
-        medium.SmartServerStreamMedium.__init__(self, memory.MemoryTransport())
-        self._write_output_list = write_output_list
-
-
 class TestSmartProtocol(tests.TestCase):
     """Base class for smart protocol tests.
 
@@ -1333,19 +1388,15 @@
     client_protocol_class = None
     server_protocol_class = None
 
-    def setUp(self):
-        super(TestSmartProtocol, self).setUp()
-        # XXX: self.server_to_client doesn't seem to be used.  If so,
-        # InstrumentedServerProtocol is redundant too.
-        self.server_to_client = []
-        self.to_server = StringIO()
-        self.to_client = StringIO()
-        self.client_medium = medium.SmartSimplePipesClientMedium(self.to_client,
-            self.to_server)
-        self.client_protocol = self.client_protocol_class(self.client_medium)
-        self.smart_server = InstrumentedServerProtocol(self.server_to_client)
-        self.smart_server_request = _mod_request.SmartServerRequestHandler(
-            None, _mod_request.request_handlers, root_client_path='/')
+    def make_client_protocol(self):
+        client_medium = medium.SmartSimplePipesClientMedium(
+            StringIO(), StringIO())
+        return self.client_protocol_class(client_medium.get_request())
+
+    def make_server_protocol(self):
+        out_stream = StringIO()
+        smart_protocol = self.server_protocol_class(None, out_stream.write)
+        return smart_protocol, out_stream
 
     def assertOffsetSerialisation(self, expected_offsets, expected_serialised,
         client):
@@ -1367,10 +1418,10 @@
         self.assertEqual(expected_serialised, serialised)
 
     def build_protocol_waiting_for_body(self):
-        out_stream = StringIO()
-        smart_protocol = self.server_protocol_class(None, out_stream.write)
+        smart_protocol, out_stream = self.make_server_protocol()
         smart_protocol.has_dispatched = True
-        smart_protocol.request = self.smart_server_request
+        smart_protocol.request = _mod_request.SmartServerRequestHandler(
+            None, _mod_request.request_handlers, '/')
         class FakeCommand(object):
             def do_body(cmd, body_bytes):
                 self.end_received = True
@@ -1392,9 +1443,7 @@
         # check the encoding of the server for all input_tuples matches
         # expected bytes
         for input_tuple in input_tuples:
-            server_output = StringIO()
-            server_protocol = self.server_protocol_class(
-                None, server_output.write)
+            server_protocol, server_output = self.make_server_protocol()
             server_protocol._send_response(
                 _mod_request.SuccessfulSmartServerResponse(input_tuple))
             self.assertEqual(expected_bytes, server_output.getvalue())
@@ -1412,8 +1461,7 @@
 
     def test_errors_are_logged(self):
         """If an error occurs during testing, it is logged to the test log."""
-        out_stream = StringIO()
-        smart_protocol = self.server_protocol_class(None, out_stream.write)
+        smart_protocol, out_stream = self.make_server_protocol()
         # This triggers a "bad request" error.
         smart_protocol.accept_bytes('abc\n')
         test_log = self._get_log(keep_log_file=True)
@@ -1421,18 +1469,29 @@
         self.assertContainsRe(test_log, 'SmartProtocolError')
 
     def test_connection_closed_reporting(self):
-        input = StringIO()
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(input, output)
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
+        smart_protocol = self.make_client_protocol()
         smart_protocol.call('hello')
-        ex = self.assertRaises(errors.ConnectionReset, 
+        ex = self.assertRaises(errors.ConnectionReset,
             smart_protocol.read_response_tuple)
         self.assertEqual("Connection closed: "
             "please check connectivity and permissions "
             "(and try -Dhpss if further diagnosis is required)", str(ex))
 
+    def test_server_offset_serialisation(self):
+        """The Smart protocol serialises offsets as a comma and \n string.
+
+        We check a number of boundary cases are as expected: empty, one offset,
+        one with the order of reads not increasing (an out of order read), and
+        one that should coalesce.
+        """
+        client_protocol = self.make_client_protocol()
+        self.assertOffsetSerialisation([], '', client_protocol)
+        self.assertOffsetSerialisation([(1,2)], '1,2', client_protocol)
+        self.assertOffsetSerialisation([(10,40), (0,5)], '10,40\n0,5',
+            client_protocol)
+        self.assertOffsetSerialisation([(1,2), (3,4), (100, 200)],
+            '1,2\n3,4\n100,200', client_protocol)
+
 
 class TestSmartProtocolOne(TestSmartProtocol, CommonSmartProtocolTestMixin):
     """Tests for the smart protocol version one."""
@@ -1454,20 +1513,6 @@
         request = client_medium.get_request()
         client_protocol = protocol.SmartClientRequestProtocolOne(request)
 
-    def test_server_offset_serialisation(self):
-        """The Smart protocol serialises offsets as a comma and \n string.
-
-        We check a number of boundary cases are as expected: empty, one offset,
-        one with the order of reads not increasing (an out of order read), and
-        one that should coalesce.
-        """
-        self.assertOffsetSerialisation([], '', self.client_protocol)
-        self.assertOffsetSerialisation([(1,2)], '1,2', self.client_protocol)
-        self.assertOffsetSerialisation([(10,40), (0,5)], '10,40\n0,5',
-            self.client_protocol)
-        self.assertOffsetSerialisation([(1,2), (3,4), (100, 200)],
-            '1,2\n3,4\n100,200', self.client_protocol)
-
     def test_accept_bytes_of_bad_request_to_protocol(self):
         out_stream = StringIO()
         smart_protocol = protocol.SmartServerRequestProtocolOne(
@@ -1603,6 +1648,41 @@
         smart_protocol.call_with_body_readv_array(('foo', ), [(1,2),(5,6)])
         self.assertEqual(expected_bytes, output.getvalue())
 
+    def _test_client_read_response_tuple_raises_UnknownSmartMethod(self,
+            server_bytes):
+        input = StringIO(server_bytes)
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolOne(request)
+        smart_protocol.call('foo')
+        self.assertRaises(
+            errors.UnknownSmartMethod, smart_protocol.read_response_tuple)
+        # The request has been finished.  There is no body to read, and
+        # attempts to read one will fail.
+        self.assertRaises(
+            errors.ReadingCompleted, smart_protocol.read_body_bytes)
+
+    def test_client_read_response_tuple_raises_UnknownSmartMethod(self):
+        """read_response_tuple raises UnknownSmartMethod if the response says
+        the server did not recognise the request.
+        """
+        server_bytes = (
+            "error\x01Generic bzr smart protocol error: bad request 'foo'\n")
+        self._test_client_read_response_tuple_raises_UnknownSmartMethod(
+            server_bytes)
+
+    def test_client_read_response_tuple_raises_UnknownSmartMethod_0_11(self):
+        """read_response_tuple also raises UnknownSmartMethod if the response
+        from a bzr 0.11 says the server did not recognise the request.
+
+        (bzr 0.11 sends a slightly different error message to later versions.)
+        """
+        server_bytes = (
+            "error\x01Generic bzr smart protocol error: bad request u'foo'\n")
+        self._test_client_read_response_tuple_raises_UnknownSmartMethod(
+            server_bytes)
+
     def test_client_read_body_bytes_all(self):
         # read_body_bytes should decode the body bytes from the wire into
         # a response.
@@ -1678,20 +1758,6 @@
         request = client_medium.get_request()
         client_protocol = protocol.SmartClientRequestProtocolTwo(request)
 
-    def test_server_offset_serialisation(self):
-        """The Smart protocol serialises offsets as a comma and \n string.
-
-        We check a number of boundary cases are as expected: empty, one offset,
-        one with the order of reads not increasing (an out of order read), and
-        one that should coalesce.
-        """
-        self.assertOffsetSerialisation([], '', self.client_protocol)
-        self.assertOffsetSerialisation([(1,2)], '1,2', self.client_protocol)
-        self.assertOffsetSerialisation([(10,40), (0,5)], '10,40\n0,5',
-            self.client_protocol)
-        self.assertOffsetSerialisation([(1,2), (3,4), (100, 200)],
-            '1,2\n3,4\n100,200', self.client_protocol)
-
     def assertBodyStreamSerialisation(self, expected_serialisation,
                                       body_stream):
         """Assert that body_stream is serialised as expected_serialisation."""
@@ -1932,6 +1998,28 @@
         smart_protocol.read_response_tuple(False)
         self.assertEqual(True, smart_protocol.response_status)
 
+    def test_client_read_response_tuple_raises_UnknownSmartMethod(self):
+        """read_response_tuple raises UnknownSmartMethod if the response is
+        says the server did not recognise the request.
+        """
+        server_bytes = (
+            protocol.RESPONSE_VERSION_TWO +
+            "failed\n" +
+            "error\x01Generic bzr smart protocol error: bad request 'foo'\n")
+        input = StringIO(server_bytes)
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        smart_protocol.call('foo')
+        self.assertRaises(
+            errors.UnknownSmartMethod, smart_protocol.read_response_tuple)
+        self.assertEqual(False, smart_protocol.response_status)
+        # The request has been finished.  There is no body to read, and
+        # attempts to read one will fail.
+        self.assertRaises(
+            errors.ReadingCompleted, smart_protocol.read_body_bytes)
+
     def test_client_read_body_bytes_all(self):
         # read_body_bytes should decode the body bytes from the wire into
         # a response.

=== modified file 'bzrlib/tests/test_store.py'
--- bzrlib/tests/test_store.py	2007-08-15 04:33:34 +0000
+++ bzrlib/tests/test_store.py	2008-04-08 00:57:07 +0000
@@ -405,32 +405,32 @@
 
 class TestVersionFileStore(TestCaseWithTransport):
 
+    def get_scope(self):
+        return self._transaction
+
     def setUp(self):
         super(TestVersionFileStore, self).setUp()
         self.vfstore = store.versioned.VersionedFileStore(MemoryTransport())
+        self.vfstore.get_scope = self.get_scope
+        self._transaction = None
 
     def test_get_weave_registers_dirty_in_write(self):
-        transaction = transactions.WriteTransaction()
-        vf = self.vfstore.get_weave_or_empty('id', transaction)
-        transaction.finish()
-        self.assertRaises(errors.OutSideTransaction, vf.add_lines, 'b', [], [])
-        transaction = transactions.WriteTransaction()
-        vf = self.vfstore.get_weave('id', transaction)
-        transaction.finish()
-        self.assertRaises(errors.OutSideTransaction, vf.add_lines, 'b', [], [])
-
-    def test_get_weave_or_empty_readonly_fails(self):
-        transaction = transactions.ReadOnlyTransaction()
-        vf = self.assertRaises(errors.ReadOnlyError,
-                               self.vfstore.get_weave_or_empty,
-                               'id',
-                               transaction)
+        self._transaction = transactions.WriteTransaction()
+        vf = self.vfstore.get_weave_or_empty('id', self._transaction)
+        self._transaction.finish()
+        self._transaction = None
+        self.assertRaises(errors.OutSideTransaction, vf.add_lines, 'b', [], [])
+        self._transaction = transactions.WriteTransaction()
+        vf = self.vfstore.get_weave('id', self._transaction)
+        self._transaction.finish()
+        self._transaction = None
+        self.assertRaises(errors.OutSideTransaction, vf.add_lines, 'b', [], [])
 
     def test_get_weave_readonly_cant_write(self):
-        transaction = transactions.WriteTransaction()
-        vf = self.vfstore.get_weave_or_empty('id', transaction)
-        transaction.finish()
-        transaction = transactions.ReadOnlyTransaction()
-        vf = self.vfstore.get_weave_or_empty('id', transaction)
+        self._transaction = transactions.WriteTransaction()
+        vf = self.vfstore.get_weave_or_empty('id', self._transaction)
+        self._transaction.finish()
+        self._transaction = transactions.ReadOnlyTransaction()
+        vf = self.vfstore.get_weave_or_empty('id', self._transaction)
         self.assertRaises(errors.ReadOnlyError, vf.add_lines, 'b', [], [])
 

=== modified file 'bzrlib/tests/test_subsume.py'
--- bzrlib/tests/test_subsume.py	2007-03-06 08:41:40 +0000
+++ bzrlib/tests/test_subsume.py	2008-04-04 00:06:58 +0000
@@ -22,7 +22,7 @@
     def make_branch_and_tree(self, relpath, format=None):
         if format is None:
             format = 'dirstate-with-subtree'
-        return tests.TestCaseWithTransport.make_branch_and_tree(self, relpath, 
+        return tests.TestCaseWithTransport.make_branch_and_tree(self, relpath,
                                                                 format)
 
     def make_trees(self, format=None, same_root=False):

=== modified file 'bzrlib/tests/test_versionedfile.py'
--- bzrlib/tests/test_versionedfile.py	2008-04-01 02:41:25 +0000
+++ bzrlib/tests/test_versionedfile.py	2008-04-08 21:41:15 +0000
@@ -30,12 +30,12 @@
     progress,
     )
 from bzrlib.errors import (
-                           RevisionNotPresent, 
+                           RevisionNotPresent,
                            RevisionAlreadyPresent,
                            WeaveParentMismatch
                            )
 from bzrlib.knit import (
-    KnitVersionedFile,
+    make_file_knit,
     KnitAnnotateFactory,
     KnitPlainFactory,
     )
@@ -59,6 +59,11 @@
     they are strictly controlled by their owning repositories.
     """
 
+    def get_transaction(self):
+        if not hasattr(self, '_transaction'):
+            self._transaction = None
+        return self._transaction
+
     def test_add(self):
         f = self.get_file()
         f.add_lines('r0', [], ['a\n', 'b\n'])
@@ -242,7 +247,7 @@
         for version in multiparent.topo_iter(vf):
             mpdiff = vf.make_mpdiffs([version])[0]
             new_vf.add_mpdiffs([(version, vf.get_parent_map([version])[version],
-                                 vf.get_sha1(version), mpdiff)])
+                                 vf.get_sha1s([version])[0], mpdiff)])
             self.assertEqualDiff(vf.get_text(version),
                                  new_vf.get_text(version))
 
@@ -348,34 +353,25 @@
             set(f.get_ancestry('rM', topo_sorted=False)))
 
     def test_mutate_after_finish(self):
+        self._transaction = 'before'
         f = self.get_file()
-        f.transaction_finished()
+        self._transaction = 'after'
         self.assertRaises(errors.OutSideTransaction, f.add_lines, '', [], [])
         self.assertRaises(errors.OutSideTransaction, f.add_lines_with_ghosts, '', [], [])
         self.assertRaises(errors.OutSideTransaction, f.join, '')
-        self.assertRaises(errors.OutSideTransaction, f.clone_text, 'base', 'bar', ['foo'])
         
-    def test_clear_cache(self):
-        f = self.get_file()
-        # on a new file it should not error
-        f.clear_cache()
-        # and after adding content, doing a clear_cache and a get should work.
-        f.add_lines('0', [], ['a'])
-        f.clear_cache()
-        self.assertEqual(['a'], f.get_lines('0'))
-
     def test_clone_text(self):
         f = self.get_file()
         f.add_lines('r0', [], ['a\n', 'b\n'])
-        f.clone_text('r1', 'r0', ['r0'])
+        self.applyDeprecated(one_four, f.clone_text, 'r1', 'r0', ['r0'])
         def verify_file(f):
             self.assertEquals(f.get_lines('r1'), f.get_lines('r0'))
             self.assertEquals(f.get_lines('r1'), ['a\n', 'b\n'])
             self.assertEqual({'r1':('r0',)}, f.get_parent_map(['r1']))
             self.assertRaises(RevisionNotPresent,
-                f.clone_text, 'r2', 'rX', [])
+                self.applyDeprecated, one_four, f.clone_text, 'r2', 'rX', [])
             self.assertRaises(RevisionAlreadyPresent,
-                f.clone_text, 'r1', 'r0', [])
+                self.applyDeprecated, one_four, f.clone_text, 'r1', 'r0', [])
         verify_file(f)
         verify_file(self.reopen_file())
 
@@ -384,15 +380,13 @@
         f.add_lines('0', [], ['a\n'])
         t = MemoryTransport()
         f.copy_to('foo', t)
-        for suffix in f.__class__.get_suffixes():
+        for suffix in self.get_factory().get_suffixes():
             self.assertTrue(t.has('foo' + suffix))
 
     def test_get_suffixes(self):
         f = self.get_file()
-        # should be the same
-        self.assertEqual(f.__class__.get_suffixes(), f.__class__.get_suffixes())
         # and should be a list
-        self.assertTrue(isinstance(f.__class__.get_suffixes(), list))
+        self.assertTrue(isinstance(self.get_factory().get_suffixes(), list))
 
     def build_graph(self, file, graph):
         for node in topo_sort(graph.items()):
@@ -405,7 +399,7 @@
             'v2': ('v1', ),
             'v3': ('v2', )}
         self.build_graph(f, graph)
-        self.assertEqual(graph, f.get_graph())
+        self.assertEqual(graph, self.applyDeprecated(one_four, f.get_graph))
     
     def test_get_graph_partial(self):
         f = self.get_file()
@@ -432,10 +426,14 @@
         simple_b_gam.update(simple_gam)
         simple_b_gam.update(simple_b)
         self.build_graph(f, complex_graph)
-        self.assertEqual(simple_a, f.get_graph(['a']))
-        self.assertEqual(simple_b, f.get_graph(['b']))
-        self.assertEqual(simple_gam, f.get_graph(['gam']))
-        self.assertEqual(simple_b_gam, f.get_graph(['b', 'gam']))
+        self.assertEqual(simple_a, self.applyDeprecated(one_four, f.get_graph,
+            ['a']))
+        self.assertEqual(simple_b, self.applyDeprecated(one_four, f.get_graph,
+            ['b']))
+        self.assertEqual(simple_gam, self.applyDeprecated(one_four,
+            f.get_graph, ['gam']))
+        self.assertEqual(simple_b_gam, self.applyDeprecated(one_four,
+            f.get_graph, ['b', 'gam']))
 
     def test_get_parents(self):
         f = self.get_file()
@@ -525,23 +523,25 @@
         # XXX TODO a ghost
         # cases: each sample data individually:
         self.assertEqual(set([('r0', ())]),
-            set(f.iter_parents(['r0'])))
+            set(self.applyDeprecated(one_four, f.iter_parents, ['r0'])))
         self.assertEqual(set([('r1', ('r0', ))]),
-            set(f.iter_parents(['r1'])))
+            set(self.applyDeprecated(one_four, f.iter_parents, ['r1'])))
         self.assertEqual(set([('r2', ('r1', 'r0'))]),
-            set(f.iter_parents(['r2'])))
+            set(self.applyDeprecated(one_four, f.iter_parents, ['r2'])))
         # no nodes returned for a missing node
         self.assertEqual(set(),
-            set(f.iter_parents(['missing'])))
+            set(self.applyDeprecated(one_four, f.iter_parents, ['missing'])))
         # 1 node returned with missing nodes skipped
         self.assertEqual(set([('r1', ('r0', ))]),
-            set(f.iter_parents(['ghost1', 'r1', 'ghost'])))
+            set(self.applyDeprecated(one_four, f.iter_parents, ['ghost1', 'r1',
+                'ghost'])))
         # 2 nodes returned
         self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
-            set(f.iter_parents(['r0', 'r1'])))
+            set(self.applyDeprecated(one_four, f.iter_parents, ['r0', 'r1'])))
         # 2 nodes returned, missing skipped
         self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
-            set(f.iter_parents(['a', 'r0', 'b', 'r1', 'c'])))
+            set(self.applyDeprecated(one_four, f.iter_parents,
+                ['a', 'r0', 'b', 'r1', 'c'])))
 
     def test_iter_lines_added_or_present_in_versions(self):
         # test that we get at least an equalset of the lines added by
@@ -631,7 +631,8 @@
         self.assertEqual(['notbxbfse'], vf.get_ancestry('notbxbfse'))
         self.assertEqual([],
             self.applyDeprecated(one_four, vf.get_parents, 'notbxbfse'))
-        self.assertEqual({'notbxbfse':()}, vf.get_graph())
+        self.assertEqual({'notbxbfse':()}, self.applyDeprecated(one_four,
+            vf.get_graph))
         self.assertFalse(vf.has_version(parent_id_utf8))
         # we have _with_ghost apis to give us ghost information.
         self.assertEqual([parent_id_utf8, 'notbxbfse'], vf.get_ancestry_with_ghosts(['notbxbfse']))
@@ -649,7 +650,7 @@
         self.assertEqual({parent_id_utf8:(),
                           'notbxbfse':(parent_id_utf8, ),
                           },
-                         vf.get_graph())
+                         self.applyDeprecated(one_four, vf.get_graph))
         self.assertTrue(vf.has_version(parent_id_utf8))
         # we have _with_ghost apis to give us ghost information.
         self.assertEqual([parent_id_utf8, 'notbxbfse'],
@@ -693,9 +694,8 @@
                           [],
                           [])
         self.assertRaises(errors.ReadOnlyError, vf.join, 'base')
-        self.assertRaises(errors.ReadOnlyError, vf.clone_text, 'base', 'bar', ['foo'])
     
-    def test_get_sha1(self):
+    def test_get_sha1s(self):
         # check the sha1 data is available
         vf = self.get_file()
         # a simple file
@@ -704,13 +704,16 @@
         vf.add_lines('b', ['a'], ['a\n'])
         # a file differing only in last newline.
         vf.add_lines('c', [], ['a'])
-        self.assertEqual(
-            '3f786850e387550fdab836ed7e6dc881de23001b', vf.get_sha1('a'))
-        self.assertEqual(
-            '3f786850e387550fdab836ed7e6dc881de23001b', vf.get_sha1('b'))
-        self.assertEqual(
-            '86f7e437faa5a7fce15d1ddcb9eaeaea377667b8', vf.get_sha1('c'))
-
+        # Deprecasted single-version API.
+        self.assertEqual(
+            '3f786850e387550fdab836ed7e6dc881de23001b',
+            self.applyDeprecated(one_four, vf.get_sha1, 'a'))
+        self.assertEqual(
+            '3f786850e387550fdab836ed7e6dc881de23001b',
+            self.applyDeprecated(one_four, vf.get_sha1, 'b'))
+        self.assertEqual(
+            '86f7e437faa5a7fce15d1ddcb9eaeaea377667b8',
+            self.applyDeprecated(one_four, vf.get_sha1, 'c'))
         self.assertEqual(['3f786850e387550fdab836ed7e6dc881de23001b',
                           '86f7e437faa5a7fce15d1ddcb9eaeaea377667b8',
                           '3f786850e387550fdab836ed7e6dc881de23001b'],
@@ -720,10 +723,12 @@
 class TestWeave(TestCaseWithMemoryTransport, VersionedFileTestMixIn):
 
     def get_file(self, name='foo'):
-        return WeaveFile(name, get_transport(self.get_url('.')), create=True)
+        return WeaveFile(name, get_transport(self.get_url('.')), create=True,
+            get_scope=self.get_transaction)
 
     def get_file_corrupted_text(self):
-        w = WeaveFile('foo', get_transport(self.get_url('.')), create=True)
+        w = WeaveFile('foo', get_transport(self.get_url('.')), create=True,
+            get_scope=self.get_transaction)
         w.add_lines('v1', [], ['hello\n'])
         w.add_lines('v2', ['v1'], ['hello\n', 'there\n'])
         
@@ -757,13 +762,15 @@
         return w
 
     def reopen_file(self, name='foo', create=False):
-        return WeaveFile(name, get_transport(self.get_url('.')), create=create)
+        return WeaveFile(name, get_transport(self.get_url('.')), create=create,
+            get_scope=self.get_transaction)
 
     def test_no_implicit_create(self):
         self.assertRaises(errors.NoSuchFile,
                           WeaveFile,
                           'foo',
-                          get_transport(self.get_url('.')))
+                          get_transport(self.get_url('.')),
+                          get_scope=self.get_transaction)
 
     def get_factory(self):
         return WeaveFile
@@ -773,10 +780,10 @@
 
     def get_file(self, name='foo'):
         return self.get_factory()(name, get_transport(self.get_url('.')),
-                                  delta=True, create=True)
+            delta=True, create=True, get_scope=self.get_transaction)
 
     def get_factory(self):
-        return KnitVersionedFile
+        return make_file_knit
 
     def get_file_corrupted_text(self):
         knit = self.get_file()
@@ -794,31 +801,23 @@
         knit.check()
 
     def test_no_implicit_create(self):
-        self.assertRaises(errors.NoSuchFile,
-                          KnitVersionedFile,
-                          'foo',
-                          get_transport(self.get_url('.')))
+        self.assertRaises(errors.NoSuchFile, self.get_factory(), 'foo',
+            get_transport(self.get_url('.')))
 
 
 class TestPlaintextKnit(TestKnit):
     """Test a knit with no cached annotations"""
 
-    def _factory(self, name, transport, file_mode=None, access_mode=None,
-                 delta=True, create=False):
-        return KnitVersionedFile(name, transport, file_mode, access_mode,
-                                 KnitPlainFactory(), delta=delta,
-                                 create=create)
-
     def get_factory(self):
-        return self._factory
+        return make_file_knit
 
 
 class TestPlanMergeVersionedFile(TestCaseWithMemoryTransport):
 
     def setUp(self):
         TestCaseWithMemoryTransport.setUp(self)
-        self.vf1 = KnitVersionedFile('root', self.get_transport(), create=True)
-        self.vf2 = KnitVersionedFile('root', self.get_transport(), create=True)
+        self.vf1 = make_file_knit('root', self.get_transport(), create=True)
+        self.vf2 = make_file_knit('root', self.get_transport(), create=True)
         self.plan_merge_vf = versionedfile._PlanMergeVersionedFile('root',
             [self.vf1, self.vf2])
 
@@ -946,6 +945,9 @@
 
 class TestReadonlyHttpMixin(object):
 
+    def get_transaction(self):
+        return 1
+
     def test_readonly_http_works(self):
         # we should be able to read from http with a versioned file.
         vf = self.get_file()
@@ -964,7 +966,8 @@
 class TestWeaveHTTP(TestCaseWithWebserver, TestReadonlyHttpMixin):
 
     def get_file(self):
-        return WeaveFile('foo', get_transport(self.get_url('.')), create=True)
+        return WeaveFile('foo', get_transport(self.get_url('.')), create=True,
+            get_scope=self.get_transaction)
 
     def get_factory(self):
         return WeaveFile
@@ -973,11 +976,11 @@
 class TestKnitHTTP(TestCaseWithWebserver, TestReadonlyHttpMixin):
 
     def get_file(self):
-        return KnitVersionedFile('foo', get_transport(self.get_url('.')),
-                                 delta=True, create=True)
+        return make_file_knit('foo', get_transport(self.get_url('.')),
+            delta=True, create=True, get_scope=self.get_transaction)
 
     def get_factory(self):
-        return KnitVersionedFile
+        return make_file_knit
 
 
 class MergeCasesMixin(object):
@@ -1220,7 +1223,7 @@
 class TestKnitMerge(TestCaseWithMemoryTransport, MergeCasesMixin):
 
     def get_file(self, name='foo'):
-        return KnitVersionedFile(name, get_transport(self.get_url('.')),
+        return make_file_knit(name, get_transport(self.get_url('.')),
                                  delta=True, create=True)
 
     def log_contents(self, w):
@@ -1240,23 +1243,3 @@
 
     overlappedInsertExpected = ['aaa', '<<<<<<< ', 'xxx', 'yyy', '=======', 
                                 'xxx', '>>>>>>> ', 'bbb']
-
-
-class TestFormatSignatures(TestCaseWithMemoryTransport):
-
-    def get_knit_file(self, name, annotated):
-        if annotated:
-            factory = KnitAnnotateFactory()
-        else:
-            factory = KnitPlainFactory()
-        return KnitVersionedFile(
-            name, get_transport(self.get_url('.')), create=True,
-            factory=factory)
-
-    def test_knit_format_signatures(self):
-        """Different formats of knit have different signature strings."""
-        knit = self.get_knit_file('a', True)
-        self.assertEqual('knit-annotated', knit.get_format_signature())
-        knit = self.get_knit_file('p', False)
-        self.assertEqual('knit-plain', knit.get_format_signature())
-

=== modified file 'bzrlib/tests/test_weave.py'
--- bzrlib/tests/test_weave.py	2007-09-19 05:14:14 +0000
+++ bzrlib/tests/test_weave.py	2008-04-08 03:39:43 +0000
@@ -65,7 +65,7 @@
 class WeaveContains(TestBase):
     """Weave __contains__ operator"""
     def runTest(self):
-        k = Weave()
+        k = Weave(get_scope=lambda:None)
         self.assertFalse('foo' in k)
         k.add_lines('foo', [], TEXT_1)
         self.assertTrue('foo' in k)
@@ -84,18 +84,6 @@
                          [('text0', TEXT_0[0])])
 
 
-class GetSha1(TestBase):
-    def test_get_sha1(self):
-        k = Weave()
-        k.add_lines('text0', [], 'text0')
-        self.assertEqual('34dc0e430c642a26c3dd1c2beb7a8b4f4445eb79',
-                         k.get_sha1('text0'))
-        self.assertRaises(errors.RevisionNotPresent,
-                          k.get_sha1, 0)
-        self.assertRaises(errors.RevisionNotPresent,
-                          k.get_sha1, 'text1')
-                        
-
 class InvalidAdd(TestBase):
     """Try to use invalid version number during add."""
     def runTest(self):

=== modified file 'bzrlib/tests/test_xml.py'
--- bzrlib/tests/test_xml.py	2007-10-19 17:14:33 +0000
+++ bzrlib/tests/test_xml.py	2008-04-15 04:29:44 +0000
@@ -20,6 +20,7 @@
     errors, 
     inventory, 
     xml7,
+    xml8,
     xml_serializer,
     )
 from bzrlib.tests import TestCase
@@ -147,6 +148,24 @@
 </inventory>
 """
 
+_expected_rev_v8 = """<revision committer="Martin Pool &lt;mbp@sourcefrog.net&gt;" format="8" inventory_sha1="e79c31c1deb64c163cf660fdedd476dd579ffd41" revision_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9" timestamp="1125907235.212" timezone="36000">
+<message>- start splitting code for xml (de)serialization away from objects
+  preparatory to supporting multiple formats by a single library
+</message>
+<parents>
+<revision_ref revision_id="mbp@sourcefrog.net-20050905063503-43948f59fa127d92" />
+</parents>
+</revision>
+"""
+
+_expected_inv_v8 = """<inventory format="8" revision_id="rev_outer">
+<directory file_id="tree-root-321" name="" revision="rev_outer" />
+<directory file_id="dir-id" name="dir" parent_id="tree-root-321" revision="rev_outer" />
+<file file_id="file-id" name="file" parent_id="tree-root-321" revision="rev_outer" text_sha1="A" text_size="1" />
+<symlink file_id="link-id" name="link" parent_id="tree-root-321" revision="rev_outer" symlink_target="a" />
+</inventory>
+"""
+
 _revision_utf8_v5 = """<revision committer="Erik B&#229;gfors &lt;erik@foo.net&gt;"
     inventory_sha1="e79c31c1deb64c163cf660fdedd476dd579ffd41"
     revision_id="erik@b&#229;gfors-02"
@@ -330,10 +349,8 @@
         new_rev = s_v5.read_revision_from_string(txt)
         self.assertEqual(props, new_rev.properties)
 
-    def test_roundtrip_inventory_v7(self):
+    def get_sample_inventory(self):
         inv = Inventory('tree-root-321', revision_id='rev_outer')
-        inv.add(inventory.TreeReference('nested-id', 'nested', 'tree-root-321',
-                                        'rev_outer', 'rev_inner'))
         inv.add(inventory.InventoryFile('file-id', 'file', 'tree-root-321'))
         inv.add(inventory.InventoryDirectory('dir-id', 'dir', 
                                              'tree-root-321'))
@@ -345,6 +362,12 @@
         inv['file-id'].text_size = 1
         inv['link-id'].revision = 'rev_outer'
         inv['link-id'].symlink_target = 'a'
+        return inv
+
+    def test_roundtrip_inventory_v7(self):
+        inv = self.get_sample_inventory()
+        inv.add(inventory.TreeReference('nested-id', 'nested', 'tree-root-321',
+                                        'rev_outer', 'rev_inner'))
         txt = xml7.serializer_v7.write_inventory_to_string(inv)
         lines = xml7.serializer_v7.write_inventory_to_lines(inv)
         self.assertEqual(bzrlib.osutils.split_lines(txt), lines)
@@ -389,6 +412,42 @@
                           s_v5.read_inventory_from_string,
                           txt.replace('format="7"', 'format="5"'))
 
+    def test_roundtrip_inventory_v8(self):
+        inv = self.get_sample_inventory()
+        txt = xml8.serializer_v8.write_inventory_to_string(inv)
+        inv2 = xml8.serializer_v8.read_inventory_from_string(txt)
+        self.assertEqual(4, len(inv2))
+        for path, ie in inv.iter_entries():
+            self.assertEqual(ie, inv2[ie.file_id])
+
+    def test_inventory_text_v8(self):
+        inv = self.get_sample_inventory()
+        txt = xml8.serializer_v8.write_inventory_to_string(inv)
+        lines = xml8.serializer_v8.write_inventory_to_lines(inv)
+        self.assertEqual(bzrlib.osutils.split_lines(txt), lines)
+        self.assertEqualDiff(_expected_inv_v8, txt)
+
+    def test_revision_text_v6(self):
+        """Pack revision to XML v6"""
+        rev = bzrlib.xml6.serializer_v6.read_revision_from_string(
+            _expected_rev_v5)
+        serialized = bzrlib.xml6.serializer_v6.write_revision_to_string(rev)
+        self.assertEqualDiff(serialized, _expected_rev_v5)
+
+    def test_revision_text_v7(self):
+        """Pack revision to XML v7"""
+        rev = bzrlib.xml7.serializer_v7.read_revision_from_string(
+            _expected_rev_v5)
+        serialized = bzrlib.xml7.serializer_v7.write_revision_to_string(rev)
+        self.assertEqualDiff(serialized, _expected_rev_v5)
+
+    def test_revision_text_v8(self):
+        """Pack revision to XML v8"""
+        rev = bzrlib.xml8.serializer_v8.read_revision_from_string(
+            _expected_rev_v8)
+        serialized = bzrlib.xml8.serializer_v8.write_revision_to_string(rev)
+        self.assertEqualDiff(serialized, _expected_rev_v8)
+
     def test_revision_ids_are_utf8(self):
         """Parsed revision_ids should all be utf-8 strings, not unicode."""
         s_v5 = bzrlib.xml5.serializer_v5
@@ -442,6 +501,8 @@
                       xml_serializer.format_registry.get('6'))
         self.assertIs(bzrlib.xml7.serializer_v7,
                       xml_serializer.format_registry.get('7'))
+        self.assertIs(bzrlib.xml8.serializer_v8,
+                      xml_serializer.format_registry.get('8'))
 
 
 class TestEncodeAndEscape(TestCase):
@@ -449,31 +510,31 @@
 
     def setUp(self):
         # Keep the cache clear before and after the test
-        bzrlib.xml5._ensure_utf8_re()
-        bzrlib.xml5._clear_cache()
-        self.addCleanup(bzrlib.xml5._clear_cache)
+        bzrlib.xml8._ensure_utf8_re()
+        bzrlib.xml8._clear_cache()
+        self.addCleanup(bzrlib.xml8._clear_cache)
 
     def test_simple_ascii(self):
         # _encode_and_escape always appends a final ", because these parameters
         # are being used in xml attributes, and by returning it now, we have to
         # do fewer string operations later.
-        val = bzrlib.xml5._encode_and_escape('foo bar')
+        val = bzrlib.xml8._encode_and_escape('foo bar')
         self.assertEqual('foo bar"', val)
         # The second time should be cached
-        val2 = bzrlib.xml5._encode_and_escape('foo bar')
+        val2 = bzrlib.xml8._encode_and_escape('foo bar')
         self.assertIs(val2, val)
 
     def test_ascii_with_xml(self):
         self.assertEqual('&amp;&apos;&quot;&lt;&gt;"',
-                         bzrlib.xml5._encode_and_escape('&\'"<>'))
+                         bzrlib.xml8._encode_and_escape('&\'"<>'))
 
     def test_utf8_with_xml(self):
         # u'\xb5\xe5&\u062c'
         utf8_str = '\xc2\xb5\xc3\xa5&\xd8\xac'
         self.assertEqual('&#181;&#229;&amp;&#1580;"',
-                         bzrlib.xml5._encode_and_escape(utf8_str))
+                         bzrlib.xml8._encode_and_escape(utf8_str))
 
     def test_unicode(self):
         uni_str = u'\xb5\xe5&\u062c'
         self.assertEqual('&#181;&#229;&amp;&#1580;"',
-                         bzrlib.xml5._encode_and_escape(uni_str))
+                         bzrlib.xml8._encode_and_escape(uni_str))

=== modified file 'bzrlib/tests/tree_implementations/__init__.py'
--- bzrlib/tests/tree_implementations/__init__.py	2008-03-15 09:25:32 +0000
+++ bzrlib/tests/tree_implementations/__init__.py	2008-04-12 06:03:29 +0000
@@ -56,18 +56,18 @@
     )
 
 
-def return_parameter(something):
+def return_parameter(testcase, something):
     """A trivial thunk to return its input."""
     return something
 
 
-def revision_tree_from_workingtree(tree):
+def revision_tree_from_workingtree(testcase, tree):
     """Create a revision tree from a working tree."""
     revid = tree.commit('save tree', allow_pointless=True, recursive=None)
     return tree.branch.repository.revision_tree(revid)
 
 
-def _dirstate_tree_from_workingtree(tree):
+def _dirstate_tree_from_workingtree(testcase, tree):
     revid = tree.commit('save tree', allow_pointless=True)
     return tree.basis_tree()
 
@@ -76,7 +76,7 @@
 
     def test_revision_tree_from_workingtree(self):
         tree = self.make_branch_and_tree('.')
-        tree = revision_tree_from_workingtree(tree)
+        tree = revision_tree_from_workingtree(self, tree)
         self.assertIsInstance(tree, RevisionTree)
 
 
@@ -89,6 +89,9 @@
         made_control.create_branch()
         return self.workingtree_format.initialize(made_control)
 
+    def workingtree_to_test_tree(self, tree):
+        return self._workingtree_to_test_tree(self, tree)
+
     def _convert_tree(self, tree, converter=None):
         """helper to convert using the converter or a supplied one."""
         # convert that to the final shape
@@ -301,22 +304,34 @@
         # now adjust the scenarios and add the non-working-tree tree scenarios.
         for scenario in self.scenarios:
             # for working tree adapted tests, preserve the tree
-            scenario[1]["workingtree_to_test_tree"] = return_parameter
+            scenario[1]["_workingtree_to_test_tree"] = return_parameter
         # add RevisionTree scenario
-        # this is the 'default format' in that it's used to test the generic InterTree
-        # code.
-        default_format = WorkingTreeFormat3()
-        self.scenarios.append(self.formats_to_scenarios([
-            (default_format, default_format._matchingbzrdir)])[0])
-        self.scenarios[-1] = (RevisionTree.__name__, self.scenarios[-1][1])
-        self.scenarios[-1][1]["workingtree_to_test_tree"] = revision_tree_from_workingtree
-
-        # also test WorkingTree4's RevisionTree implementation which is specialised.
-        dirstate_format = WorkingTreeFormat4()
-        self.scenarios.append(self.formats_to_scenarios([
-            (dirstate_format, dirstate_format._matchingbzrdir)])[0])
-        self.scenarios[-1] = (DirStateRevisionTree.__name__, self.scenarios[-1][1])
-        self.scenarios[-1][1]["workingtree_to_test_tree"] = _dirstate_tree_from_workingtree
+        self.scenarios.append(self.create_tree_scenario(RevisionTree.__name__,
+                              revision_tree_from_workingtree,))
+
+        # also test WorkingTree4's RevisionTree implementation which is
+        # specialised.
+        self.scenarios.append(self.create_tree_scenario(
+            DirStateRevisionTree.__name__, _dirstate_tree_from_workingtree,
+            WorkingTreeFormat4()))
+
+    def create_tree_scenario(self, name, converter, workingtree_format=None):
+        """Create a scenario for the specified converter
+
+        :param name: The name to append to tests using this converter
+        :param converter: A function that converts a workingtree into the
+            desired format.
+        :param workingtree_format: The particular workingtree format to
+            convert from.
+        :return: a (name, options) tuple, where options is a dict of values
+            to be used as members of the TestCase.
+        """
+        if workingtree_format is None:
+            workingtree_format = WorkingTreeFormat3()
+        scenario_options = WorkingTreeTestProviderAdapter.create_scenario(self,
+            workingtree_format, workingtree_format._matchingbzrdir)[1]
+        scenario_options["_workingtree_to_test_tree"] = converter
+        return name, scenario_options
 
 
 def test_suite():

=== modified file 'bzrlib/tests/workingtree_implementations/__init__.py'
--- bzrlib/tests/workingtree_implementations/__init__.py	2007-07-12 07:22:52 +0000
+++ bzrlib/tests/workingtree_implementations/__init__.py	2008-04-12 06:03:29 +0000
@@ -59,15 +59,26 @@
     
         result = []
         for workingtree_format, bzrdir_format in formats:
-            scenario = (workingtree_format.__class__.__name__, {
-                "transport_server":self._transport_server,
-                "transport_readonly_server":self._transport_readonly_server,
-                "bzrdir_format":bzrdir_format,
-                "workingtree_format":workingtree_format,
-                })
-            result.append(scenario)
+            result.append(self.create_scenario(workingtree_format,
+                          bzrdir_format))
         return result
 
+    def create_scenario(self, workingtree_format, bzrdir_format):
+        """Create a scenario for the specified converter
+
+        :param workingtree_format: The particular workingtree format to test.
+        :param bzrdir_format: The bzrdir format to test.
+        :return: a (name, options) tuple, where options is a dict of values
+            to be used as members of the TestCase.
+        """
+        scenario_options = {
+            "transport_server": self._transport_server,
+            "transport_readonly_server": self._transport_readonly_server,
+            "bzrdir_format": bzrdir_format,
+            "workingtree_format": workingtree_format,
+            }
+        return workingtree_format.__class__.__name__, scenario_options
+
 
 class TestCaseWithWorkingTree(TestCaseWithBzrDir):
 

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2008-03-07 14:15:10 +0000
+++ bzrlib/transform.py	2008-04-04 04:20:19 +0000
@@ -1644,6 +1644,7 @@
     by_parent = tt.by_parent()
     for child in by_parent[old_parent]:
         tt.adjust_path(tt.final_name(child), new_parent, child)
+    return by_parent[old_parent]
 
 def _content_match(tree, entry, file_id, kind, target_path):
     if entry.kind != kind:
@@ -2019,18 +2020,39 @@
                 new_conflicts.add(('deleting parent', 'Not deleting', 
                                    trans_id))
             except KeyError:
-                tt.create_directory(trans_id)
-                new_conflicts.add((c_type, 'Created directory', trans_id))
+                create = True
                 try:
                     tt.final_name(trans_id)
                 except NoFinalPath:
                     if path_tree is not None:
                         file_id = tt.final_file_id(trans_id)
+                        if file_id is None:
+                            file_id = tt.inactive_file_id(trans_id)
                         entry = path_tree.inventory[file_id]
-                        parent_trans_id = tt.trans_id_file_id(entry.parent_id)
-                        tt.adjust_path(entry.name, parent_trans_id, trans_id)
+                        # special-case the other tree root (move its
+                        # children to current root)
+                        if entry.parent_id is None:
+                            create=False
+                            moved = _reparent_transform_children(
+                                tt, trans_id, tt.root)
+                            for child in moved:
+                                new_conflicts.add((c_type, 'Moved to root',
+                                                   child))
+                        else:
+                            parent_trans_id = tt.trans_id_file_id(
+                                entry.parent_id)
+                            tt.adjust_path(entry.name, parent_trans_id,
+                                           trans_id)
+                if create:
+                    tt.create_directory(trans_id)
+                    new_conflicts.add((c_type, 'Created directory', trans_id))
         elif c_type == 'unversioned parent':
-            tt.version_file(tt.inactive_file_id(conflict[1]), conflict[1])
+            file_id = tt.inactive_file_id(conflict[1])
+            # special-case the other tree root (move its children instead)
+            if path_tree and file_id in path_tree:
+                if path_tree.inventory[file_id].parent_id is None:
+                    continue
+            tt.version_file(file_id, conflict[1])
             new_conflicts.add((c_type, 'Versioned directory', conflict[1]))
         elif c_type == 'non-directory parent':
             parent_id = conflict[1]

=== modified file 'bzrlib/transport/remote.py'
--- bzrlib/transport/remote.py	2008-03-28 08:58:43 +0000
+++ bzrlib/transport/remote.py	2008-04-07 10:34:57 +0000
@@ -127,19 +127,17 @@
 
     def is_readonly(self):
         """Smart server transport can do read/write file operations."""
-        resp = self._call2('Transport.is_readonly')
-        if resp == ('yes', ):
-            return True
-        elif resp == ('no', ):
-            return False
-        elif (resp == ('error', "Generic bzr smart protocol error: "
-                                "bad request 'Transport.is_readonly'") or
-              resp == ('error', "Generic bzr smart protocol error: "
-                                "bad request u'Transport.is_readonly'")):
+        try:
+            resp = self._call2('Transport.is_readonly')
+        except errors.UnknownSmartMethod:
             # XXX: nasty hack: servers before 0.16 don't have a
             # 'Transport.is_readonly' verb, so we do what clients before 0.16
             # did: assume False.
             return False
+        if resp == ('yes', ):
+            return True
+        elif resp == ('no', ):
+            return False
         else:
             self._translate_error(resp)
         raise errors.UnexpectedSmartServerResponse(resp)

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2007-10-24 18:19:51 +0000
+++ bzrlib/transport/sftp.py	2008-04-10 09:16:39 +0000
@@ -1019,10 +1019,12 @@
             def close(self):
                 pass
 
-        server = paramiko.SFTPServer(FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
-                                     root=self._root, home=self._server_homedir)
+        server = paramiko.SFTPServer(
+            FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
+            root=self._root, home=self._server_homedir)
         try:
-            server.start_subsystem('sftp', None, sock)
+            server.start_subsystem(
+                'sftp', None, ssh.SocketAsChannelAdapter(sock))
         except socket.error, e:
             if (len(e.args) > 0) and (e.args[0] == errno.EPIPE):
                 # it's okay for the client to disconnect abruptly

=== modified file 'bzrlib/transport/ssh.py'
--- bzrlib/transport/ssh.py	2008-02-08 18:36:35 +0000
+++ bzrlib/transport/ssh.py	2008-04-10 09:16:39 +0000
@@ -172,19 +172,34 @@
     signal.signal(signal.SIGINT, signal.SIG_IGN)
 
 
-class LoopbackSFTP(object):
+class SocketAsChannelAdapter(object):
     """Simple wrapper for a socket that pretends to be a paramiko Channel."""
 
     def __init__(self, sock):
         self.__socket = sock
 
+    def get_name(self):
+        return "bzr SocketAsChannelAdapter"
+    
     def send(self, data):
         return self.__socket.send(data)
 
     def recv(self, n):
-        return self.__socket.recv(n)
+        try:
+            return self.__socket.recv(n)
+        except socket.error, e:
+            if e.args[0] in (errno.EPIPE, errno.ECONNRESET, errno.ECONNABORTED,
+                             errno.EBADF):
+                # Connection has closed.  Paramiko expects an empty string in
+                # this case, not an exception.
+                return ''
+            raise
 
     def recv_ready(self):
+        # TODO: jam 20051215 this function is necessary to support the
+        # pipelined() function. In reality, it probably should use
+        # poll() or select() to actually return if there is data
+        # available, otherwise we probably don't get any benefit
         return True
 
     def close(self):
@@ -237,7 +252,7 @@
             sock.connect((host, port))
         except socket.error, e:
             self._raise_connection_error(host, port=port, orig_error=e)
-        return SFTPClient(LoopbackSFTP(sock))
+        return SFTPClient(SocketAsChannelAdapter(sock))
 
 register_ssh_vendor('loopback', LoopbackVendor())
 
@@ -347,7 +362,7 @@
             argv = self._get_vendor_specific_argv(username, host, port,
                                                   subsystem='sftp')
             sock = self._connect(argv)
-            return SFTPClient(sock)
+            return SFTPClient(SocketAsChannelAdapter(sock))
         except _sftp_connection_errors, e:
             self._raise_connection_error(host, port=port, orig_error=e)
         except (OSError, IOError), e:
@@ -601,13 +616,6 @@
     def send(self, data):
         return os.write(self.proc.stdin.fileno(), data)
 
-    def recv_ready(self):
-        # TODO: jam 20051215 this function is necessary to support the
-        # pipelined() function. In reality, it probably should use
-        # poll() or select() to actually return if there is data
-        # available, otherwise we probably don't get any benefit
-        return True
-
     def recv(self, count):
         return os.read(self.proc.stdout.fileno(), count)
 

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2008-04-01 02:41:25 +0000
+++ bzrlib/versionedfile.py	2008-04-09 00:34:54 +0000
@@ -55,10 +55,6 @@
     Texts are identified by a version-id string.
     """
 
-    def __init__(self, access_mode):
-        self.finished = False
-        self._access_mode = access_mode
-
     @staticmethod
     def check_not_reserved_id(version_id):
         revision.check_not_reserved_id(version_id)
@@ -161,13 +157,7 @@
             if '\n' in line[:-1]:
                 raise errors.BzrBadParameterContainsNewline("lines")
 
-    def _check_write_ok(self):
-        """Is the versioned file marked as 'finished' ? Raise if it is."""
-        if self.finished:
-            raise errors.OutSideTransaction()
-        if self._access_mode != 'w':
-            raise errors.ReadOnlyObjectDirtiedError(self)
-
+    @deprecated_method(one_four)
     def enable_cache(self):
         """Tell this versioned file that it should cache any data it reads.
         
@@ -175,6 +165,7 @@
         """
         pass
     
+    @deprecated_method(one_four)
     def clear_cache(self):
         """Remove any data cached in the versioned file object.
 
@@ -182,6 +173,7 @@
         """
         pass
 
+    @deprecated_method(one_four)
     def clone_text(self, new_version_id, old_version_id, parents):
         """Add an identical text to old_version_id as new_version_id.
 
@@ -191,11 +183,8 @@
         Must raise RevisionAlreadyPresent if the new version is
         already present in file history."""
         self._check_write_ok()
-        return self._clone_text(new_version_id, old_version_id, parents)
-
-    def _clone_text(self, new_version_id, old_version_id, parents):
-        """Helper function to do the _clone_text work."""
-        raise NotImplementedError(self.clone_text)
+        return self.add_lines(new_version_id, parents,
+            self.get_lines(old_version_id))
 
     def get_format_signature(self):
         """Get a text description of the data encoding in this file.
@@ -282,12 +271,13 @@
             if expected_sha1 != sha1:
                 raise errors.VersionedFileInvalidChecksum(version)
 
+    @deprecated_method(one_four)
     def get_sha1(self, version_id):
         """Get the stored sha1 sum for the given revision.
         
         :param version_id: The name of the version to lookup
         """
-        raise NotImplementedError(self.get_sha1)
+        return self.get_sha1s([version_id])[0]
 
     def get_sha1s(self, version_ids):
         """Get the stored sha1 sums for the given revisions.
@@ -297,10 +287,6 @@
         """
         raise NotImplementedError(self.get_sha1s)
 
-    def get_suffixes(self):
-        """Return the file suffixes associated with this versioned file."""
-        raise NotImplementedError(self.get_suffixes)
-    
     def get_text(self, version_id):
         """Return version contents as a text string.
 
@@ -353,7 +339,8 @@
         but are not explicitly marked.
         """
         raise NotImplementedError(self.get_ancestry_with_ghosts)
-        
+    
+    @deprecated_method(one_four)
     def get_graph(self, version_ids=None):
         """Return a graph from the versioned file. 
         
@@ -362,18 +349,28 @@
                             None means retrieve all versions.
         """
         if version_ids is None:
-            return dict(self.iter_parents(self.versions()))
-        result = {}
-        pending = set(version_ids)
-        while pending:
-            this_iteration = pending
-            pending = set()
-            for version, parents in self.iter_parents(this_iteration):
-                result[version] = parents
-                for parent in parents:
-                    if parent in result:
-                        continue
-                    pending.add(parent)
+            result = self.get_parent_map(self.versions())
+        else:
+            result = {}
+            pending = set(version_ids)
+            while pending:
+                this_iteration = pending
+                pending = set()
+                parents = self.get_parent_map(this_iteration)
+                for version, parents in parents.iteritems():
+                    result[version] = parents
+                    for parent in parents:
+                        if parent in result:
+                            continue
+                        pending.add(parent)
+        references = set()
+        for parents in result.itervalues():
+            references.update(parents)
+        existing_parents = self.get_parent_map(references)
+        for key, parents in result.iteritems():
+            present_parents = [parent for parent in parents if parent in
+                existing_parents]
+            result[key] = tuple(present_parents)
         return result
 
     @deprecated_method(one_four)
@@ -425,6 +422,7 @@
         except KeyError:
             raise errors.RevisionNotPresent(version_id, self)
 
+    @deprecated_method(one_four)
     def annotate_iter(self, version_id):
         """Yield list of (version-id, line) pairs for the specified
         version.
@@ -432,10 +430,15 @@
         Must raise RevisionNotPresent if the given version is
         not present in file history.
         """
-        raise NotImplementedError(self.annotate_iter)
+        return iter(self.annotate(version_id))
 
     def annotate(self, version_id):
-        return list(self.annotate_iter(version_id))
+        """Return a list of (version-id, line) tuples for version_id.
+
+        :raise RevisionNotPresent: If the given version is
+        not present in file history.
+        """
+        raise NotImplementedError(self.annotate)
 
     def join(self, other, pb=None, msg=None, version_ids=None,
              ignore_missing=False):
@@ -477,6 +480,7 @@
         """
         raise NotImplementedError(self.iter_lines_added_or_present_in_versions)
 
+    @deprecated_method(one_four)
     def iter_parents(self, version_ids):
         """Iterate through the parents for many version ids.
 
@@ -488,14 +492,6 @@
         """
         return self.get_parent_map(version_ids).iteritems()
 
-    def transaction_finished(self):
-        """The transaction that this file was opened in has finished.
-
-        This records self.finished = True and should cause all mutating
-        operations to error.
-        """
-        self.finished = True
-
     def plan_merge(self, ver_a, ver_b):
         """Return pseudo-annotation indicating how the two versions merge.
 

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2008-04-01 02:41:25 +0000
+++ bzrlib/weave.py	2008-04-09 00:34:54 +0000
@@ -185,7 +185,13 @@
     __slots__ = ['_weave', '_parents', '_sha1s', '_names', '_name_map',
                  '_weave_name', '_matcher']
     
-    def __init__(self, weave_name=None, access_mode='w', matcher=None):
+    def __init__(self, weave_name=None, access_mode='w', matcher=None, get_scope=None):
+        """Create a weave.
+
+        :param get_scope: A callable that returns an opaque object to be used
+            for detecting when this weave goes out of scope (should stop
+            answering requests or allowing mutation).
+        """
         super(Weave, self).__init__(access_mode)
         self._weave = []
         self._parents = []
@@ -197,10 +203,22 @@
             self._matcher = bzrlib.patiencediff.PatienceSequenceMatcher
         else:
             self._matcher = matcher
+        if get_scope is None:
+            get_scope = lambda:None
+        self._get_scope = get_scope
+        self._scope = get_scope()
+        self._access_mode = access_mode
 
     def __repr__(self):
         return "Weave(%r)" % self._weave_name
 
+    def _check_write_ok(self):
+        """Is the versioned file marked as 'finished' ? Raise if it is."""
+        if self._get_scope() != self._scope:
+            raise errors.OutSideTransaction()
+        if self._access_mode != 'w':
+            raise errors.ReadOnlyObjectDirtiedError(self)
+
     def copy(self):
         """Return a deep copy of self.
         
@@ -401,11 +419,6 @@
                 offset += 2 + (j2 - j1)
         return new_version
 
-    def _clone_text(self, new_version_id, old_version_id, parents):
-        """See VersionedFile.clone_text."""
-        old_lines = self.get_text(old_version_id)
-        self.add_lines(new_version_id, parents, old_lines)
-
     def _inclusions(self, versions):
         """Return set of all ancestors of given version(s)."""
         if not len(versions):
@@ -453,13 +466,13 @@
         """
         return len(other_parents.difference(my_parents)) == 0
 
-    def annotate_iter(self, version_id):
-        """Yield list of (version-id, line) pairs for the specified version.
+    def annotate(self, version_id):
+        """Return a list of (version-id, line) tuples for version_id.
 
         The index indicates when the line originated in the weave."""
         incls = [self._lookup(version_id)]
-        for origin, lineno, text in self._extract(incls):
-            yield self._idx_to_name(origin), text
+        return [(self._idx_to_name(origin), text) for origin, lineno, text in
+            self._extract(incls)]
 
     def iter_lines_added_or_present_in_versions(self, version_ids=None,
                                                 pb=None):
@@ -670,10 +683,6 @@
                        expected_sha1, measured_sha1))
         return result
 
-    def get_sha1(self, version_id):
-        """See VersionedFile.get_sha1()."""
-        return self._sha1s[self._lookup(version_id)]
-
     def get_sha1s(self, version_ids):
         """See VersionedFile.get_sha1s()."""
         return [self._sha1s[self._lookup(v)] for v in version_ids]
@@ -865,12 +874,12 @@
 
     WEAVE_SUFFIX = '.weave'
     
-    def __init__(self, name, transport, filemode=None, create=False, access_mode='w'):
+    def __init__(self, name, transport, filemode=None, create=False, access_mode='w', get_scope=None):
         """Create a WeaveFile.
         
         :param create: If not True, only open an existing knit.
         """
-        super(WeaveFile, self).__init__(name, access_mode)
+        super(WeaveFile, self).__init__(name, access_mode, get_scope=get_scope)
         self._transport = transport
         self._filemode = filemode
         try:
@@ -891,11 +900,6 @@
         self._save()
         return result
 
-    def _clone_text(self, new_version_id, old_version_id, parents):
-        """See VersionedFile.clone_text."""
-        super(WeaveFile, self)._clone_text(new_version_id, old_version_id, parents)
-        self._save
-
     def copy_to(self, name, transport):
         """See VersionedFile.copy_to()."""
         # as we are all in memory always, just serialise to the new place.

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2008-03-17 21:58:47 +0000
+++ bzrlib/workingtree_4.py	2008-04-09 00:34:54 +0000
@@ -1402,7 +1402,7 @@
                       default_revision=_mod_revision.CURRENT_REVISION):
         """See Tree.annotate_iter"""
         w = self._get_weave(file_id)
-        return w.annotate_iter(self.inventory[file_id].revision)
+        return w.annotate(self.inventory[file_id].revision)
 
     def _get_ancestors(self, default_revision):
         return set(self._repository.get_ancestry(self._revision_id,

=== added file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	1970-01-01 00:00:00 +0000
+++ bzrlib/xml5.py	2008-03-28 03:09:47 +0000
@@ -0,0 +1,84 @@
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib import (
+    cache_utf8,
+    inventory,
+    xml6,
+    xml8,
+    )
+
+class Serializer_v5(xml6.Serializer_v6):
+    """Version 5 serializer
+
+    Packs objects into XML and vice versa.
+    """
+    format_num = '5'
+    root_id = inventory.ROOT_ID
+
+    def _unpack_inventory(self, elt, revision_id):
+        """Construct from XML Element
+        """
+        assert elt.tag == 'inventory'
+        root_id = elt.get('file_id') or inventory.ROOT_ID
+        root_id = xml8._get_utf8_or_ascii(root_id)
+
+        format = elt.get('format')
+        if format is not None:
+            if format != '5':
+                raise BzrError("invalid format version %r on inventory"
+                                % format)
+        data_revision_id = elt.get('revision_id')
+        if data_revision_id is not None:
+            revision_id = cache_utf8.encode(data_revision_id)
+        inv = inventory.Inventory(root_id, revision_id=revision_id)
+        for e in elt:
+            ie = self._unpack_entry(e)
+            if ie.parent_id is None:
+                ie.parent_id = root_id
+            inv.add(ie)
+        if revision_id is not None:
+            inv.root.revision = revision_id
+        return inv
+
+    def _check_revisions(self, inv):
+        """Extension point for subclasses to check during serialisation.
+
+        In this version, no checking is done.
+
+        :param inv: An inventory about to be serialised, to be checked.
+        :raises: AssertionError if an error has occured.
+        """
+
+    def _append_inventory_root(self, append, inv):
+        """Append the inventory root to output."""
+        if inv.root.file_id not in (None, inventory.ROOT_ID):
+            fileid1 = ' file_id="'
+            fileid2 = xml8._encode_and_escape(inv.root.file_id)
+        else:
+            fileid1 = ""
+            fileid2 = ""
+        if inv.revision_id is not None:
+            revid1 = ' revision_id="'
+            revid2 = xml8._encode_and_escape(inv.revision_id)
+        else:
+            revid1 = ""
+            revid2 = ""
+        append('<inventory%s%s format="5"%s%s>\n' % (
+            fileid1, fileid2, revid1, revid2))
+
+
+serializer_v5 = Serializer_v5()

=== added file 'bzrlib/xml6.py'
--- bzrlib/xml6.py	1970-01-01 00:00:00 +0000
+++ bzrlib/xml6.py	2008-03-28 02:28:52 +0000
@@ -0,0 +1,33 @@
+# Copyright (C) 2008 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib import xml8
+
+
+class Serializer_v6(xml8.Serializer_v8):
+    """This serialiser supports rich roots.
+
+    While its inventory format number is 6, its revision format is 5.
+    Its inventory_sha1 may be inaccurate-- the inventory may have been
+    converted from format 5 or 7 without updating the sha1.
+    """
+
+    format_num = '6'
+    # Format 6 & 7 reported their revision format as 5.
+    revision_format_num = '5'
+
+
+serializer_v6 = Serializer_v6()

=== removed file 'bzrlib/xml6.py'
--- bzrlib/xml6.py	2007-10-05 02:41:37 +0000
+++ bzrlib/xml6.py	1970-01-01 00:00:00 +0000
@@ -1,71 +0,0 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib import cache_utf8, inventory, errors, xml5
-
-
-class Serializer_v6(xml5.Serializer_v5):
-    """This serialiser adds rich roots."""
-
-    format_num = '6'
-    root_id = None
-
-    def _append_inventory_root(self, append, inv):
-        """Append the inventory root to output."""
-        if inv.revision_id is not None:
-            revid1 = ' revision_id="'
-            revid2 = xml5._encode_and_escape(inv.revision_id)
-        else:
-            revid1 = ""
-            revid2 = ""
-        append('<inventory format="%s"%s%s>\n' % (
-            self.format_num, revid1, revid2))
-        append('<directory file_id="%s name="%s revision="%s />\n' % (
-            xml5._encode_and_escape(inv.root.file_id),
-            xml5._encode_and_escape(inv.root.name),
-            xml5._encode_and_escape(inv.root.revision)))
-
-    def _check_revisions(self, inv):
-        """Extension point for subclasses to check during serialisation.
-
-        By default no checking is done.
-
-        :param inv: An inventory about to be serialised, to be checked.
-        :raises: AssertionError if an error has occured.
-        """
-        assert inv.revision_id is not None
-        assert inv.root.revision is not None
-
-    def _unpack_inventory(self, elt, revision_id=None):
-        """Construct from XML Element"""
-        if elt.tag != 'inventory':
-            raise errors.UnexpectedInventoryFormat('Root tag is %r' % elt.tag)
-        format = elt.get('format')
-        if format != self.format_num:
-            raise errors.UnexpectedInventoryFormat('Invalid format version %r'
-                                                   % format)
-        revision_id = elt.get('revision_id')
-        if revision_id is not None:
-            revision_id = cache_utf8.encode(revision_id)
-        inv = inventory.Inventory(root_id=None, revision_id=revision_id)
-        for e in elt:
-            ie = self._unpack_entry(e)
-            inv.add(ie)
-        assert inv.root.revision is not None
-        return inv
-
-
-serializer_v6 = Serializer_v6()

=== renamed file 'bzrlib/xml5.py' => 'bzrlib/xml8.py'
--- bzrlib/xml5.py	2007-10-19 17:14:33 +0000
+++ bzrlib/xml8.py	2008-04-17 05:49:53 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -138,30 +138,31 @@
     _to_escaped_map.clear()
 
 
-class Serializer_v5(Serializer):
-    """Version 5 serializer
+class Serializer_v8(Serializer):
+    """This serialiser adds rich roots.
 
-    Packs objects into XML and vice versa.
+    Its revision format number matches its inventory number.
     """
-    
+
     __slots__ = []
 
-    root_id = ROOT_ID
+    root_id = None
     support_altered_by_hack = True
     # This format supports the altered-by hack that reads file ids directly out
     # of the versionedfile, without doing XML parsing.
 
     supported_kinds = set(['file', 'directory', 'symlink'])
-    format_num = '5'
+    format_num = '8'
+    revision_format_num = None
 
     def _check_revisions(self, inv):
         """Extension point for subclasses to check during serialisation.
 
-        By default no checking is done.
-
         :param inv: An inventory about to be serialised, to be checked.
         :raises: AssertionError if an error has occured.
         """
+        assert inv.revision_id is not None
+        assert inv.root.revision is not None
 
     def write_inventory_to_lines(self, inv):
         """Return a list of lines with the encoded inventory."""
@@ -273,21 +274,19 @@
 
     def _append_inventory_root(self, append, inv):
         """Append the inventory root to output."""
-        if inv.root.file_id not in (None, ROOT_ID):
-            fileid1 = ' file_id="'
-            fileid2 = _encode_and_escape(inv.root.file_id)
-        else:
-            fileid1 = ""
-            fileid2 = ""
         if inv.revision_id is not None:
             revid1 = ' revision_id="'
             revid2 = _encode_and_escape(inv.revision_id)
         else:
             revid1 = ""
             revid2 = ""
-        append('<inventory%s%s format="5"%s%s>\n' % (
-            fileid1, fileid2, revid1, revid2))
-        
+        append('<inventory format="%s"%s%s>\n' % (
+            self.format_num, revid1, revid2))
+        append('<directory file_id="%s name="%s revision="%s />\n' % (
+            _encode_and_escape(inv.root.file_id),
+            _encode_and_escape(inv.root.name),
+            _encode_and_escape(inv.root.revision)))
+
     def _pack_revision(self, rev):
         """Revision object -> xml tree"""
         # For the XML format, we need to write them as Unicode rather than as
@@ -297,12 +296,15 @@
         revision_id = rev.revision_id
         if isinstance(revision_id, str):
             revision_id = decode_utf8(revision_id)
+        format_num = self.format_num
+        if self.revision_format_num is not None:
+            format_num = self.revision_format_num
         root = Element('revision',
                        committer = rev.committer,
                        timestamp = '%.3f' % rev.timestamp,
                        revision_id = revision_id,
                        inventory_sha1 = rev.inventory_sha1,
-                       format='5',
+                       format=format_num,
                        )
         if rev.timezone is not None:
             root.set('timezone', str(rev.timezone))
@@ -336,29 +338,22 @@
             prop_elt.tail = '\n'
         top_elt.tail = '\n'
 
-    def _unpack_inventory(self, elt, revision_id):
-        """Construct from XML Element
-        """
-        assert elt.tag == 'inventory'
-        root_id = elt.get('file_id') or ROOT_ID
-        root_id = _get_utf8_or_ascii(root_id)
-
+    def _unpack_inventory(self, elt, revision_id=None):
+        """Construct from XML Element"""
+        if elt.tag != 'inventory':
+            raise errors.UnexpectedInventoryFormat('Root tag is %r' % elt.tag)
         format = elt.get('format')
-        if format is not None:
-            if format != '5':
-                raise BzrError("invalid format version %r on inventory"
-                                % format)
-        data_revision_id = elt.get('revision_id')
-        if data_revision_id is not None:
-            revision_id = cache_utf8.encode(data_revision_id)
-        inv = Inventory(root_id, revision_id=revision_id)
+        if format != self.format_num:
+            raise errors.UnexpectedInventoryFormat('Invalid format version %r'
+                                                   % format)
+        revision_id = elt.get('revision_id')
+        if revision_id is not None:
+            revision_id = cache_utf8.encode(revision_id)
+        inv = inventory.Inventory(root_id=None, revision_id=revision_id)
         for e in elt:
             ie = self._unpack_entry(e)
-            if ie.parent_id is None:
-                ie.parent_id = root_id
             inv.add(ie)
-        if revision_id is not None:
-            inv.root.revision = revision_id
+        assert inv.root.revision is not None
         return inv
 
     def _unpack_entry(self, elt):
@@ -404,9 +399,12 @@
         """XML Element -> Revision object"""
         assert elt.tag == 'revision'
         format = elt.get('format')
+        format_num = self.format_num
+        if self.revision_format_num is not None:
+            format_num = self.revision_format_num
         if format is not None:
-            if format != '5':
-                raise BzrError("invalid format version %r on inventory"
+            if format != format_num:
+                raise BzrError("invalid format version %r on revision"
                                 % format)
         get_cached = _get_utf8_or_ascii
         rev = Revision(committer = elt.get('committer'),
@@ -449,4 +447,4 @@
             rev.properties[name] = value
 
 
-serializer_v5 = Serializer_v5()
+serializer_v8 = Serializer_v8()

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2008-01-09 00:51:01 +0000
+++ bzrlib/xml_serializer.py	2008-03-28 02:10:23 +0000
@@ -179,3 +179,4 @@
 format_registry.register_lazy('5', 'bzrlib.xml5', 'serializer_v5')
 format_registry.register_lazy('6', 'bzrlib.xml6', 'serializer_v6')
 format_registry.register_lazy('7', 'bzrlib.xml7', 'serializer_v7')
+format_registry.register_lazy('8', 'bzrlib.xml8', 'serializer_v8')

=== modified file 'doc/developers/HACKING.txt'
--- doc/developers/HACKING.txt	2008-01-16 00:26:25 +0000
+++ doc/developers/HACKING.txt	2008-04-11 07:42:28 +0000
@@ -2,12 +2,21 @@
 Bazaar Developer Guide
 ======================
 
+This document describes the Bazaar internals and the development process.  
+It's meant for people interested in developing Bazaar, and some parts will
+also be useful to people developing Bazaar plugins.
+
+If you have any questions or something seems to be incorrect, unclear or
+missing, please talk to us in ``irc://irc.freenode.net/#bzr``, or write to
+the Bazaar mailing list.  To propose a correction or addition to this
+document, send a merge request or new text to the mailing list.
+
+The current version of this document is available in the file 
+``doc/developers/HACKING.txt`` in the source tree, or at
+http://doc.bazaar-vcs.org/bzr.dev/en/developer-guide/HACKING.html
+
 .. contents::
 
-(The current version of this document is available in the file 
-``doc/developers/HACKING.txt`` in the source tree, or at
-http://doc.bazaar-vcs.org/bzr.dev/en/developer-guide/HACKING.html)
-
 
 Getting Started
 ###############
@@ -2000,5 +2009,132 @@
 #. Update http://bazaar-vcs.org/WindowsDownloads to have the correct version number as well as the correct sha1sum displayed.
 
 
+The Bazaar PPA archive
+----------------------
+
+We build Ubuntu ``.deb`` packages for Bazaar as an important part of the release
+process.  These packages are hosted in a `Personal Package Archive (PPA)`__ on
+Launchpad, at <https://launchpad.net/~bzr/+archive>.
+
+  __ https://help.launchpad.net/PPAQuickStart
+
+We build packages for every supported Ubuntu release
+<https://wiki.ubuntu.com/Releases>.  Packages need no longer be updated
+when the release passes end-of-life because all users should have then
+update.
+
+The ``debian/`` directory containing the packaging information is kept in
+branches on Launchpad, named like 
+<https://code.launchpad.net/~bzr/bzrtools/packaging-dapper>
+
+Updating the PPA for a new release
+----------------------------------
+
+Preconditions for building these packages:
+  
+ * You must have a Launchpad account and be a member of the `~bzr`__ team
+   
+ __ https://edge.launchpad.net/~bzr/+members>
+
+ * You must have a GPG key registered to your Launchpad account.
+
+ * Configure ``dput`` to upload to our PPA with this section in your
+   ``~/.dput.cf``::
+
+        [bzr-ppa]
+        fqdn = ppa.launchpad.net
+        method = ftp
+        incoming = ~bzr/ubuntu
+        login = anonymous
+        allow_unsigned_uploads = 0
+
+ * You need a Ubuntu (or probably Debian) machine, and ::
+
+     sudo apt-get install build-essential devscripts dput
+
+Here is the process; there are some steps which should be automated in
+future:
+
+#. You will need a working directory for each supported release, such as
+   ``~/bzr/Packaging/dapper``
+
+#. Download the official tarball of the release to e.g. ``~/bzr/Releases``
+
+#. Copy the original tarball into your per-disto directory, then untar it 
+   and if necessary rename it::
+
+     cp -l ~/bzr/Releases/bzrtools-1.3.0.tar.gz bzrtools_1.3.0.orig.tar.gz
+     tar xfvz bzrtools_1.3.0.orig.tar.gz
+     mv bzrtools bzrtools-1.3.0
+
+#. Change into that directory and check out the packaging branch::
+
+     cd bzrtools
+     bzr checkout \
+       bzr+ssh://bazaar.launchpad.net/~bzr/bzrtools/packaging-dapper \
+       debian
+
+#. For Bazaar plugins, change the ``debian/control`` file to express a
+   dependency on the correct version of ``bzr``.
+
+   For bzrtools this is typically::
+
+      Build-Depends-Indep: bzr (>= 1.3~), rsync
+      Depends: ${python:Depends}, bzr (>= 1.3~), bzr (<< 1.4~), patch
+
+#. Make a new ``debian/changelog`` entry for the new release,
+   either by using ``dch`` or just editing the file::
+
+     dch -v '1.3.0-1~bazaar1~dapper1' -D dapper
+
+   dch will default to the distro you're working in and this isn't checked
+   against the version number (which is just our conversion).  So make
+   sure to specify it.
+
+   Make sure you have the correct email address for yourself, version
+   number, and distribution.  It should look something like this::
+
+     >  bzrtools (1.3.0-1~bazaar1~dapper1) dapper; urgency=low
+     >
+     >   * New upstream release.
+     >
+     >  -- John Sample <sample@example.com>  Mon, 31 Mar 2008 12:36:27 +1100
+
+   If you need to upload the package again to fix a problem, normally you
+   should increment the last number in the version number, following the
+   distro name.  Make sure not to omit the initial ``-1``, and make sure
+   that the distro name in the version is consistent with the target name
+   outside the parenthesis.
+
+#. Commit these changes into the packaging branch::
+
+     bzr ci -m '1.3.0-1~bazaar1~dapper1: New upstream release.' debian
+
+#. Build a source package::
+
+     debuild -S -sa -i
+
+   This will create a ``.changes`` file in the per-distro directory,
+   and should invoke gpg to sign it with your key.
+   Check that file is reasonable: it should be uploading to the intended
+   distribution, have a .orig file included, and the right version number.
+
+#. Upload into the PPA::
+
+     dput bzr-ppa ../bzrtools__1.3.0-1\~bazaar1\~dapper1_source.changes
+
+   Don't forget the ``bzr-ppa`` component or dput will try to upload into
+   the main archive by default.  You can disable this by adding this
+   section to your ``.dput.cf``::
+
+     [ubuntu]
+     fqdn = SPECIFY.A.PPA.NAME
+
+#. You should soon get an "upload accepted" mail from Launchpad, which
+   means that your package is waiting to be built.  You can then track its
+   progress in <https://launchpad.net/~bzr/+archive> and
+   <https://launchpad.net/~bzr/+archive/+builds>.
+
+
 ..
    vim: ft=rst tw=74 ai

=== modified file 'doc/developers/index.txt'
--- doc/developers/index.txt	2008-01-11 05:08:20 +0000
+++ doc/developers/index.txt	2008-04-08 07:46:55 +0000
@@ -35,8 +35,13 @@
 
 * `Network protocol <network-protocol.html>`_ |--| Custom network protocol.
 
+* `Plugin APIs <plugin-api.html>`_ |--| APIs plugins should use.
+
 * `Repositories <repository.html>`_ |--| What repositories do and are used for.
 
+* `Integration Guide <integration.html>`_ |--| A guide to integrate bzrlib into
+  any python application.
+
 Data formats
 ============
 

=== added file 'doc/developers/integration.txt'
--- doc/developers/integration.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/integration.txt	2008-04-08 10:55:41 +0000
@@ -0,0 +1,304 @@
+=======================
+Integrating with Bazaar
+=======================
+
+This page should hopefully become a quick guide to integrating other
+(Python-based) software with Bazaar.
+
+Manipulating the Working Tree
+=============================
+Most objects in Bazaar are in files, named after the class they contain.
+To manipulate the Working Tree we need a valid WorkingTree object, which
+is loaded from the workingtree.py file, eg::
+
+  from bzrlib import workingtree
+  wt = workingtree.WorkingTree.open('/home/jebw/bzrtest')
+
+
+This gives us a WorkingTree object, which has various methods spread over
+itself, and its parent classes MutableTree and Tree - its worth having a
+look through these three files (workingtree.py, mutabletree.py and tree.py)
+to see which methods are available.
+
+Compare trees
+===============
+There are two methods for comparing trees: ``changes_from`` and
+``iter_changes``.  ``iter_changes`` is more regular and precise, but it is
+somewhat harder to work with.  See the API documentation for more details.
+
+``changes_from`` creates a Delta object showing changes::
+
+  from bzrlib import delta
+  changes = wt.changes_from(wt.basis_tree())
+
+This gives us a Delta object, which has several lists of files for each type of
+change, eg changes.added is a list of added files, changes.removed is list
+of removed files, changes.modified is a list of modified files. The contents
+of the lists aren't just filenames, but include other information as well.
+To grab just the filename we want the first value, eg::
+
+  print("list of newly added files")
+  for filename in changes.added:
+    print("%s has been added" % filename[0])
+
+
+The exception to this is changes.renamed, where the list returned for each
+renamed files contains both the old and new names -- one or both may interest
+you, depending on what you're doing.
+
+For example::
+
+  print("list of renamed files")
+  for filename in changes.renamed:
+    print("%s has been renamed to %s" % (filename[0], filename[1]))
+
+
+Adding Files
+============
+
+If you want to add files the same way ``bzr add`` does, you can use
+MutableTree.smart_add.  By default, this is recursive. Paths can either be
+absolute or relative to the workingtree::
+
+  wt.smart_add(['dir1/filea.txt', 'fileb.txt',
+                '/home/jebw/bzrtesttree/filec.txt'])
+
+
+For more precise control over which files to add, use MutableTree.add::
+
+  wt.add(['dir1/filea.txt', 'fileb.txt', '/home/jebw/bzrtesttree/filec.txt'])
+
+
+Removing Files
+==============
+
+You can remove multiple files at once.  The file paths need to be relative
+to the workingtree::
+
+  wt.remove(['filea.txt', 'fileb.txt', 'dir1'])
+
+
+By default, the files are not deleted, just removed from the inventory.
+To delete them from the filesystem as well::
+
+  wt.remove(['filea.txt', 'fileb.txt', 'dir1'], keep_files=False)
+
+
+Renaming a File
+===============
+
+You can rename one file to a different name using WorkingTree.rename_one.
+You just provide the old and new names, eg::
+
+  wt.rename_one('oldfile.txt','newfile.txt')
+
+
+Moving Files
+============
+
+You can move multiple files from one directory into another using
+WorkingTree.move::
+
+  wt.move(['olddir/file.txt'], 'newdir')
+
+
+More complicated renames/moves can be done with transform.TreeTransform,
+which is outside the scope of this document.
+
+
+Committing Changes
+==================
+
+To commit _all_ the changes to our working tree we can just call the
+WorkingTree's commit method, giving it a commit message, eg::
+
+  wt.commit('this is my commit message')
+
+
+To commit only certain files, we need to provide a list of filenames which we
+want committing, eg::
+
+  wt.commit(message='this is my commit message', specific_files=['fileA.txt',
+            'dir2/fileB.txt', 'fileD.txt'])
+
+
+Generating a Log for a File
+===========================
+
+Generating a log is, in itself, simple.  Grab a branch (see below) and pass
+it to show_log together with a log formatter, eg::
+
+  from bzrlib import log
+  from bzrlib import branch
+
+  b = branch.Branch.open('/path/to/bazaar/branch')
+  lf = log.LongLogFormatter(to_file=sys.stdout)
+  log.show_log(b, lf)
+
+
+Three log formatters are included with bzrlib: LongLogFormatter,
+ShortLogFormatter and LineLogFormatter.  These provide long, short and
+single-line log output formats. It's also possible to write your own in
+very little code.
+
+Annotating a File
+=================
+
+To annotate a file, we want to walk every line of a file, retrieving the
+revision which last modified/created that line and then retrieving the
+information for that revision.
+
+First we get an annotation iterator for the file we are interested in::
+
+  tree, relpath = workingtree.WorkingTree.open_containing('/path/to/file.txt')
+  fileid = tree.path2id(relpath)
+  annotation = list(tree.annotate_iter(fileid))
+
+
+To avoid repeatedly retrieving the same revisions we grab all revisions
+associated with the file at once and build up a map of id to revision
+information. We also build an map of revision numbers, again indexed
+by the revision id::
+
+  revision_ids = set(revision_id for revision_id, text in annotation)
+  revisions = tree.branch.repository.get_revisions(revision_ids)
+  revision_map = dict(izip(revision_ids, revisions))
+  revno_map = tree.branch.get_revision_id_to_revno_map()
+
+
+Finally, we use our annotation iterator to walk the lines of the file,
+displaying the information from our revision maps as we go::
+
+  for revision_id, text in annotation :
+      rev = revision_map[revision_id]
+      revno = revno_map[revision_id]
+      revno_string = '.'.join(str(i) for i in revno)
+      print "%s, %s: %s" % (revno_string, rev.committer, text)
+
+
+Working with branches
+=====================
+
+To work with a branch you need a branch object, created from your branch::
+
+  from bzrlib import branch
+
+  b = branch.Branch.open('/home/jebw/bzrtest')
+
+
+Branching from an existing branch
+=================================
+
+To branch you create a branch object representing the branch you are
+branching from, and supply a path/url to the new branch location.
+The following code clones the bzr.dev branch (the latest copy of the Bazaar
+source code) - be warned it has to download 60meg so takes a while to run
+with no feedback::
+
+  from bzrlib import branch
+
+  b = branch.Branch.open('http://bazaar-vcs.org/bzr/bzr.dev')
+  nb = b.bzrdir.sprout('/tmp/newBzrBranch').open_branch()
+
+
+This provides no feedback, since Bazaar automatically uses the 'silent' UI.
+
+
+Pushing and pulling branches
+============================
+
+To push a branch you need to open the source and destination branches, then
+just call push with the other branch as a parameter::
+
+  from bzrlib import branch
+
+  b1 = branch.Branch.open('file:///home/user/mybranch')
+  b2 = branch.Branch.open('http://bazaar-vcs.org/bzr/bzr.dev')
+  b1.push(b2)
+
+
+Pulling is much the same::
+
+  b1.pull(b2)
+
+
+If you have a working tree, as well as a branch, you should use
+WorkingTree.pull, not Branch.pull.
+
+This won't handle conflicts automatically though, so any conflicts will be
+left in the working tree for the user to resolve.
+
+
+Checkout from an existing branch
+================================
+
+This performs a Lightweight checkout from an existing Branch::
+
+  from bzrlib import bzrdir
+
+  accelerator_tree, source = bzrdir.BzrDir.open_tree_or_branch('http:URL')
+  source.create_checkout('/tmp/newBzrCheckout', None, True, accelerator_tree)
+
+
+To make a heavyweight checkout, change the last line to::
+
+  source.create_checkout('/tmp/newBzrCheckout', None, False, accelerator_tree
+
+==================
+History Operations
+==================
+
+Finding the last revision number or id
+======================================
+
+To get the last revision number and id of a branch use::
+
+  revision_number, revision_id = branch.last_revision_info()
+
+
+If all you care about is the revision_id there is also the
+method::
+
+  revision_id = branch.last_revision()
+
+
+Getting the list of revision ids that make up a branch
+======================================================
+
+IMPORTANT: This should be avoided wherever possible, as it scales with the
+length of history::
+
+  revisions = branch.revision_history()
+
+now revisions[0] is the revision id of the first commit, and revs[-1] is the
+revision id of the most recent. Note that if all you want is the last
+revision then you should use branch.last_revision() as described above, as
+it is vastly more efficient.
+
+
+Getting a Revision object from a revision id
+============================================
+
+The Revision object has attributes like "message" to get the information
+about the revision::
+
+  repo = branch.repository
+  revision = repo.get_revision(rev_id)
+
+
+Accessing the files from a revision
+===================================
+
+To get the file contents and tree shape for a specific revision you need
+a RevisionTree. These are supplied by the repository for a specific
+revision id::
+
+  revtree = repo.revision_tree(rev_id)
+
+RevisionTrees, like all trees, can be compared as described in "Comparing
+Trees" above.
+
+The most common way to list files in a tree is ``Tree.iter_entries()``.
+The simplest way to get file content is ``Tree.get_file()``.  The best way
+to retrieve file content for large numbers of files `Tree.iter_files_bytes()``
+

=== added file 'doc/developers/plugin-api.txt'
--- doc/developers/plugin-api.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/plugin-api.txt	2008-04-06 23:37:06 +0000
@@ -0,0 +1,173 @@
+==========
+Plugin API
+==========
+
+Status
+======
+
+:Date: 2008-02-29
+
+bzrlib has a very flexible internal structure allowing plugins for many
+operations. Plugins can add commands, new storage formats, diff and merge
+features and more. This document provides an overview of the API and
+conventions for plugin authors.
+
+.. contents::
+
+
+Structure of a plugin
+=====================
+
+Plugins are Python modules under ``bzrlib.plugins``. They can be installed
+either into the PYTHONPATH in that location, or in ~/.bazaar/plugins.
+
+Plugins should have a setup.py.
+
+As for other Python modules, the name of the directory must match the
+expected name of the plugin.
+
+
+Plugin metadata before installation
+===================================
+
+Plugins can export a summary of what they provide, and what versions of bzrlib
+they are compatible with. This allows tools to be written to work with plugins,
+such as to generate a directory of plugins, or install them via a
+symlink/checkout to ~/.bazaar/plugins.
+
+This interface allows bzr to interrogate a plugin without actually loading
+it. This is useful because loading a plugin may have side effects such
+as registering or overriding commands, or the plugin may raise an error,
+if for example a prerequisite is not present.
+
+
+Metadata protocol
+-----------------
+
+A plugin that supports the bzr plugin metadata protocol will do two
+things. Firstly, the ``setup.py`` for the plugin will guard the call to
+``setup()``::
+
+  if __name__ == 'main':
+      setup(...)
+
+Secondly, the setup module will have one or more of the following variables
+present at module scope. Any variables that are missing will be given the
+defaults from the table. An example of every variable is provided after
+the full list.
+
++------------------------+---------+----------------------------------------+
+| Variable               | Default | Definition                             |
++========================+=========+========================================+
+| bzr_plugin_name        | None    | The name the plugin package should be  |
+|                        |         | given on disk. The plugin is then      |
+|                        |         | available to python at                 |
+|                        |         | bzrlib.plugins.NAME                    |
++------------------------+---------+----------------------------------------+
+| bzr_commands           | []      | A list of the commands that the plugin |
+|                        |         | provides. Commands that already exist  |
+|                        |         | in bzr and are decorated by the plugin |
+|                        |         | do not need to be listed (but it is not|
+|                        |         | harmful if you do list them).          |
++------------------------+---------+----------------------------------------+
+| bzr_plugin_version     | None    | A version_info 5-tuple with the plugins|
+|                        |         | version.                               |
++------------------------+---------+----------------------------------------+
+| bzr_minimum_version    | None    | A version_info 3-tuple for comparison  |
+|                        |         | with the bzrlib minimum and current    |
+|                        |         | version, for determining likely        |
+|                        |         | compatibility.                         |
++------------------------+---------+----------------------------------------+
+| bzr_maximum_version    | None    | A version_info 3-tuple like            |
+|                        |         | bzr_minimum_version but checking the   |
+|                        |         | upper limits supported.                |
++------------------------+---------+----------------------------------------+
+| bzr_control_formats    | {}      | A dictionary of descriptions of version|
+|                        |         | control directories. See               |
+|                        |         | `Control Formats` below.               |
++------------------------+---------+----------------------------------------+
+| bzr_checkout_formats   | {}      | A dictionary of tree_format_string ->  |
+|                        |         | human description strings, for tree    |
+|                        |         | formats that drop into the             |
+|                        |         | ``.bzr/checkout`` metadir system.      |
++------------------------+---------+----------------------------------------+
+| bzr_branch_formats     | {}      | As bzr_checkout_formats but for        |
+|                        |         | branches.                              |
++------------------------+---------+----------------------------------------+
+| bzr_repository_formats | {}      | As bzr_checkout_formats but for        |
+|                        |         | repositories.                          |
++------------------------+---------+----------------------------------------+
+
+Control Formats
+---------------
+
+Because disk format detection for formats that bzr does not understand at
+all can be useful, we allow a declarative description of the shape of a
+control directory. Each description has a name for showing to users, and a
+dictonary of relative paths, and the content needed at each path. Paths
+that end in '/' are required to be directories and the value for that key
+is ignored. Other paths are required to be regular files, and the value
+for that key is either None, in which case the file is statted but the
+content is ignored, or a literal string which is compared against for
+the content of the file. Thus::
+
+  # (look for a .hg directory)
+  bzr_control_formats = {"Mercurial":{'.hg/': None}}
+  
+  # (look for a file called .svn/format with contents 4\n).
+  bzr_control_formats = {"Subversion":{'.svn/format': '4\n'}}
+
+
+Example
+-------
+
+An example setup.py follows::
+  
+  #!/usr/bin/env python2.4
+  from distutils.core import setup
+  
+  bzr_plugin_name = 'demo'
+  bzr_commands = [
+      'new-command',
+      ]
+  
+  bzr_branch_formats = {
+      "Branch label on disk\n":"demo branch",
+      }
+
+  bzr_control_formats = {"Subversion":{'.svn/format': '4\n'}}
+  
+  bzr_plugin_version = (1, 3, 0, 'dev', 0)
+  bzr_minimum_version = (1, 0, 0)
+  
+  if __name__ == 'main':
+      setup(name="Demo",
+            version="1.3.0dev0",
+            description="Demo plugin for plugin metadata.",
+            author="Canonical Ltd",
+            author_email="bazaar@lists.canonical.com",
+            license = "GNU GPL v2",
+            url="https://launchpad.net/bzr-demo",
+            packages=['bzrlib.plugins.demo',
+                      'bzrlib.plugins.demo.tests',
+                      ],
+            package_dir={'bzrlib.plugins.demo': '.'})
+
+
+Plugin metadata after installation
+==================================
+
+After a plugin has been installed, metadata can be more easily obtained.
+Currently the only metadata used is for API versioning.
+
+API version
+-----------
+
+Please see `API versioning <api-versioning.html>`_ for details on the API
+metadata protocol used by bzrlib.
+
+
+..
+   vim: ft=rst tw=74 ai
+
+

=== added file 'doc/developers/tortoise-strategy.txt'
--- doc/developers/tortoise-strategy.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/tortoise-strategy.txt	2008-04-09 08:19:38 +0000
@@ -0,0 +1,354 @@
+Bazaar Windows Shell Extension Options
+========================================
+
+.. contents:: :local:
+
+Introduction
+------------
+
+This document details the imlpementation strategy chosen for the
+Bazaar Windows Shell Extensions, otherwise known as TortoiseBzr, or TBZR.
+As justification for the strategy, it also describes the general architecture
+of Windows Shell Extensions, then looks at the C++ implemented TortoiseSvn
+and the Python implemented TortoiseBzr, and discusses alternative
+implementation strategies, and the reasons they were not chosen.
+
+The following points summarize the  strategy.
+
+* Main shell extension code will be implemented in C++, and be as thin as
+  possible.  It will not directly do any VCS work, but instead will perform
+  all operations via either external applications or an RPC server.
+
+* Most VCS operations will be performed by external applications.  For
+  example, committing changes or viewing history will spawn a child
+  process that provides its own UI.
+
+* For operations where spawning a child process is not practical, an
+  external RPC server will be implemented in Python and will directly use
+  the VCS library. In the short term, there will be no attempt to create a
+  general purpose RPC mechanism, but instead will be focused on keeping the
+  C++ RPC client as thin, fast and dumb as possible.
+
+Background Information
+----------------------
+
+The facts about shell extensions
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Well - the facts as I understand them :)
+
+Shell Extensions are COM objects. They are implemented as DLLs which are
+loaded by the Windows shell. There is no facility for shell extensions to
+exist in a separate process - DLLs are the only option, and they are loaded
+into other processes which take advantage of the Windows shell (although
+obviously this DLL is free to do whatever it likes)
+ 
+For the sake of this discussion, there are 2 categories of shell extensions:
+ 
+* Ones that create a new "namespace". The file-system itself is an example of
+  such a namespace, as is the "Recycle Bin". For a user-created example,
+  picture a new tree under "My Computer" which allows you to browse a remote
+  server - it creates a new, stand-alone tree that doesn't really interact
+  with the existing namespaces.
+ 
+* Ones that enhance existing namespaces, including the filesystem. An example
+  would be an extension which uses Icon Overlays to modify how existing files
+  on disk are displayed or add items to their context menu, for example.
+
+The latter category is the kind of shell extension relevant for TortoiseBzr,
+and it has an important implication - it will be pulled into any process
+which uses the shell to display a list of files. While this is somewhat
+obvious for Windows Explorer (which many people consider the shell), every
+other process that shows a FileOpen/FileSave dialog will have these shell
+extensions loaded into its process space. This may surprise many people - the
+simple fact of allowing the user to select a filename will result in an
+unknown number of DLLs being loaded into your process. For a concrete
+example, when notepad.exe first starts with an empty file it is using around
+3.5MB of RAM. As soon as the FileOpen dialog is loaded, TortoiseSvn loads
+well over 20 additional DLLs, including the MSVC8 runtime, into the Notepad
+process causing its memory usage to more than double - all without doing
+anything tortoise specific at all.
+ 
+This has wide-ranging implications. It means that such shell extensions
+should be developed using a tool which can never cause conflict with
+arbitrary processes. For this very reason, MS recommend against using .NET
+to write shell extensions[1], as there is a significant risk of being loaded
+into a process that uses a different version of the .NET runtime, and this
+will kill the process. Similarly, Python implemented shell extension may well
+conflict badly with other Python implemented applications (and will certainly
+kill them in some situations). A similar issue exists with GUI toolkits used
+- using (say) PyGTK directly in the shell extension would need to be avoided
+(which it currently is best I can tell). It should also be obvious the shell
+extension will be in many processes simultaneously, meaning use of a simple
+log-file etc is problematic.
+
+In practice, there is only 1 truly safe option - a low-level language (such
+as C/C++) which makes use of only the win32 API, and a static version of the
+C runtime library if necessary. Obviously, this sucks from our POV :)
+
+[1]: http://blogs.msdn.com/oldnewthing/archive/2006/12/18/1317290.aspx
+
+Analysis of TortoiseSVN code
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+TortoiseSVN is implemented in C++. It relies on an external process to
+perform most UI (such as diff, log, commit etc commands), but it appears to
+directly embed the SVN C libraries for the purposes of obtaining status for
+icon overlays, context menu, drag&drop, etc.
+
+The use of an external process to perform commands is fairly simplistic in
+terms of parent and modal windows - for example, when selecting "Commit", a
+new process starts and *usually* ends up as the foreground window, but it may
+occasionally be lost underneath the window which created it, and the user may
+accidently start many processes when they only need 1. Best I can tell, this
+isn't necessarily a limitation of the approach, just the implementation.
+
+Advantages of using the external process is that it keeps all the UI code
+outside Windows explorer - only the minimum needed to perform operations
+directly needed by the shell are part of the "shell extension" and the rest
+of TortoiseSvn is "just" a fairly large GUI application implementing many
+commands. The command-line to the app has even been documented for people who
+wish to automate tasks using that GUI. This GUI appears to also be
+implemented in C++ using Windows resource files.
+ 
+TortoiseSvn appears to cache using a separate process, aptly named
+TSVNCache.exe. It uses a named pipe to accept connections from other
+processes for various operations. At this stage, it's still unclear exactly
+what is fetched from the cache and exactly what the shell extension fetches
+directly via the subversion C libraries. 
+
+There doesn't seem to be a good story for logging or debugging - which is
+what you expect from C++ based apps :( Most of the heavy lifting is done by
+the external application, which might offer better facilities.
+ 
+Analysis of existing TortoiseBzr code
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+The existing code is actually quite cool given its history (SoC student,
+etc), so this should not be taken as criticism of the implementer nor of the
+implementation - indeed, many criticisms are also true of the TortoiseSvn
+implementation - see above. However, I have attempted to list the bad things
+rather than the good things so a clear future strategy can be agreed, with
+all limitations understood.
+
+The existing TortoiseBzr code has been ported into Python from other tortoise
+implementations (probably svn). This means it is very nice to implement and
+develop, but suffers the problems described above - it is likely to conflict
+with other Python based processes, and it means the entire CPython runtime
+and libraries are pulled into many arbitrary processes.
+
+The existing TortoiseBzr code pulls in the bzrlib library to determine the
+path of the bzr library, and also to determine the status of files, but uses
+an external process for most GUI commands - ie, very similar to TortoiseSvn
+as described above - and as such, all comments above apply equally here - but
+note that the bzr library *is* pulled into the shell, and therefore every
+application using the shell. The GUI in the external application is written
+in PyGTK, which may not offer the best Windows "look and feel", but that
+discussion is beyond the scope of this document.
+ 
+It has a better story for logging and debugging for the developer - but not
+for diagnosing issues in the field - although again, much of the heavy
+lifting remains done by the external application.
+ 
+It uses a rudimentary in-memory cache for the status of files and
+directories, the implementation of which isn't really suitable (ie, no
+theoretical upper bound on cache size), and also means that there is no
+sharing of cached information between processes, which is unfortunate (eg,
+imagine a user using Windows explorer, then switching back to their editor)
+and also error prone (it's possible the editor will check the file in,
+meaning Windows explorer will be showing stale data). This may be possible to
+address via file-system notifications, but a shared cache would be preferred
+(although clearly more difficult to implement)
+
+One tortoise port recently announced a technique for all tortoise ports to
+share the same icon overlays to help work around a limitation in Windows on
+the total number of overlays (its limited to 15, due to the number of bits
+reserved in a 32bit int for overlays). TBZR needs to take advantage of that
+(but to be fair, this overlay sharing technique was probably done after the
+TBZR implementation)
+
+The current code appears to recursively walk a tree to check if *any* file in
+the tree has changed, so it can reflect this in the parent directory status.
+This is almost certainly an evil thing to do (Shell Extensions are optimized
+so that a folder doesn't even need to look in its direct children for another
+folder, let alone recurse for any reason at all. It may be a network mounted
+drive that doesn't perform at all)
+
+Although somewhat dependent on bzr itself, we need a strategy for binary
+releases (ie, it assumes python.exe, etc) and integration into an existing
+"blessed" installer.
+
+Trivially, the code is not PEP8 compliant and was written by someone fairly
+inexperienced with the language.
+
+Detailed Implementation Strategy
+---------------------------------
+
+We will create a hybrid Python and C++ implementation.  In this model, we
+would still use something like TSVNCache.exe (this external
+process doesn't have the same restrictions as the shell extension itself) but
+go one step further - use this remote process for *all* interactions with
+bzr, including status and other "must be fast" operations. This would allow
+the shell extension itself to be implemented in C++, but still take advantage
+of Python for much of the logic.
+
+A pragmatic implementation strategy will be used to work towards the above
+infrastructure - we will keep the shell extension implemented in Python - but
+without using bzrlib. This would allow us to focus on this
+shared-cache/remote-process infrastructure without immediately
+re-implementing a shell extension in C++. Longer term, once the
+infrastructure is in place and as optimized as possible, we can move to C++
+code in the shell calling our remote Python process. This port should try and
+share as much code as possible from TortoiseSvn, including overlay handlers.
+
+External Command Processor
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+The external command application (ie, the app invoked by the shell extension
+to perform commands) can remain as-is, and remain a "shell" for other
+external commands. The implementation of this application is not particularly
+relevant to the shell extension, just the interface to the application (ie,
+its command-line) is. In the short term this will remain PyGTK and will only
+change if there is compelling reason - cross-platform GUI tools are a better
+for bazaar than Windows specific ones, although native look-and-feel is
+important. Either way, this can change independently from the shell
+extension.
+
+Performance considerations
+~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+As discussed above, the model used by Tortoise is that most "interesting"
+things are done by external applications. Most Tortoise implementations
+show read-only columns in the "detail" view, and shows a few read only
+properties in the "Properties" dialog - but most of these properties are
+"state" related (eg, revision number), or editing of others is done by
+launching an external application. This means that the shell extension itself
+really has 2 basic requirements WRT RPC: 1) get the local state of a file and
+2) get some named state-related "properties" for a file. Everything else can
+be built on that.
+
+There are 2 aspects of the shell integration which are performance critical -
+the "icon overlays" and "column providers"
+
+The short-story with Icon Overlays is that we need to register 12 global
+"overlay providers" - one for each state we show. Each provider is called for
+every icon ever shown in Windows explorer or in any application's FileOpen
+dialog. While most versions of Windows update icons in the background, we
+still need to perform well. On the positive side, this just needs the simple
+"local state" of a file - information that can probably be carried in a
+single byte. On the negative side, it is the shell which makes a synchronous
+call to us with a single filename as an arg, which makes it difficult to
+"batch" multiple status requests into a single RPC call.
+
+The story with columns is messier - these have changed significantly for
+Vista and the new system may not work with the VCS model (see below).
+However, if we implement this, it will be fairly critical to have
+high-performance name/value pairs implemented, as described above.
+
+Note that the nature of the shell implementation means we will have a large
+number of "unrelated" handlers, each called somewhat independently by the
+shell, often for information about the same file (eg, imagine each of our
+overlay providers all called in turn with the same filename, followed by our
+column providers called in turn with the same filename. However, that isn't
+exactly what happens!). This means we will need a kind of cache, geared
+towards reducing the number of status or property requests we make to the RPC
+server.
+
+We will also allow all of the above to be disabled via user preferences.
+Thus, Icon Overlays could be disabled if it did cause a problem for some
+people, for example.
+ 
+RPC options
+~~~~~~~~~~~~
+
+Due to the high number of calls for icon overlays, the RPC overhead must be
+kept as low as possible. Due to the client side being implemented in C++,
+reducing complexity is also a goal. Our requirements are quite simple and no
+existing RPC options exist we can leverage. It does not seen prudent to build
+an XMLRPC solution for tbzr - which is not to preclude the use of such a
+server in the future, but tbzr need not become the "pilot" project for an
+XMLRPC server given these constraints.
+
+I propose that a custom RPC mechanism, built initially using windows-specific
+named-pipes, be used. A binary format, designed with an eye towards
+implementation speed and C++ simplicity, will be used. If we succeed here, we
+can build on that infrastructure, and even replace it should other more
+general frameworks materialize.
+
+FWIW, with a Python process at each end, my P4 2.4G machine can achieve
+around 25000 "calls" per-second across an open named pipe. C++ at one end
+should increase this a little, but obviously any real work done by the Python
+side of the process will be the bottle-neck. However, this throughput would
+appear sufficient to implement a prototype.
+
+Vista versus XP
+~~~~~~~~~~~~~~~~
+
+Let's try and avoid an OS advocacy debate :) But it is probably true that
+TBZR will, over its life, be used by more Vista computers than XP ones. In
+short, Vista has changed a number of shell related interfaces, and while TSVN
+is slowly catching up (http://tortoisesvn.net/vistaproblems) they are a pain.
+
+XP has IColumnProvider (as implemented by Tortoise), but Vista changes this
+model. The new model is based around "file types" (eg, .jpg files) and it
+appears each file type can only have 1 provider! TSVN also seems to think the
+Vista model isn't going to work (see previous link). It's not clear how much
+effort we should expend on a column system that has already been abandoned by
+MS. I would argue we spend effort on other parts of the system (ie, the
+external GUI apps themselves, etc) and see if a path forward does emerge for
+Vista. We can re-evaluate this based on user feedback and more information
+about features of the Vista property system.
+ 
+Implementation plan:
+--------------------
+
+The following is a high-level set of milestones for the implementation:
+
+* Design the RPC mechanism used for icon overlays (ie, binary format used for
+  communication)
+
+* Create Python prototype of the C++ "shim": modify the existing TBZR Python
+  code so that all references to "bzrlib" are removed. Implement the client
+  side of the RPC mechanism and implement icon overlays using this RPC
+  mechanism.
+
+* Create initial implementation of RPC server in Python. This will use
+  bzrlib, but will also maintain a local cache to achieve the required
+  performance. The initial implementation may even be single-threaded, just
+  to keep synchronization issues to a minimum.
+
+* Analyze performance of prototype. Verify that technique is feasible and
+  will offer reasonable performance and user experience.
+
+* Implement C++ shim: replace the Python prototype with a light-weight C++
+  version. We would work from the current TSVN sources, including its new
+  support for sharing icon overlays. Advice on if we should "fork" TSVN, or
+  try and manage our own svn based branch in bazaar are invited.
+ 
+* Implement property pages and context menus in C++. Expand RPC server as
+  necessary.
+
+* Create binary for alpha releases, then go round-and-round until its baked.
+
+Alternative Implementation Strategies
+-------------------------------------
+
+Only one credible alternative strategy was identified, as discussed below. No
+languages other than Python and C++ were considered; Python as the bzr
+library and existing extensions are written in Python and otherwise only C++
+for reasons outlined in the background on shell extensions above.
+
+Implement Completely in Python
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+This would keep the basic structure of the existing TBZR code, with the
+shell extension continuing to pull in Python and all libraries used by Bzr
+into various processes.
+
+Although implementation simplicity is a key benefit to this option, it was
+not chosen for various reasons; The use of Python means that there is a
+larger chance of conflicting with existing applications, or even existing
+Python implemented shell extensions. It will also increase the memory usage
+of all applications which use the shell. While this may create problems for a
+small number of users, it may create a wider perception of instability or
+resource hogging.

=== modified file 'doc/en/user-guide/controlling_registration.txt'
--- doc/en/user-guide/controlling_registration.txt	2008-01-12 00:20:20 +0000
+++ doc/en/user-guide/controlling_registration.txt	2008-04-10 00:53:43 +0000
@@ -73,10 +73,10 @@
     config.h                 ./config.h
     configure.in~            *~
 
-It is OK to have either an ignore pattern match a versioned file, or to
-add an ignored file.  Ignore patterns have no effect on versioned files;
-they only determine whether unversioned files are reported as unknown or
-ignored.
+Note that ignore patterns are only matched against non-versioned files,
+and control whether they are treated as "unknown" or "ignored".  If a file
+is explicitly added, it remains versioned regardless of whether it matches
+an ignore pattern.
 
 The ``.bzrignore`` file should normally be versioned, so that new copies
 of the branch see the same patterns::

